﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace QSFP_DD_LPBK
{
    class ConnectionManager
    {
        public Wrapper wrapper;
        //MPResult result;
        UInt16 tempValue;
        byte slaveAddress = 0xA0;
        public byte target;
        byte[] ReadBuff = new byte[32];
        public UInt16 conUSBinstance = 0;

        public ConnectionManager()
        {
            wrapper = new Wrapper();
        }

        public bool IsConnected(UInt16 ClassInstance)
        {
            return wrapper.IsConnected(ClassInstance);
        }

        /// <summary>
        /// Get/Set Slave Address
        /// </summary>
        public byte SetSlaveAddress
        {
            get
            {
                return slaveAddress;
            }
            set
            {
                slaveAddress = value;
            }
        }

        public byte SetTarget
        {

            get
            {
                return target;
            }

            set
            {
                target = value;
            }
        }

        /// <summary>
        /// Connect to the HW
        /// </summary>
        /// <returns></returns>
        public bool Connect(UInt16 Instance, string IP, int port)
        {
            if (wrapper.OpenUSBPort(Instance, IP, port))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        //public bool Ping(UInt16 instance, ref FWInfo PingInfo)
        //{
        //    return wrapper.Ping(instance, ref PingInfo) == MPResult.MPUSB_SUCCES ? true : false;
        //}
        //public bool SetDeviceID(UInt16 instance, byte D_ID)
        //{
        //    return wrapper.SetDeviceID(instance, D_ID) == MPResult.MPUSB_SUCCES ? true : false;
        //}
        //public int GetDeviceCount()
        //{
        //    return (int)wrapper.GetDeviceCount();
        //}
        /// <summary>
        /// Disconnect form the HW
        /// </summary>
        /// <returns></returns>
        public bool Disconnect(UInt16 Instance)
        {
            if (wrapper.CloseUSBPort(Instance))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        //public bool IsConnected(int Instance)
        //{
        //    return wrapper.IsConnected;
        //}

        public int ReadBoardID(UInt16 Instance)
        {
            ushort data = 0;
            wrapper.AccessBoardRegister(Instance, 0, 0, 0x14, ref data);
            return (int)data;
        }


        public string About()
        {
            return wrapper.About();
        }

        public UInt16 GetRev()
        {
            return wrapper.GetAPIRev();
        }

        /// <summary>
        /// Set Port
        /// </summary>
        /// <param name="port">port Address</param>
        /// <param name="value">port value</param>
        /// <returns></returns>
        public bool SetPort(UInt16 Instance, byte port, UInt16 value)
        {
            if (wrapper.SetPort(Instance, port, value) == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Get Port Value
        /// </summary>
        /// <param name="port">Specify the Port Value</param>
        /// <returns></returns>
        public UInt16 GetPort(UInt16 Instance, byte port)
        {
            if (wrapper.GetPort(Instance, (byte)port, ref tempValue) == true)
            {
                return tempValue;
            }
            else
            {
                return 8;
            }
        }

        /// <summary>
        /// Read I2C
        /// </summary>
        /// <param name="registerAdress">Address  to read from</param>
        /// <returns></returns>
        public byte[] I2CRead(UInt16 Instance, int registerAdress)
        {
            if (wrapper.I2C_Read(Instance, target, slaveAddress, (byte)registerAdress, ref ReadBuff) == true)
            {
                return (byte[])ReadBuff.Clone();
            }
            else
            {
                return new byte[32];
            }
        }
        /// <summary>
        /// Read I2C
        /// </summary>
        /// <param name="registerAdress"></param>
        /// <param name="ReadBuff"></param>
        /// <returns></returns>
        public byte[] I2CReadd(UInt16 Instance, int registerAdress, ref byte[] ReadBfr)
        {
            ReadBfr = new byte[32];
            if (wrapper.I2C_Read(Instance, target, slaveAddress, (byte)registerAdress, ref ReadBfr) == true)
            {
                return (byte[])ReadBfr.Clone();
            }
            else
            {
                return new byte[32];
            }
        }

        /// <summary>
        /// Write I2C 
        /// </summary>
        /// <param name="registerAdress">address</param>
        /// <param name="registerValue">data to be written</param>
        /// <returns></returns>
        public bool I2CWrite(UInt16 Instance, int registerAdress, int registerValue)
        {
            if (wrapper.I2C_write(Instance, target, slaveAddress, (byte)registerAdress, (byte)registerValue) == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        #region AOC

        //public bool SetPE(int instance, byte SlaveAdd, byte Val)
        //{
        //    return wrapper.SetPE(instance, SlaveAdd, Val) == MPResult.MPUSB_SUCCES ? true : false;
        //}

        //public bool GetPE(int instance, byte SlaveAdd, ref byte Val)
        //{
        //    return wrapper.GetPE(instance, SlaveAdd, ref Val) == MPResult.MPUSB_SUCCES ? true : false;
        //}

        public bool EEPROM_Write(int instance, byte block, byte Address, byte Data)
        {
            return wrapper.EEPROM_Write(instance, block, Address, Data) == true ? true : false;
        }

        public bool EEPROM_Read(int instance, byte block, byte Address, ref byte Data)
        {
            return wrapper.EEPROM_Read(instance, block, Address, ref Data) == true ? true : false;
        }

        //ADC
        //public bool GetIntADC(int instance, byte ADCchannel, ref byte receive_buffer)
        //{
        //    return wrapper.GetIntADC(instance, ADCchannel, ref receive_buffer) == MPResult.MPUSB_SUCCES ? true : false;
        //}

        //power
        public bool SetPower(int instance, byte rate)
        {
            return wrapper.SetPower(instance, target, rate) == true ? true : false;
        }

        //public bool SetFan_ON_OFF(int instance, byte Enable)
        //{
        //    return wrapper.SetFan_ON_OFF(instance, Enable) == MPResult.MPUSB_SUCCES ? true : false;
        //}

        //public bool Set_PWM(int instance, byte channel, byte value)
        //{
        //    return wrapper.Set_PWM(instance, channel, value) == MPResult.MPUSB_SUCCES ? true : false;
        //}

        //analog

        public bool GetCurrent_sens(int instance, ref double Data)
        {
            return wrapper.GetCurrent_sens(instance, target, ref Data) == true ? true : false;
        }


        public bool GetCurrent_sens_VCC1(int instance, ref double Data)
        {
            return wrapper.GetCurrent_sens_VCC1(instance, target, ref Data) == true ? true : false;
        }


        public bool GetCurrent_sens_VCCTX(int instance, ref double Data)
        {
            return wrapper.GetCurrent_sens_VCCTX(instance, target, ref Data) == true ? true : false;
        }

        public bool GetCurrent_sens_VCCRX(int instance, ref double Data)
        {
            return wrapper.GetCurrent_sens_VCCRX(instance, target, ref Data) == true ? true : false;
        }

        public bool Get_VCC(int instance, ref double Data)
        {
            return wrapper.Get_VCC(instance, target, ref Data) == true ? true : false;
        }
        public bool Get_VCC1(int instance, ref double Data)
        {
            return wrapper.Get_VCC1(instance, target, ref Data) == true ? true : false;
        }
        public bool Get_VCCTX(int instance, ref double Data)
        {
            return wrapper.Get_VCCTX(instance, target, ref Data) == true ? true : false;
        }

        public bool Get_VCCRX(int instance, ref double Data)
        {
            return wrapper.Get_VCCRX(instance, target, ref Data) == true ? true : false;
        }

        public bool Get_temperature(int instance, ref double Data)
        {
            return wrapper.Get_temperature(instance, target, ref Data) == true ? true : false;
        }

        public bool Set_Module_VCC(int instance, float voltage)
        {
            return wrapper.Set_Module_VCC(instance, target, voltage) == true ? true : false;
        }

        public bool Set_VCC_noise_amplitude(int instance, byte amplitude)
        {
            return wrapper.Set_VCC_noise_amplitude(instance, target, amplitude) == true ? true : false;
        }
        public bool Set_VCC_noise_frequency(int instance, Int32 frequency)
        {
            return wrapper.Set_VCC_noise_frequency(instance, target, frequency) == true ? true : false;
        }
        #endregion


    }
}
