﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace QSFP_DD_LPBK
{

    public enum BITS : uint
    {
        BIT0 = 0x000001,
        BIT1 = 0x000002,
        BIT2 = 0x000004,
        BIT3 = 0x000008,
        BIT4 = 0x000010,
        BIT5 = 0x000020,
        BIT6 = 0x000040,
        BIT7 = 0x000080,
        BIT8 = 0x000100,
        BIT9 = 0x000200,
        BIT10 = 0x000400,
        BIT11 = 0x000800,
        BIT12 = 0x001000,
        BIT13 = 0x002000,
        BIT14 = 0x004000,
        BIT15 = 0x008000,
        BIT16 = 0x00010000,
        BIT17 = 0x00020000,
        BIT18 = 0x00040000,
        BIT19 = 0x00080000,
        BIT20 = 0x00100000,
        BIT21 = 0x00200000,
        BIT22 = 0x00400000,
        BIT23 = 0x00800000,
        BIT24 = 0x01000000,
        BIT25 = 0x02000000,
        BIT26 = 0x04000000,
        BIT27 = 0x08000000,
        BIT28 = 0x10000000,
        BIT29 = 0x20000000,
        BIT30 = 0x40000000,
        BIT31 = 0x80000000
    }

    public enum Identifier : byte
    {
        UNKOWN = 0x00,
        GBIC = 0x01,
        MODULE_SOLDERED = 0x02,
        SFP = 0x03,
        XB1_300 = 0x04,
        XENPAK = 0x05,
        XFP = 0x06,
        XFF = 0x07,
        XFP_E = 0x08,
        XPAK = 0x09,
        X2 = 0x0A,
        DWDM_SFP = 0x0B,
        QSFP = 0x0C,
        QSFP_Plus = 0x0D,
        CXP = 0x0E,
        HD_4X = 0x0F,
        HD_8X = 0x10,
        QSFP_28 = 0x11,
        CXP_28 = 0x12,
        CDFP_Style_1_2 = 0x13,
        HD_4X_Fanout = 0x14,
        HD_8X_Fanout = 0x15,
        CDFP_Style_3 = 0x16,
        microQSFP = 0x17,
        QSFP_DD = 0x18,
        RESERVED = 0x0E,
        VENDOR_SPECIFIC = 0x80,
    }

    public enum Connector : byte
    {
        Unknown = 0x00,
        SC = 0x01,
        FC_Style_1 = 0x02,
        FC_Style_2 = 0x03,
        BNC_TNC = 0x04,
        FC_coax_headers = 0x05,
        Fiberjack = 0x06,
        LC = 0x07,
        MT_RJ = 0x08,
        MU = 0x09,
        SG = 0x0A,
        Optical_Pigtail = 0x0B,
        MPO_1x12 = 0x0C,
        MPO_2x16 = 0x0D,
        Reserved = 0x0E,
        HSSDC_II = 0x20,
        Copper_pigtail = 0x21,
        RJ45 = 0x22,
        No_separable_connector = 0x23,
        MXC_2x16 = 0x24,
        Vendor_specific = 0x80,
    }

    public enum DeviceTechnology : byte
    {
        VCSEL_850nm = 0x00,
        VCSEL_1310nm = 0x01,
        VCSEL_1550nm = 0x02,
        FP_1310nm = 0x03,
        DFB_1310nm = 0x04,
        DFB_1550nm = 0x05,
        EML_1310nm = 0x06,
        EML_1550nm = 0x07,
        Copper_or_others = 0x08,
        DFB_1490nm = 0x09,
        Copper_Cable_Unequalized = 0x0A,
        Copper_Cable_Passive_Equalized = 0x0B,
        Copper_Cable_near_and_far_end_equalizers = 0x0C,
        Copper_Cable_far_end_equalizers = 0x0D,
        Copper_Cables_near_end_equalizer = 0x0E,
        PAM4 = 0x0F,
    }

    public enum EncodingValues : byte
    {
        Unspecified = 0x00,
        _8B10B = 0x01,
        _4B5B = 0x02,
        NRZ = 0x03,
        SONET_Scrambled = 0x04,
        _64B66B = 0x05,
        Manchester = 0x06,
        _256B_257B = 0x07,
        PAM4 = 0x08,
        Reserved = 0x09,
    }
    public enum ExtendedEthernet : byte
    {
        Unspecified = 0x00,
        _100G_AOC = 0x01,
        _100GBASE_SR4 = 0x02,
        _100GBASE_LR4 = 0x03,
        _100GBASE_ER4 = 0x04,
        _100GBASE_SR10 = 0x05,
        _100G_CWDM4_Coarse_WDM_SMF = 0x06,
        _100G_PSM4_Parallel_SMF = 0x07,
        _40GBASE_ER4 = 0x08,
        Reserved = 0x09,
    }
}
