﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;
using System.Diagnostics;

namespace QSFP_DD_LPBK
{


    #region "Enumeratios"
    public enum MPResult
    {
        MPUSB_FAIL = 0,
        MPUSB_SUCCES = 1,
        MPUSB_SUCCESS_LESS_DATA = 2
    }
    #endregion


    #region "Structures"
    public struct FWInfo
    {
        public int FWDeviceID;
        public int FWRev;
        public string DateAndTime;
    }

    #endregion

    public class Wrapper
    {


        #region "Memebers"

        private static bool printAPIMessage = true;
        public bool PrintAPIMessage
        {
            get
            {
                return printAPIMessage;
            }
            set
            {
                printAPIMessage = value;
            }
        }

        private string apiMsg;
        public string APIMsg
        {
            get
            {
                return apiMsg;
            }
            set
            {
                apiMsg = value;
            }
        }

        //private bool isConnected;
        public bool[] isConnected;

        public bool IsConnected(UInt16 ClassInstance)
        {
            try
            {
                return isConnected[ClassInstance];
            }
            catch (Exception)
            {
                return false;
            }
        }

        #endregion

        //#region "DLL Imports USB"

        //////////////////////////USB API///////////////////////////////
        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "OpenUSBPort")]
        //private static extern MPResult apiOpenUSBPort(UInt16 Instance);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "CloseUSBPort")]
        //private static extern bool apiCloseUSBPort(UInt16 Instance);

        ////////////////////////L1 API//////////////////////////////////

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "About")]
        //private static extern void apiAbout();

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "GetDeviceCount")]
        //private static extern UInt32 apiGetDeviceCount();

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Ping")]
        //private static extern MPResult apiPing(UInt16 Instance, byte[] inBuff);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Reset_MCU")]
        //private static extern MPResult apiReset_MCU(UInt16 Instance);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Reset_MCU_Boot")]
        //private static extern MPResult apiReset_MCU_Boot(UInt16 Instance);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "SetDeviceID")]
        //private static extern MPResult apiSetDeviceID(UInt16 Instance, byte D_ID);

        /////////////////////////////////Direct IO API//////////////////////////////

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "SetPort")]
        //private static extern MPResult apiSetPort(UInt16 Instance, byte t_Port, byte Val);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "GetPort")]
        //private static extern MPResult apiGetPort(UInt16 Instance, byte t_Port, ref byte inBuff);

        //////////////////////////////////I2C API/////////////////////////////////

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "I2C_Write")]
        //private static extern MPResult apiI2C_Write(UInt16 Instance, byte SlaveAddress, byte[] DtBuff, byte Length, byte I2CStart, byte I2CStop);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "I2C_Read")]
        //private static extern MPResult apiI2C_Read(UInt16 Instance, byte SlaveAddress, byte Length, byte[] DtBuff, byte I2CStart, byte I2CStop);

        //[DllImport("ML4062MCB.dll", EntryPoint = "I2C_Config")]
        //private static extern MPResult apiI2C_Config(UInt16 Instance, I2CRate R);*/

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "SetPE")]
        //private static extern MPResult apiSetPE(int Instance, byte SlaveAdd, byte Val);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "GetPE")]
        //private static extern MPResult apiGetPE(int Instance, byte SlaveAdd, ref byte Val);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "EEPROM_Write")]
        //private static extern MPResult apiEEPROM_Write(int Instance, byte block, byte Address, byte Data);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "EEPROM_Read")]
        //private static extern MPResult apiEEPROM_Read(int Instance, byte block, byte Address, ref byte Data);

        ////ADC
        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "GetIntADC")]
        //private static extern MPResult apiGetIntADC(int Instance, byte ADCchannel, ref byte receive_buffer);

        ////power
        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "SetPower")]
        //private static extern MPResult apiSetPower(int Instance, byte rate);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "SetFan_ON_OFF")]
        //private static extern MPResult apiSetFan_ON_OFF(int Instance, byte Enable);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Set_PWM")]
        //private static extern MPResult apiSet_PWM(int Instance, byte channel, byte value);

        ////analog

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "GetCurrent_sens")]
        //private static extern MPResult apiGetCurrent_sens(int Instance, ushort Address, ref double Data);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Get_VCC")]
        //private static extern MPResult apiGet_VCC(int Instance, ref double Data);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Get_VCC1")]
        //private static extern MPResult apiGet_VCC1(int Instance, ref double Data);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Get_VCCTX")]
        //private static extern MPResult apiGet_VCCTX(int Instance, ref double Data);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Get_VCCRX")]
        //private static extern MPResult apiGet_VCCRX(int Instance, ref double Data);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Get_temperature")]
        //private static extern MPResult apiGet_temperature(int Instance, ref double Data);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Set_Module_VCC")]
        //private static extern MPResult apiSet_Module_VCC(int Instance, float voltage);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Set_VCC_noise_amplitude")]
        //private static extern MPResult apiSet_VCC_noise_amplitude(int Instance, byte amplitude);

        //[DllImport("Dll\\ML4062MCB.dll", EntryPoint = "Set_VCC_noise_frequency")]
        //private static extern MPResult apiSet_VCC_noise_frequency(int Instance, Int32 frequency);

        //#endregion

        #region "DLL Imports ETH"

        ////////////////////////USB API///////////////////////////////
        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Connect")]
        private static extern bool E_apiOpenUSBPort(UInt16 Instance, string IP, int Port);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Disconnect")]
        private static extern bool E_apiCloseUSBPort(UInt16 Instance);

        //////////////////////L1 API//////////////////////////////////

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "About")]
        private static extern void E_apiAbout();

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetAPIRev")]
        private static extern UInt16 E_apiGetAPIRev();

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Ping")]
        //private static extern MPResult apiPing(UInt16 Instance, byte[] inBuff);

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Reset_MCU")]
        //private static extern MPResult apiReset_MCU(UInt16 Instance);

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Reset_MCU_Boot")]
        //private static extern MPResult apiReset_MCU_Boot(UInt16 Instance);

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "SetDeviceID")]
        //private static extern MPResult apiSetDeviceID(UInt16 Instance, byte D_ID);

        ///////////////////////////////Direct IO API//////////////////////////////

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "SetPort")]
        private static extern bool E_apiSetPort(UInt16 Instance, byte t_Port, UInt16 Val);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetPort")]
        private static extern bool E_apiGetPort(UInt16 Instance, byte t_Port, ref UInt16 inBuff);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "AccessBoardRegister")]
        public static extern bool E_piAccessBoardRegister(UInt16 instance, byte Read_Write, ushort Index, ushort Reg, ref ushort Data);

        ////////////////////////////////I2C API/////////////////////////////////

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "I2C_Write")]
        private static extern bool E_apiI2C_Write(UInt16 Instance, byte target, byte SlaveAddress, byte[] DtBuff, byte Length, byte I2CStart, byte I2CStop);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "I2C_Read")]
        private static extern bool E_apiI2C_Read(UInt16 Instance, byte target, byte SlaveAddress, byte Length, byte[] DtBuff, byte I2CStart, byte I2CStop);

        /*[DllImport("ML4062MCB.dll", EntryPoint = "I2C_Config")]
        private static extern MPResult apiI2C_Config(UInt16 Instance, I2CRate R);*/

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "SetPE")]
        //private static extern MPResult apiSetPE(int Instance, byte SlaveAdd, byte Val);

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetPE")]
        //private static extern MPResult apiGetPE(int Instance, byte SlaveAdd, ref byte Val);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "EEPROM_Write")]
        private static extern bool E_apiEEPROM_Write(int Instance, byte block, byte Address, byte Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "EEPROM_Read")]
        private static extern bool E_apiEEPROM_Read(int Instance, byte block, byte Address, ref byte Data);

        ////ADC
        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetIntADC")]
        //private static extern MPResult apiGetIntADC(int Instance, byte ADCchannel, ref byte receive_buffer);

        //power
        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "SetPower")]
        private static extern bool E_apiSetPower(int Instance, byte target, byte rate);

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "SetFan_ON_OFF")]
        //private static extern bool E_apiSetFan_ON_OFF(int Instance, byte Enable);

        //[DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Set_PWM")]
        //private static extern bool E_apiSet_PWM(int Instance, byte channel, byte value);

        //analog

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetCurrent_sens")]
        private static extern bool E_apiGetCurrent_sens(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetCurrent_sens_VCC1")]
        private static extern bool E_apiGetCurrent_sens_VCC1(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetCurrent_sens_VCCTX")]
        private static extern bool E_apiGetCurrent_sens_VCCTX(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "GetCurrent_sens_VCCRX")]
        private static extern bool E_apiGetCurrent_sens_VCCRX(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Get_VCC")]
        private static extern bool E_apiGet_VCC(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Get_VCC1")]
        private static extern bool E_apiGet_VCC1(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Get_VCCTX")]
        private static extern bool E_apiGet_VCCTX(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Get_VCCRX")]
        private static extern bool E_apiGet_VCCRX(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Get_temperature")]
        private static extern bool E_apiGet_temperature(int Instance, byte target, ref double Data);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Set_Module_VCC")]
        private static extern bool E_apiSet_Module_VCC(int Instance, byte target, float voltage);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Set_VCC_noise_amplitude")]
        private static extern bool E_apiSet_VCC_noise_amplitude(int Instance, byte target, UInt16 amplitude);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "Set_VCC_noise_frequency")]
        private static extern bool E_apiSet_VCC_noise_frequency(int Instance, byte target, Int32 frequency);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "ChangeIPConfiguration")]
        private static extern bool apiChangeIPConfiguration(int instance, StringBuilder IP);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "SetEthIPMask")]
        private static extern bool apiSetEthIPMask(int instance, StringBuilder ipMask);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "SetEthIPGateway")]
        private static extern bool apiSetEthIPGateway(int instance, StringBuilder ipGateway);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "readIPConfiguration")]
        private static extern bool apireadIPConfiguration(int instance, StringBuilder myString);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "readIPMask")]
        private static extern bool apireadIPMask(int instance, StringBuilder IPMask);

        [DllImport("Dll\\ML4062-MCB-LPBK.dll", EntryPoint = "readGateway")]
        private static extern bool apireadGateway(int instance, StringBuilder IPGateway);


        #endregion

        #region "USB Connection"

        public bool OpenUSBPort(UInt16 ClassInstance, string IP, int port)
        {

            //if (QSFPuserGUI.MainWindow.autolog == true)
            //{
            //    QSFPuserGUI.MainWindow.sw.WriteLine("OpenUSBPort()");
            //    QSFPuserGUI.MainWindow.sw.Flush();
            //}
            bool rc;
            rc = E_apiOpenUSBPort(ClassInstance, IP, port);

            return rc;
        }

        public bool CloseUSBPort(UInt16 ClassInstance)
        {
            //if (QSFPuserGUI.MainWindow.autolog)
            //{
            //    QSFPuserGUI.MainWindow.sw.WriteLine("CloseUSBPort()");
            //    QSFPuserGUI.MainWindow.sw.Flush();
            //}
            bool oK;
            oK = E_apiCloseUSBPort(ClassInstance);

            if (!oK)
            {
                return false;
            }
            else
            {
                return true;
            }
        }
        public UInt16 GetAPIRev()
        {
            UInt16 rev = E_apiGetAPIRev();
            return rev;
        }
        #endregion

        //#region "L1"

        //UInt32 devicesChange = 0;
        ////public UInt32 GetDeviceCount()
        ////{
        ////    //if (QSFPuserGUI.MainWindow.autolog)
        ////    //{
        ////    //    QSFPuserGUI.MainWindow.sw.WriteLine("GetDeviceCount()");
        ////    //    QSFPuserGUI.MainWindow.sw.Flush();
        ////    //}
        ////    UInt32 devices = apiGetDeviceCount();
        ////    if (devices != devicesChange)
        ////    {
        ////        isConnected = new bool[devices];
        ////        devicesChange = devices;
        ////    }
        ////    return devices;
        ////}


        //public MPResult Ping(UInt16 ClassInstance, ref FWInfo PingInfo)
        //{
        //    //if (QSFPuserGUI.MainWindow.autolog)
        //    //{
        //    //    QSFPuserGUI.MainWindow.sw.WriteLine("Ping(" + PingInfo + ")");
        //    //    QSFPuserGUI.MainWindow.sw.Flush();
        //    //}

        //    MPResult rc = MPResult.MPUSB_FAIL;

        //    try
        //    {
        //        byte[] inBuff = new byte[25];
        //        rc = apiPing(ClassInstance, inBuff);
        //        if (rc == MPResult.MPUSB_SUCCES)
        //        {
        //            PingInfo.FWDeviceID = inBuff[0];
        //            PingInfo.FWRev = inBuff[1];
        //            for (int i = 2; i < 21; i++)
        //            {
        //                PingInfo.DateAndTime += (char)inBuff[i];
        //            }
        //        }
        //    }

        //    catch
        //    {
        //        //if (QSFPuserGUI.MainWindow.autolog)
        //        //{
        //        //    QSFPuserGUI.MainWindow.sw.WriteLine("Line = " + ex.StackTrace + " Message = " + ex.Message);
        //        //    QSFPuserGUI.MainWindow.sw.Flush();
        //        //    return MPResult.MPUSB_FAIL;
        //        //}
        //    }
        //    return rc;
        //}

        //public MPResult Reset_MCU_Boot(UInt16 ClassInstance)
        //{
        //    //if (QSFPuserGUI.MainWindow.autolog)
        //    //{
        //    //    QSFPuserGUI.MainWindow.sw.WriteLine("Reset_MCU_Boot()");
        //    //    QSFPuserGUI.MainWindow.sw.Flush();
        //    //}
        //    return apiReset_MCU_Boot(ClassInstance);
        //}


        //public MPResult Reset_MCU(UInt16 ClassInstance)
        //{
        //    //if (QSFPuserGUI.MainWindow.autolog)
        //    //{
        //    //    QSFPuserGUI.MainWindow.sw.WriteLine("Reset_MCU()");
        //    //    QSFPuserGUI.MainWindow.sw.Flush();
        //    //}
        //    return apiReset_MCU(ClassInstance);
        //}

        //public MPResult SetDeviceID(UInt16 ClassInstance, byte D_ID)
        //{
        //    //if (QSFPuserGUI.MainWindow.autolog)
        //    //{
        //    //    QSFPuserGUI.MainWindow.sw.WriteLine("SetDeviceID(" + D_ID + ")");
        //    //    QSFPuserGUI.MainWindow.sw.Flush();
        //    //}
        //    return apiSetDeviceID(ClassInstance, D_ID);
        //}

        //#endregion

        #region "Direct IO"

        public bool AccessBoardRegister(UInt16 instance, byte Read_Write, ushort Index, ushort Reg, ref ushort Data)
        {
            return E_piAccessBoardRegister(instance, Read_Write,  Index,  Reg, ref Data);
        }





        public bool SetPort(UInt16 ClassInstance, byte t_port, UInt16 val)
        {
            //if (QSFPuserGUI.MainWindow.autolog)
            //{
            //    QSFPuserGUI.MainWindow.sw.WriteLine("SetPort(" + t_port + "," + val + ")");
            //    QSFPuserGUI.MainWindow.sw.Flush();
            //}
            return E_apiSetPort(ClassInstance, t_port, val);
        }

        public bool GetPort(UInt16 ClassInstance, byte t_port, ref UInt16 val)
        {
            //if (QSFPuserGUI.MainWindow.autolog)
            //{
            //    QSFPuserGUI.MainWindow.sw.WriteLine("GetPort(" + t_port + "," + val + ")");
            //    QSFPuserGUI.MainWindow.sw.Flush();
            //}
            return E_apiGetPort(ClassInstance, t_port, ref val);
        }

        #endregion

        #region "I2C"

        public bool I2C_write(UInt16 ClassInstance, byte target, byte SlaveAddress, byte Register, byte Val)//write one byte at a time
        {

            //if (QSFPuserGUI.MainWindow.autolog)
            //{
            //    QSFPuserGUI.MainWindow.sw.WriteLine("I2C_write(" + SlaveAddress + "," + Register + "," + Val + ")");
            //    QSFPuserGUI.MainWindow.sw.Flush();
            //}
            bool rc;
            byte[] DtBuff = new byte[2];
            DtBuff[0] = Register;
            DtBuff[1] = Val;
            rc = E_apiI2C_Write(ClassInstance, target, SlaveAddress, DtBuff, (byte)DtBuff.Length, 1, 1);// write the register address and the value to be written in that address
            Thread.Sleep(5);
            return rc;
        }

        public bool I2C_Read(UInt16 ClassInstance, byte target, byte SlaveAddress, byte registerAddress, ref byte[] ReadBuff)// read 32 byte/packet
        {

            //if (QSFPuserGUI.MainWindow.autolog)
            //{
            //    QSFPuserGUI.MainWindow.sw.WriteLine("I2C_Read(" + SlaveAddress + "," + registerAddress + "," + ReadBuff + ")");
            //    QSFPuserGUI.MainWindow.sw.Flush();
            //}
            bool rc;
            byte[] WriteBuff = new byte[32];
            WriteBuff[0] = registerAddress;
            rc = E_apiI2C_Write(ClassInstance, target, SlaveAddress, WriteBuff, 1, 1, 0);// write the register address we want to read from 
            rc = E_apiI2C_Read(ClassInstance, target, SlaveAddress, (byte)(ReadBuff.Length), ReadBuff, 1, 1);
            Thread.Sleep(5);
            return rc;
        }

        #endregion

        public string About()
        {
            E_apiAbout();
            return "";
        }

        #region AOC

        //public bool SetPE(int Instance, byte SlaveAdd, byte Val)
        //{
        //    return apiSetPE(Instance, SlaveAdd, Val);
        //}

        //public bool GetPE(int Instance, byte SlaveAdd, ref byte Val)
        //{
        //    return apiGetPE(Instance, SlaveAdd, ref Val);
        //}

        public bool EEPROM_Write(int Instance, byte block, byte Address, byte Data)
        {
            return E_apiEEPROM_Write(Instance, block, Address, Data);
        }

        public bool EEPROM_Read(int Instance, byte block, byte Address, ref byte Data)
        {
            return E_apiEEPROM_Read(Instance, block, Address, ref Data);
        }

        ////ADC
        //public MPResult GetIntADC(int Instance, byte ADCchannel, ref byte receive_buffer)
        //{
        //    return E_apiGetIntADC(Instance, ADCchannel, ref receive_buffer);
        //}

        //power
        public bool SetPower(int Instance, byte target, byte rate)
        {
            return E_apiSetPower(Instance, target, rate);
        }

        //public MPResult SetFan_ON_OFF(int Instance, byte target,byte Enable)
        //{
        //    return apiSetFan_ON_OFF(Instance,target, Enable);
        //}

        //public MPResult Set_PWM(int Instance, byte channel, byte value)
        //{
        //    return apiSet_PWM(Instance, channel, value);
        //}

        //analog

        public bool GetCurrent_sens(int Instance, byte target, ref double Data)
        {
            return E_apiGetCurrent_sens(Instance, target, ref Data);
        }

        public bool GetCurrent_sens_VCC1(int Instance, byte target, ref double Data)
        {
            return E_apiGetCurrent_sens_VCC1(Instance, target, ref Data);
        }

        public bool GetCurrent_sens_VCCTX(int Instance, byte target, ref double Data)
        {
            return E_apiGetCurrent_sens_VCCTX(Instance, target, ref Data);
        }

        public bool GetCurrent_sens_VCCRX(int Instance, byte target, ref double Data)
        {
            return E_apiGetCurrent_sens_VCCRX(Instance, target, ref Data);
        }

        public bool Get_VCC(int Instance, byte target, ref double Data)
        {
            return E_apiGet_VCC(Instance, target, ref Data);
        }
        public bool Get_VCC1(int Instance, byte target, ref double Data)
        {
            return E_apiGet_VCC1(Instance, target, ref Data);
        }

        public bool Get_VCCTX(int Instance, byte target, ref double Data)
        {
            return E_apiGet_VCCTX(Instance, target, ref Data);
        }

        public bool Get_VCCRX(int Instance, byte target, ref double Data)
        {
            //return MPResult.MPUSB_SUCCES;
            return E_apiGet_VCCRX(Instance, target, ref Data);
        }

        public bool Get_temperature(int Instance, byte target, ref double Data)
        {
            return E_apiGet_temperature(Instance, target, ref Data);
        }
        public bool Set_Module_VCC(int Instance, byte target, float voltage)
        {
            return E_apiSet_Module_VCC(Instance, target, voltage);
        }

        public bool Set_VCC_noise_amplitude(int Instance, byte target, byte amplitude)
        {
            return E_apiSet_VCC_noise_amplitude(Instance, target, (UInt16)amplitude);
        }

        public bool Set_VCC_noise_frequency(int Instance, byte target, Int32 Frequency)
        {
            return E_apiSet_VCC_noise_frequency(Instance, target, Frequency);
        }
        #endregion

        #region IPChanger
        public TraceSource ts;
        public TextWriterTraceListener tr;
        public int expectionCounter;
        public void exceptionLog(Exception ex)
        {
            tr.WriteLine(DateTime.Now.ToString() + " > " + ex.ToString());
            tr.WriteLine("-------------------------------------------------------");
            tr.Flush();
            expectionCounter++;
        }

        public void exceptionLog(UnhandledExceptionEventArgs ex)
        {
            tr.WriteLine("Unhandled Exception:");
            tr.WriteLine(DateTime.Now.ToString() + " > " + ex.ExceptionObject.ToString());
            tr.WriteLine("-------------------------------------------------------");
            tr.Flush();
            expectionCounter++;
        }

        public bool ChangeIPConfiguration(int Instance,string IP)
        {
            StringBuilder ip = new StringBuilder(100);
            ip.Append(IP);
            return apiChangeIPConfiguration(Instance, ip);
        }

        public bool readIPConfiguration(int Instance,ref string IP)
        {
            StringBuilder str = new StringBuilder(100);
           
            apireadIPConfiguration(Instance, str);
            IP = str.ToString();
            return true;
           
        }

        public bool SetEthIPMask(int Instance, string ipMask)
        {
            StringBuilder str = new StringBuilder(100);
            str.Append(ipMask);
            return apiSetEthIPMask(Instance, str);
        }

        public bool readIPMask(int Instance, ref string IPMask)
        {
            StringBuilder str = new StringBuilder(100);
            apireadIPMask(Instance, str);
            IPMask = str.ToString();
            return true;
        }

        public bool SetEthIPGateway(int Instance, string ipGateway)
        {
            StringBuilder str = new StringBuilder(100);
            str.Append(ipGateway);
            return apiSetEthIPGateway(Instance, str);
        }

        public bool readGateway(int Instance, ref string IPGateway)
        {
            StringBuilder str = new StringBuilder(100);
            apireadGateway(Instance, str);
            IPGateway = str.ToString();
            return true;
        }

        #endregion 
    }
}
