﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using System.Windows.Threading;
using System.IO;
using System.Data;
using System.Globalization;

namespace QSFP_DD_LPBK
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MSAManager msaManager;
        IPConfiguration con;
        public static string IP;
        public bool restart;
        int fwRev = 0;
        SetActionDelegate SetActionChangeLedStatus;
        TextBoxUserControl tb_SingleByteASCII = new TextBoxUserControl();
        ListBoxUserControl lb_MultiByteDisplay = new ListBoxUserControl();
        public bool threadIsSleep = false;
        public bool requestSleep = false;
        public Thread MulThread;    //create the thread to perform monitoring in parallel with the main thread, we should use the invoke method to avoid cross  thread between the main thread and the monitor thread
        public byte MemPage = 00;
        FileStream fMultiByte;
        public static StreamWriter sMultiByte;
        System.Windows.Forms.DataGridView msaGrid = new System.Windows.Forms.DataGridView();
        System.Windows.Forms.DataGridView msaGrid2 = new System.Windows.Forms.DataGridView();
        DataTable msaTable2 = new DataTable();
        DataTable msaTable = new DataTable();
        bool softwarePause = false;
        public static StreamReader sr;
        FileStream fGrid;
        public static StreamWriter sGrid;
        bool SWInterrupt;
        object[] FlagParameters;
        object[] parameters;
        bool IsConnected = false;
        private delegate void SetTextBoxDelegate(object[] objects);
        SetTextBoxDelegate UpdateTextBox;
        private delegate void SetActionDelegate(object[] objects);
        SetActionDelegate SetActionFlagAssertedLed;
        RadialGradientBrush Ellipse_On;
        RadialGradientBrush Ellipse_Off;
        RadialGradientBrush Ellipse_Disabled;
        int intval = 0;
        byte[] ReadBuff;
        bool[] enableMonitor;
        FWInfo fwinfo;
        int usbConTimesLost = 0;
        int devId = 0;
        bool initialized = false;
        bool isDetectHWdone;
        int deviceCount;
        Dictionary<int, int> tick = new Dictionary<int, int>(){
            {0,100},{1,150},{2,200},{3,250},{4,300},{5,350},{6,400},{7,450},{8,500},{9,550},{10,600},{11,650},{12,700},{13,750},{14,800}
            };


        int BoardID = 0;




        public MainWindow()
        {
            InitializeComponent();
            isDetectHWdone = false;
            deviceCount = 0;
            msaManager = new MSAManager();
            fwinfo = new FWInfo();
            enableMonitor = new bool[1];

            ReadBuff = new byte[18];
            FlagParameters = new object[2];
            parameters = new object[2];
            UpdateTextBox = new SetTextBoxDelegate(SetTextBoxt);
            SetActionFlagAssertedLed = new SetActionDelegate(FlagAssertedLed);
            Ellipse_On = new RadialGradientBrush(Colors.Lime, Colors.LightGray);
            Ellipse_Off = new RadialGradientBrush(Colors.Red, Colors.LightGray);
            Ellipse_Disabled = new RadialGradientBrush(Colors.Transparent, Colors.LightGray);
            SetActionChangeLedStatus = new SetActionDelegate(ChangeLedStatus);

            wfh_AsciiSingleByte.Child = tb_SingleByteASCII;
            wfh_MultiByteDisplay.Child = lb_MultiByteDisplay;
            msaGrid.CellValueChanged += new System.Windows.Forms.DataGridViewCellEventHandler(msaGrid_CellValueChanged);
            msaGrid.RowCount = 640;
            msaGrid.ColumnCount = 5;
            msaTable.Columns.Clear();
            msaTable.Columns.Add("Address");
            msaTable.Columns.Add("Data(Hex)");
            msaTable.Columns.Add("Data(Dec.)");
            msaTable.Columns.Add("Data(Ascii)");
            msaTable.Columns.Add("MSA Description");

            msaGrid2.CellValueChanged += new System.Windows.Forms.DataGridViewCellEventHandler(msaGrid2_CellValueChanged);
            msaGrid2.RowCount = 128;
            msaGrid2.ColumnCount = 5;
            msaTable2.Columns.Clear();
            msaTable2.Columns.Add("Address");
            msaTable2.Columns.Add("Data(Hex)");
            msaTable2.Columns.Add("Data(Dec.)");
            msaTable2.Columns.Add("Data(Ascii)");
            msaTable2.Columns.Add("MSA Description");

            for (int row = 0; row < msaGrid.RowCount; row++)//for (int row = 0; row < 640; row++)
            {
                msaTable.Rows.Add(new object[] { 0, 0, 0, 0, "" });
            }
            FillMSADescription();

            for (int row = 0; row < msaGrid2.RowCount; row++)//for (int row = 0; row < 128; row++)
            {
                msaTable2.Rows.Add(new object[] { 0, 0, 0, 0, "" });
            }
            FillMSADescription2();

            for (int i = 0; i < 128; i++)
            {
                msaTable2.Rows[i][0] = "Page10  " + (i + 128).ToString() + "(" + (i + 128).ToString("X2") + "h)";

            }

            for (int i = 0; i < 128; i++)
            {
                msaTable.Rows[i][0] = "LowMem  " + i.ToString() + "(" + i.ToString("X2") + "h)";

            }
            for (int i = 128; i < 256; i++)
            {
                msaTable.Rows[i][0] = "Page00  " + i.ToString() + "(" + i.ToString("X2") + "h)";

            }

            for (int i = 256; i < 384; i++)
            {
                msaTable.Rows[i][0] = "Page01 " + (i - 128).ToString() + "(" + (i - 128).ToString("X2") + "h)";

            }
            for (int i = 384; i < 512; i++)
            {
                msaTable.Rows[i][0] = "Page02 " + (i - 256).ToString() + "(" + (i - 256).ToString("X2") + "h)";

            }
            for (int i = 512; i < 640; i++)
            {
                msaTable.Rows[i][0] = "Page03 " + (i - 384).ToString() + "(" + (i - 384).ToString("X2") + "h)";
            }

            msaGrid.Columns.Clear();
            msaGrid.DataSource = msaTable.Copy();
            wfh_DataGridView.Child = msaGrid;

            msaGrid2.Columns.Clear();
            msaGrid2.DataSource = msaTable2.Copy();
            wfh_DataGridView2.Child = msaGrid2;

            //sld_1.Value = 3.3;
            initialized = true;


            txt_IP.Text = Properties.Settings.Default.IP.ToString();

        }

        public void ChangeLedStatus(object[] objects)
        {
            Ellipse ellipse = (Ellipse)objects[0];
            int status = (int)objects[1];

            switch (status)
            {
                case 0:
                    ellipse.Fill = Ellipse_Off;
                    break;
                case 1:
                    ellipse.Fill = Ellipse_On;
                    break;
                default:
                    ellipse.Fill = Ellipse_Disabled;
                    break;
            }
        }

        public void Monitor()
        {
            try
            {
                while (true)
                {
                    if (requestSleep || !IsConnected)
                    {
                        threadIsSleep = true;
                        Thread.Sleep(50);
                        continue;
                    }

                    if (enableMonitor.Length > 0 && enableMonitor[msaManager.MSAInstance])
                    {
                        double data = 0;
                        if (msaManager.Get_temperature(ref data))
                        {
                            ChangeStatus(ref elps_Warning, 2);
                            ChangeStatus(ref elps_OK, 1);
                            usbConTimesLost = 0;
                            //lb_DisplayStatus.Items.Add("API Rev: " + data);
                        }
                        else
                        {
                            if (usbConTimesLost > 3)
                            {
                                //    ChangeStatus(ref elps_Warning, 0);
                                //    ChangeStatus(ref elps_OK, 2);
                                //    ChangeStatus(ref elps_ModuleFound, 2);
                                //    ChangeStatus(ref elps_ModuleNotFound, 2);
                                //}
                                //else
                                //{
                                ChangeStatus(ref elps_Warning, 0);
                                ChangeStatus(ref elps_OK, 2);
                                ChangeStatus(ref elps_ModuleFound, 2);
                                ChangeStatus(ref elps_ModuleNotFound, 2);
                                enableMonitor[msaManager.MSAInstance] = false;
                                msaManager.Disconnect();
                                System.Windows.Application.Current.Dispatcher.Invoke(
                                                                     new Action(() =>
                                                                     {
                                                                         b_Initialize.Content = "Initialize";
                                                                         elps_connection.Fill = System.Windows.Media.Brushes.Red;
                                                                         lb_DisplayStatus.Items.Clear();
                                                                         lb_DisplayStatus.Items.Add("Disconnected.");
                                                                     }));
                                MessageBox.Show("Connection lost. QSFP-DD LPBK host disconnected.", "QSFP-DD Host", MessageBoxButton.OK, MessageBoxImage.Warning);

                                continue;
                            }
                            usbConTimesLost++;
                        }
                        //check if the module is present
                        if (!msaManager.IsModulePresent())
                        {
                            ChangeStatus(ref elps_ModuleFound, 2);
                            ChangeStatus(ref elps_ModuleNotFound, 0);
                            //  return;
                        }
                        else
                        {

                            //if (msaManager.isTX_Dis) // if transmitter is disabled, then enable it
                            //    msaManager.TX_DIS(false); //enable Transmitter by deasserting TX_Dis 
                            ChangeStatus(ref elps_ModuleFound, 1);
                            ChangeStatus(ref elps_ModuleNotFound, 2);
                        }

                        /*  SetTextBoxt(txt_current, (msaManager.GetCurrent_sens(0).ToString("0.##")));
                          SetTextBoxt(txt_current1, (msaManager.GetCurrent_sens(1).ToString("0.##")));
                          SetTextBoxt(txt_currenttx, (msaManager.GetCurrent_sens(2).ToString("0.##")));
                          SetTextBoxt(txt_currentrx, (msaManager.GetCurrent_sens(3).ToString("0.##")));*/

                        SetTextBoxt(val_VCC, msaManager.Get_VCC().ToString("0.##"));
                        SetTextBoxt(val_VCC_1, msaManager.Get_VCC1().ToString("0.##"));
                        SetTextBoxt(val_VCC_TX, msaManager.Get_VCCTX().ToString("0.##"));
                        SetTextBoxt(val_VCC_RX, msaManager.Get_VCCRX().ToString("0.##"));

                        SetTextBoxt(val_CurrVCC, ((msaManager.GetCurrent_sens() / 1000)).ToString("0.####"));
                        SetTextBoxt(val_CurrVCC_1, ((msaManager.GetCurrent_sens_VCC1() / 1000)).ToString("0.####"));
                        SetTextBoxt(val_CurrVCC_TX, ((msaManager.GetCurrent_sens_VCCTX() / 1000)).ToString("0.####"));
                        SetTextBoxt(val_CurrVCC_RX, ((msaManager.GetCurrent_sens_VCCRX() / 1000)).ToString("0.####"));

                        SetTextBoxt(txt_temp, msaManager.TemperatureMeasurement(14, 2).ToString());
                        //14-15
                        // SetTextBoxt(txt_temp2, msaManager.TemperatureMeasurement2().ToString());

                        //16-17
                        SetTextBoxt(txt_supply3_3, msaManager.SuplyVoltageMeasurements().ToString("0.##"));

                        //18-19
                        //SetTextBoxt(txt_supply3_3_1, msaManager.SuplyVoltageMeasurements2().ToString("0.##"));



                        //18-19
                        SetTextBoxt(txt_TECsupplyCurr1, msaManager.TECSuplyCurrent1().ToString());
                        //20-21
                        SetTextBoxt(txt_TECsupplyCurr2, msaManager.TECSuplyCurrent2().ToString());
                        //22-23
                        SetTextBoxt(txt_LaserTemp, msaManager.TemperatureMeasurement(22, 2).ToString());


                        msaManager.I2CWrite(127, 17);
                        Thread.Sleep(10);
                        msaManager.ReadAddresses(134, 0, ref ReadBuff);
                        //TX

                        //134

                        FlagAsserted(ref elps_sttch7, msaManager.IsBitSet(ReadBuff[0], BITS.BIT7));
                        FlagAsserted(ref elps_sttch6, msaManager.IsBitSet(ReadBuff[0], BITS.BIT6));
                        FlagAsserted(ref elps_sttch5, msaManager.IsBitSet(ReadBuff[0], BITS.BIT5));
                        FlagAsserted(ref elps_sttch4, msaManager.IsBitSet(ReadBuff[0], BITS.BIT4));
                        FlagAsserted(ref elps_sttch3, msaManager.IsBitSet(ReadBuff[0], BITS.BIT3));
                        FlagAsserted(ref elps_sttch2, msaManager.IsBitSet(ReadBuff[0], BITS.BIT2));
                        FlagAsserted(ref elps_sttch1, msaManager.IsBitSet(ReadBuff[0], BITS.BIT1));
                        FlagAsserted(ref elps_sttch0, msaManager.IsBitSet(ReadBuff[0], BITS.BIT0));
                        //135

                        FlagAsserted(ref elps_txFault7, msaManager.IsBitSet(ReadBuff[1], BITS.BIT7));
                        FlagAsserted(ref elps_txFault6, msaManager.IsBitSet(ReadBuff[1], BITS.BIT6));
                        FlagAsserted(ref elps_txFault5, msaManager.IsBitSet(ReadBuff[1], BITS.BIT5));
                        FlagAsserted(ref elps_txFault4, msaManager.IsBitSet(ReadBuff[1], BITS.BIT4));
                        FlagAsserted(ref elps_txFault3, msaManager.IsBitSet(ReadBuff[1], BITS.BIT3));
                        FlagAsserted(ref elps_txFault2, msaManager.IsBitSet(ReadBuff[1], BITS.BIT2));
                        FlagAsserted(ref elps_txFault1, msaManager.IsBitSet(ReadBuff[1], BITS.BIT1));
                        FlagAsserted(ref elps_txFault0, msaManager.IsBitSet(ReadBuff[1], BITS.BIT0));
                        //136
                        FlagAsserted(ref elps_txLOS7, msaManager.IsBitSet(ReadBuff[2], BITS.BIT7));
                        FlagAsserted(ref elps_txLOS6, msaManager.IsBitSet(ReadBuff[2], BITS.BIT6));
                        FlagAsserted(ref elps_txLOS5, msaManager.IsBitSet(ReadBuff[2], BITS.BIT5));
                        FlagAsserted(ref elps_txLOS4, msaManager.IsBitSet(ReadBuff[2], BITS.BIT4));
                        FlagAsserted(ref elps_txLOS3, msaManager.IsBitSet(ReadBuff[2], BITS.BIT3));
                        FlagAsserted(ref elps_txLOS2, msaManager.IsBitSet(ReadBuff[2], BITS.BIT2));
                        FlagAsserted(ref elps_txLOS1, msaManager.IsBitSet(ReadBuff[2], BITS.BIT1));
                        FlagAsserted(ref elps_txLOS0, msaManager.IsBitSet(ReadBuff[2], BITS.BIT0));
                        //137
                        FlagAsserted(ref elps_txLOL7, msaManager.IsBitSet(ReadBuff[3], BITS.BIT7));
                        FlagAsserted(ref elps_txLOL6, msaManager.IsBitSet(ReadBuff[3], BITS.BIT6));
                        FlagAsserted(ref elps_txLOL5, msaManager.IsBitSet(ReadBuff[3], BITS.BIT5));
                        FlagAsserted(ref elps_txLOL4, msaManager.IsBitSet(ReadBuff[3], BITS.BIT4));
                        FlagAsserted(ref elps_txLOL3, msaManager.IsBitSet(ReadBuff[3], BITS.BIT3));
                        FlagAsserted(ref elps_txLOL2, msaManager.IsBitSet(ReadBuff[3], BITS.BIT2));
                        FlagAsserted(ref elps_txLOL1, msaManager.IsBitSet(ReadBuff[3], BITS.BIT1));
                        FlagAsserted(ref elps_txLOL0, msaManager.IsBitSet(ReadBuff[3], BITS.BIT0));
                        //138 adaptive tx eq to add [3]

                        //139
                        FlagAsserted(ref elps_txpwrHA7, msaManager.IsBitSet(ReadBuff[5], BITS.BIT7));
                        FlagAsserted(ref elps_txpwrHA6, msaManager.IsBitSet(ReadBuff[5], BITS.BIT6));
                        FlagAsserted(ref elps_txpwrHA5, msaManager.IsBitSet(ReadBuff[5], BITS.BIT5));
                        FlagAsserted(ref elps_txpwrHA4, msaManager.IsBitSet(ReadBuff[5], BITS.BIT4));
                        FlagAsserted(ref elps_txpwrHA3, msaManager.IsBitSet(ReadBuff[5], BITS.BIT3));
                        FlagAsserted(ref elps_txpwrHA2, msaManager.IsBitSet(ReadBuff[5], BITS.BIT2));
                        FlagAsserted(ref elps_txpwrHA1, msaManager.IsBitSet(ReadBuff[5], BITS.BIT1));
                        FlagAsserted(ref elps_txpwrHA0, msaManager.IsBitSet(ReadBuff[5], BITS.BIT0));
                        //140
                        FlagAsserted(ref elps_txpwrLA7, msaManager.IsBitSet(ReadBuff[6], BITS.BIT7));
                        FlagAsserted(ref elps_txpwrLA6, msaManager.IsBitSet(ReadBuff[6], BITS.BIT6));
                        FlagAsserted(ref elps_txpwrLA5, msaManager.IsBitSet(ReadBuff[6], BITS.BIT5));
                        FlagAsserted(ref elps_txpwrLA4, msaManager.IsBitSet(ReadBuff[6], BITS.BIT4));
                        FlagAsserted(ref elps_txpwrLA3, msaManager.IsBitSet(ReadBuff[6], BITS.BIT3));
                        FlagAsserted(ref elps_txpwrLA2, msaManager.IsBitSet(ReadBuff[6], BITS.BIT2));
                        FlagAsserted(ref elps_txpwrLA1, msaManager.IsBitSet(ReadBuff[6], BITS.BIT1));
                        FlagAsserted(ref elps_txpwrLA0, msaManager.IsBitSet(ReadBuff[6], BITS.BIT0));

                        //141
                        FlagAsserted(ref elps_txpwrHW7, msaManager.IsBitSet(ReadBuff[7], BITS.BIT7));
                        FlagAsserted(ref elps_txpwrHW6, msaManager.IsBitSet(ReadBuff[7], BITS.BIT6));
                        FlagAsserted(ref elps_txpwrHW5, msaManager.IsBitSet(ReadBuff[7], BITS.BIT5));
                        FlagAsserted(ref elps_txpwrHW4, msaManager.IsBitSet(ReadBuff[7], BITS.BIT4));
                        FlagAsserted(ref elps_txpwrHW3, msaManager.IsBitSet(ReadBuff[7], BITS.BIT3));
                        FlagAsserted(ref elps_txpwrHW2, msaManager.IsBitSet(ReadBuff[7], BITS.BIT2));
                        FlagAsserted(ref elps_txpwrHW1, msaManager.IsBitSet(ReadBuff[7], BITS.BIT1));
                        FlagAsserted(ref elps_txpwrHW0, msaManager.IsBitSet(ReadBuff[7], BITS.BIT0));

                        //142
                        FlagAsserted(ref elps_txpwrLW7, msaManager.IsBitSet(ReadBuff[8], BITS.BIT7));
                        FlagAsserted(ref elps_txpwrLW6, msaManager.IsBitSet(ReadBuff[8], BITS.BIT6));
                        FlagAsserted(ref elps_txpwrLW5, msaManager.IsBitSet(ReadBuff[8], BITS.BIT5));
                        FlagAsserted(ref elps_txpwrLW4, msaManager.IsBitSet(ReadBuff[8], BITS.BIT4));
                        FlagAsserted(ref elps_txpwrLW3, msaManager.IsBitSet(ReadBuff[8], BITS.BIT3));
                        FlagAsserted(ref elps_txpwrLW2, msaManager.IsBitSet(ReadBuff[8], BITS.BIT2));
                        FlagAsserted(ref elps_txpwrLW1, msaManager.IsBitSet(ReadBuff[8], BITS.BIT1));
                        FlagAsserted(ref elps_txpwrLW0, msaManager.IsBitSet(ReadBuff[8], BITS.BIT0));

                        //143
                        FlagAsserted(ref elps_txBHA7, msaManager.IsBitSet(ReadBuff[9], BITS.BIT7));
                        FlagAsserted(ref elps_txBHA6, msaManager.IsBitSet(ReadBuff[9], BITS.BIT6));
                        FlagAsserted(ref elps_txBHA5, msaManager.IsBitSet(ReadBuff[9], BITS.BIT5));
                        FlagAsserted(ref elps_txBHA4, msaManager.IsBitSet(ReadBuff[9], BITS.BIT4));
                        FlagAsserted(ref elps_txBHA3, msaManager.IsBitSet(ReadBuff[9], BITS.BIT3));
                        FlagAsserted(ref elps_txBHA2, msaManager.IsBitSet(ReadBuff[9], BITS.BIT2));
                        FlagAsserted(ref elps_txBHA1, msaManager.IsBitSet(ReadBuff[9], BITS.BIT1));
                        FlagAsserted(ref elps_txBHA0, msaManager.IsBitSet(ReadBuff[9], BITS.BIT0));

                        //144
                        FlagAsserted(ref elps_txBLA7, msaManager.IsBitSet(ReadBuff[10], BITS.BIT7));
                        FlagAsserted(ref elps_txBLA6, msaManager.IsBitSet(ReadBuff[10], BITS.BIT6));
                        FlagAsserted(ref elps_txBLA5, msaManager.IsBitSet(ReadBuff[10], BITS.BIT5));
                        FlagAsserted(ref elps_txBLA4, msaManager.IsBitSet(ReadBuff[10], BITS.BIT4));
                        FlagAsserted(ref elps_txBLA3, msaManager.IsBitSet(ReadBuff[10], BITS.BIT3));
                        FlagAsserted(ref elps_txBLA2, msaManager.IsBitSet(ReadBuff[10], BITS.BIT2));
                        FlagAsserted(ref elps_txBLA1, msaManager.IsBitSet(ReadBuff[10], BITS.BIT1));
                        FlagAsserted(ref elps_txBLA0, msaManager.IsBitSet(ReadBuff[10], BITS.BIT0));

                        //145
                        FlagAsserted(ref elps_txBHW7, msaManager.IsBitSet(ReadBuff[11], BITS.BIT7));
                        FlagAsserted(ref elps_txBHW6, msaManager.IsBitSet(ReadBuff[11], BITS.BIT6));
                        FlagAsserted(ref elps_txBHW5, msaManager.IsBitSet(ReadBuff[11], BITS.BIT5));
                        FlagAsserted(ref elps_txBHW4, msaManager.IsBitSet(ReadBuff[11], BITS.BIT4));
                        FlagAsserted(ref elps_txBHW3, msaManager.IsBitSet(ReadBuff[11], BITS.BIT3));
                        FlagAsserted(ref elps_txBHW2, msaManager.IsBitSet(ReadBuff[11], BITS.BIT2));
                        FlagAsserted(ref elps_txBHW1, msaManager.IsBitSet(ReadBuff[11], BITS.BIT1));
                        FlagAsserted(ref elps_txBHW0, msaManager.IsBitSet(ReadBuff[11], BITS.BIT0));

                        //146
                        FlagAsserted(ref elps_txBLW7, msaManager.IsBitSet(ReadBuff[12], BITS.BIT7));
                        FlagAsserted(ref elps_txBLW6, msaManager.IsBitSet(ReadBuff[12], BITS.BIT6));
                        FlagAsserted(ref elps_txBLW5, msaManager.IsBitSet(ReadBuff[12], BITS.BIT5));
                        FlagAsserted(ref elps_txBLW4, msaManager.IsBitSet(ReadBuff[12], BITS.BIT4));
                        FlagAsserted(ref elps_txBLW3, msaManager.IsBitSet(ReadBuff[12], BITS.BIT3));
                        FlagAsserted(ref elps_txBLW2, msaManager.IsBitSet(ReadBuff[12], BITS.BIT2));
                        FlagAsserted(ref elps_txBLW1, msaManager.IsBitSet(ReadBuff[12], BITS.BIT1));
                        FlagAsserted(ref elps_txBLW0, msaManager.IsBitSet(ReadBuff[12], BITS.BIT0));



                        //RX
                        //147
                        FlagAsserted(ref elps_rxLOS7, msaManager.IsBitSet(ReadBuff[13], BITS.BIT7));
                        FlagAsserted(ref elps_rxLOS6, msaManager.IsBitSet(ReadBuff[13], BITS.BIT6));
                        FlagAsserted(ref elps_rxLOS5, msaManager.IsBitSet(ReadBuff[13], BITS.BIT5));
                        FlagAsserted(ref elps_rxLOS4, msaManager.IsBitSet(ReadBuff[13], BITS.BIT4));
                        FlagAsserted(ref elps_rxLOS3, msaManager.IsBitSet(ReadBuff[13], BITS.BIT3));
                        FlagAsserted(ref elps_rxLOS2, msaManager.IsBitSet(ReadBuff[13], BITS.BIT2));
                        FlagAsserted(ref elps_rxLOS1, msaManager.IsBitSet(ReadBuff[13], BITS.BIT1));
                        FlagAsserted(ref elps_rxLOS0, msaManager.IsBitSet(ReadBuff[13], BITS.BIT0));

                        //148
                        FlagAsserted(ref elps_rxLOL7, msaManager.IsBitSet(ReadBuff[14], BITS.BIT7));
                        FlagAsserted(ref elps_rxLOL6, msaManager.IsBitSet(ReadBuff[14], BITS.BIT6));
                        FlagAsserted(ref elps_rxLOL5, msaManager.IsBitSet(ReadBuff[14], BITS.BIT5));
                        FlagAsserted(ref elps_rxLOL4, msaManager.IsBitSet(ReadBuff[14], BITS.BIT4));
                        FlagAsserted(ref elps_rxLOL3, msaManager.IsBitSet(ReadBuff[14], BITS.BIT3));
                        FlagAsserted(ref elps_rxLOL2, msaManager.IsBitSet(ReadBuff[14], BITS.BIT2));
                        FlagAsserted(ref elps_rxLOL1, msaManager.IsBitSet(ReadBuff[14], BITS.BIT1));
                        FlagAsserted(ref elps_rxLOL0, msaManager.IsBitSet(ReadBuff[14], BITS.BIT0));

                        //149
                        FlagAsserted(ref elps_rxpwrHA7, msaManager.IsBitSet(ReadBuff[15], BITS.BIT7));
                        FlagAsserted(ref elps_rxpwrHA6, msaManager.IsBitSet(ReadBuff[15], BITS.BIT6));
                        FlagAsserted(ref elps_rxpwrHA5, msaManager.IsBitSet(ReadBuff[15], BITS.BIT5));
                        FlagAsserted(ref elps_rxpwrHA4, msaManager.IsBitSet(ReadBuff[15], BITS.BIT4));
                        FlagAsserted(ref elps_rxpwrHA3, msaManager.IsBitSet(ReadBuff[15], BITS.BIT3));
                        FlagAsserted(ref elps_rxpwrHA2, msaManager.IsBitSet(ReadBuff[15], BITS.BIT2));
                        FlagAsserted(ref elps_rxpwrHA1, msaManager.IsBitSet(ReadBuff[15], BITS.BIT1));
                        FlagAsserted(ref elps_rxpwrHA0, msaManager.IsBitSet(ReadBuff[15], BITS.BIT0));
                        //150
                        FlagAsserted(ref elps_rxpwrLA7, msaManager.IsBitSet(ReadBuff[16], BITS.BIT7));
                        FlagAsserted(ref elps_rxpwrLA6, msaManager.IsBitSet(ReadBuff[16], BITS.BIT6));
                        FlagAsserted(ref elps_rxpwrLA5, msaManager.IsBitSet(ReadBuff[16], BITS.BIT5));
                        FlagAsserted(ref elps_rxpwrLA4, msaManager.IsBitSet(ReadBuff[16], BITS.BIT4));
                        FlagAsserted(ref elps_rxpwrLA3, msaManager.IsBitSet(ReadBuff[16], BITS.BIT3));
                        FlagAsserted(ref elps_rxpwrLA2, msaManager.IsBitSet(ReadBuff[16], BITS.BIT2));
                        FlagAsserted(ref elps_rxpwrLA1, msaManager.IsBitSet(ReadBuff[16], BITS.BIT1));
                        FlagAsserted(ref elps_rxpwrLA0, msaManager.IsBitSet(ReadBuff[16], BITS.BIT0));

                        //151
                        FlagAsserted(ref elps_rxpwrHW7, msaManager.IsBitSet(ReadBuff[17], BITS.BIT7));
                        FlagAsserted(ref elps_rxpwrHW6, msaManager.IsBitSet(ReadBuff[17], BITS.BIT6));
                        FlagAsserted(ref elps_rxpwrHW5, msaManager.IsBitSet(ReadBuff[17], BITS.BIT5));
                        FlagAsserted(ref elps_rxpwrHW4, msaManager.IsBitSet(ReadBuff[17], BITS.BIT4));
                        FlagAsserted(ref elps_rxpwrHW3, msaManager.IsBitSet(ReadBuff[17], BITS.BIT3));
                        FlagAsserted(ref elps_rxpwrHW2, msaManager.IsBitSet(ReadBuff[17], BITS.BIT2));
                        FlagAsserted(ref elps_rxpwrHW1, msaManager.IsBitSet(ReadBuff[17], BITS.BIT1));
                        FlagAsserted(ref elps_rxpwrHW0, msaManager.IsBitSet(ReadBuff[17], BITS.BIT0));
                        //152
                        FlagAsserted(ref elps_rxpwrLW7, msaManager.IsBitSet(ReadBuff[18], BITS.BIT7));
                        FlagAsserted(ref elps_rxpwrLW6, msaManager.IsBitSet(ReadBuff[18], BITS.BIT6));
                        FlagAsserted(ref elps_rxpwrLW5, msaManager.IsBitSet(ReadBuff[18], BITS.BIT5));
                        FlagAsserted(ref elps_rxpwrLW4, msaManager.IsBitSet(ReadBuff[18], BITS.BIT4));
                        FlagAsserted(ref elps_rxpwrLW3, msaManager.IsBitSet(ReadBuff[18], BITS.BIT3));
                        FlagAsserted(ref elps_rxpwrLW2, msaManager.IsBitSet(ReadBuff[18], BITS.BIT2));
                        FlagAsserted(ref elps_rxpwrLW1, msaManager.IsBitSet(ReadBuff[18], BITS.BIT1));
                        FlagAsserted(ref elps_rxpwrLW0, msaManager.IsBitSet(ReadBuff[18], BITS.BIT0));

                        Thread.Sleep(10);
                        msaManager.ReadAddresses(8, 0, ref ReadBuff);

                        //8
                        FlagAsserted(ref elps_initCompl, msaManager.IsBitSet(ReadBuff[0], BITS.BIT0));
                        //9
                        FlagAsserted(ref elps_vccLW, msaManager.IsBitSet(ReadBuff[1], BITS.BIT7));
                        FlagAsserted(ref elps_vccHW, msaManager.IsBitSet(ReadBuff[1], BITS.BIT6));
                        FlagAsserted(ref elps_vccLA, msaManager.IsBitSet(ReadBuff[1], BITS.BIT5));
                        FlagAsserted(ref elps_vccHA, msaManager.IsBitSet(ReadBuff[1], BITS.BIT4));
                        FlagAsserted(ref elps_tempLW, msaManager.IsBitSet(ReadBuff[1], BITS.BIT3));
                        FlagAsserted(ref elps_tempHW, msaManager.IsBitSet(ReadBuff[1], BITS.BIT2));
                        FlagAsserted(ref elps_tempHA, msaManager.IsBitSet(ReadBuff[1], BITS.BIT0));
                        FlagAsserted(ref elps_tempLA, msaManager.IsBitSet(ReadBuff[1], BITS.BIT1));

                        //10
                        FlagAsserted(ref elps_AUX_LW2, msaManager.IsBitSet(ReadBuff[2], BITS.BIT7));
                        FlagAsserted(ref elps_AUX_HW2, msaManager.IsBitSet(ReadBuff[2], BITS.BIT6));
                        FlagAsserted(ref elps_AUX_LA2, msaManager.IsBitSet(ReadBuff[2], BITS.BIT5));
                        FlagAsserted(ref elps_AUX_HA2, msaManager.IsBitSet(ReadBuff[2], BITS.BIT4));
                        FlagAsserted(ref elps_AUX_LW1, msaManager.IsBitSet(ReadBuff[2], BITS.BIT3));
                        FlagAsserted(ref elps_AUX_HW1, msaManager.IsBitSet(ReadBuff[2], BITS.BIT2));
                        FlagAsserted(ref elps_AUX_LA1, msaManager.IsBitSet(ReadBuff[2], BITS.BIT1));
                        FlagAsserted(ref elps_AUX_HA1, msaManager.IsBitSet(ReadBuff[2], BITS.BIT0));

                        //11
                        FlagAsserted(ref elps_vendorLW, msaManager.IsBitSet(ReadBuff[3], BITS.BIT7));
                        FlagAsserted(ref elps_vendorHW, msaManager.IsBitSet(ReadBuff[3], BITS.BIT6));
                        FlagAsserted(ref elps_vendorLA, msaManager.IsBitSet(ReadBuff[3], BITS.BIT5));
                        FlagAsserted(ref elps_vendorHA, msaManager.IsBitSet(ReadBuff[3], BITS.BIT4));
                        FlagAsserted(ref elps_AUX_LW3, msaManager.IsBitSet(ReadBuff[3], BITS.BIT3));
                        FlagAsserted(ref elps_AUX_HW3, msaManager.IsBitSet(ReadBuff[3], BITS.BIT2));
                        FlagAsserted(ref elps_AUX_LA3, msaManager.IsBitSet(ReadBuff[3], BITS.BIT1));
                        FlagAsserted(ref elps_AUX_HA3, msaManager.IsBitSet(ReadBuff[3], BITS.BIT0));









                        //20
                        //FlagAsserted(ref elps_tecStable, msaManager.IsBitSet(ReadBuff[17], BITS.BIT0));

                        //14-15

                        //23
                        //SetTextBoxt(txt_Supplyvlt, msaManager.SuplyVoltageMeasurements2().ToString("0.##"));

                        msaManager.I2CWrite(127, 17);

                        Thread.Sleep(10);
                        msaManager.ReadAddresses(154, 0, ref ReadBuff);

                        //154->169
                        SetTextBoxt(txt_txpwr0, ((double)msaManager.ReadXBuffer(154, 2) / 10000).ToString());
                        SetTextBoxt(txt_txpwr1, ((double)msaManager.ReadXBuffer(156, 2) / 10000).ToString());
                        SetTextBoxt(txt_txpwr2, ((double)msaManager.ReadXBuffer(158, 2) / 10000).ToString());
                        SetTextBoxt(txt_txpwr3, ((double)msaManager.ReadXBuffer(160, 2) / 10000).ToString());
                        SetTextBoxt(txt_txpwr4, ((double)msaManager.ReadXBuffer(162, 2) / 10000).ToString());
                        SetTextBoxt(txt_txpwr5, ((double)msaManager.ReadXBuffer(164, 2) / 10000).ToString());
                        SetTextBoxt(txt_txpwr6, ((double)msaManager.ReadXBuffer(166, 2) / 10000).ToString());
                        SetTextBoxt(txt_txpwr7, ((double)msaManager.ReadXBuffer(168, 2) / 10000).ToString());

                        //170 -> 185 
                        SetTextBoxt(txt_txB0, ((double)msaManager.ReadXBuffer(170, 2) * 0.002).ToString());
                        SetTextBoxt(txt_txB1, ((double)msaManager.ReadXBuffer(172, 2) * 0.002).ToString());
                        SetTextBoxt(txt_txB2, ((double)msaManager.ReadXBuffer(174, 2) * 0.002).ToString());
                        SetTextBoxt(txt_txB3, ((double)msaManager.ReadXBuffer(176, 2) * 0.002).ToString());
                        SetTextBoxt(txt_txB4, ((double)msaManager.ReadXBuffer(178, 2) * 0.002).ToString());
                        SetTextBoxt(txt_txB5, ((double)msaManager.ReadXBuffer(180, 2) * 0.002).ToString());
                        SetTextBoxt(txt_txB6, ((double)msaManager.ReadXBuffer(182, 2) * 0.002).ToString());
                        SetTextBoxt(txt_txB7, ((double)msaManager.ReadXBuffer(184, 2) * 0.002).ToString());

                        //186->201
                        SetTextBoxt(txt_rxpwr0, ((double)msaManager.ReadXBuffer(186, 2) / 10000).ToString());
                        SetTextBoxt(txt_rxpwr1, ((double)msaManager.ReadXBuffer(188, 2) / 10000).ToString());
                        SetTextBoxt(txt_rxpwr2, ((double)msaManager.ReadXBuffer(190, 2) / 10000).ToString());
                        SetTextBoxt(txt_rxpwr3, ((double)msaManager.ReadXBuffer(192, 2) / 10000).ToString());
                        SetTextBoxt(txt_rxpwr4, ((double)msaManager.ReadXBuffer(194, 2) / 10000).ToString());
                        SetTextBoxt(txt_rxpwr5, ((double)msaManager.ReadXBuffer(196, 2) / 10000).ToString());
                        SetTextBoxt(txt_rxpwr6, ((double)msaManager.ReadXBuffer(198, 2) / 10000).ToString());
                        SetTextBoxt(txt_rxpwr7, ((double)msaManager.ReadXBuffer(200, 2) / 10000).ToString());

                        //msaManager.ReadAddresses(8, 0, ref ReadBuff);


                        //msaManager.ReadAddresses(193, 0, ref ReadBuff);
                        //FlagAsserted(ref elps_193_7, msaManager.IsBitSet(ReadBuff[0], BITS.BIT7));
                        //FlagAsserted(ref elps_193_6, msaManager.IsBitSet(ReadBuff[0], BITS.BIT6));
                        //FlagAsserted(ref elps_193_5, msaManager.IsBitSet(ReadBuff[0], BITS.BIT5));
                        //FlagAsserted(ref elps_193_4, msaManager.IsBitSet(ReadBuff[0], BITS.BIT4));
                        //FlagAsserted(ref elps_193_3, msaManager.IsBitSet(ReadBuff[0], BITS.BIT3));
                        //FlagAsserted(ref elps_193_2, msaManager.IsBitSet(ReadBuff[0], BITS.BIT2));
                        //FlagAsserted(ref elps_193_1, msaManager.IsBitSet(ReadBuff[0], BITS.BIT1));
                        //FlagAsserted(ref elps_193_0, msaManager.IsBitSet(ReadBuff[0], BITS.BIT0));

                        //FlagAsserted(ref elps_194_7, msaManager.IsBitSet(ReadBuff[1], BITS.BIT7));
                        //FlagAsserted(ref elps_194_6, msaManager.IsBitSet(ReadBuff[1], BITS.BIT6));
                        //FlagAsserted(ref elps_194_5, msaManager.IsBitSet(ReadBuff[1], BITS.BIT5));
                        //FlagAsserted(ref elps_194_4, msaManager.IsBitSet(ReadBuff[1], BITS.BIT4));
                        //FlagAsserted(ref elps_194_3, msaManager.IsBitSet(ReadBuff[1], BITS.BIT3));
                        //FlagAsserted(ref elps_194_2, msaManager.IsBitSet(ReadBuff[1], BITS.BIT2));
                        //FlagAsserted(ref elps_194_1, msaManager.IsBitSet(ReadBuff[1], BITS.BIT1));
                        //FlagAsserted(ref elps_194_0, msaManager.IsBitSet(ReadBuff[1], BITS.BIT0));

                        //FlagAsserted(ref elps_195_7, msaManager.IsBitSet(ReadBuff[2], BITS.BIT7));
                        //FlagAsserted(ref elps_195_6, msaManager.IsBitSet(ReadBuff[2], BITS.BIT6));
                        //FlagAsserted(ref elps_195_5, msaManager.IsBitSet(ReadBuff[2], BITS.BIT5));
                        //FlagAsserted(ref elps_195_4, msaManager.IsBitSet(ReadBuff[2], BITS.BIT4));
                        //FlagAsserted(ref elps_195_3, msaManager.IsBitSet(ReadBuff[2], BITS.BIT3));
                        //FlagAsserted(ref elps_195_2, msaManager.IsBitSet(ReadBuff[2], BITS.BIT2));
                        //FlagAsserted(ref elps_195_1, msaManager.IsBitSet(ReadBuff[2], BITS.BIT1));

                    }
                }
            }
            catch (Exception e)
            {
                if (e.InnerException != null)
                {
                    string err = e.InnerException.Message;
                    MessageBox.Show(err);
                }
            }
        }
        private void SetTextBoxt(object[] objects) //   the UpdateTextBox delegate calls this function 
        {
            TextBox tx = (TextBox)objects[0];
            tx.Text = (string)objects[1];
        }
        private void SetTextBoxt(TextBox tx, string text)
        {
            if (requestSleep && !threadIsSleep) { return; }
            try
            {
                parameters[0] = tx;
                parameters[1] = text;

                this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal, UpdateTextBox, parameters); // the UpdateTextBox delegate calls SetTextBoxt(object[] parameters) functions with objects[]=parameters[] inside the function SetTextBoxt(TextBox tx, string text) 
                //Thread.Sleep(5);
            }
            catch (Exception e)
            {
                if (e.InnerException != null)
                {
                    string err = e.InnerException.Message;
                    MessageBox.Show(err);
                }
            }
        }
        public void FlagAsserted(ref Ellipse ellipse, bool status)
        {
            try
            {
                FlagParameters[0] = ellipse;
                FlagParameters[1] = status;
                this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal, SetActionFlagAssertedLed, FlagParameters);
                //Thread.Sleep(5);
            }
            catch (Exception e)
            {
                if (e.InnerException != null)
                {
                    string err = e.InnerException.Message;
                    MessageBox.Show(err);
                }
            }
        }
        public void FlagAssertedLed(object[] objects)
        {
            Ellipse ellipse = (Ellipse)objects[0];
            bool status = (bool)objects[1];

            if (status)
                ellipse.Fill = Ellipse_Off;
            else
                ellipse.Fill = Ellipse_Disabled;
        }
        public void FillMSADescription()
        {
            #region Low MEM page
            msaTable.Rows[0][4] = "Identifier";
            msaTable.Rows[1][4] = "Version Id";
            msaTable.Rows[2][4] = "CLEI code present";
            msaTable.Rows[3][4] = "Module State";
            msaTable.Rows[4][4] = "Bank 0";
            msaTable.Rows[5][4] = "Bank 1";
            msaTable.Rows[6][4] = "Bank 2";
            msaTable.Rows[7][4] = "Bank 3";
            msaTable.Rows[8][4] = "Module State changed flag";
            msaTable.Rows[9][4] = "Latched VCC3.3/Temp Alarm and Warning";
            msaTable.Rows[10][4] = "Latched AUX1/2 Alarm and Warning";
            msaTable.Rows[11][4] = "Latched Vendor Defined Alarm and Warning";
            msaTable.Rows[12][4] = "Reserved";
            msaTable.Rows[13][4] = "Custom";
            msaTable.Rows[14][4] = "Internally measured Temperature 1 MSB";
            msaTable.Rows[15][4] = "Internally measured Temperature 1 LSB";
            msaTable.Rows[16][4] = "Internally measured Supply 3.3v MSB";
            msaTable.Rows[17][4] = "Internally measured Supply 3.3v LSB";
            msaTable.Rows[18][4] = "Internally measured AUX1 MSB";
            msaTable.Rows[19][4] = "Internally measured AUX1 LSB";
            msaTable.Rows[20][4] = "Internally measured AUX2 MSB";
            msaTable.Rows[21][4] = "Internally measured AUX2 LSB";
            msaTable.Rows[22][4] = "Internally measured AUX3 MSB";
            msaTable.Rows[23][4] = "Internally measured AUX3 LSB";
            msaTable.Rows[24][4] = "Internally measured Custom MSB";
            msaTable.Rows[25][4] = "Internally measured Custom LSB";
            msaTable.Rows[26][4] = "Software reset";
            msaTable.Rows[27][4] = "Reserved";
            msaTable.Rows[28][4] = "Reserved";
            msaTable.Rows[29][4] = "Custom";
            msaTable.Rows[30][4] = "Custom";
            msaTable.Rows[31][4] = "State Changed Mask";
            msaTable.Rows[32][4] = "Voltage/Temperature Mask";
            msaTable.Rows[33][4] = "AUX2/AUX1 mask";
            msaTable.Rows[34][4] = "Vendor Defined/AUX3 Mask";
            msaTable.Rows[35][4] = "Reserved";
            msaTable.Rows[36][4] = "Custom";
            msaTable.Rows[37][4] = "Reserved";
            msaTable.Rows[38][4] = "Reserved";
            msaTable.Rows[39][4] = "Reserved";
            msaTable.Rows[40][4] = "Reserved";
            msaTable.Rows[41][4] = "Reserved";
            msaTable.Rows[42][4] = "Reserved";
            msaTable.Rows[43][4] = "Reserved";
            msaTable.Rows[44][4] = "Reserved";
            msaTable.Rows[45][4] = "Reserved";
            msaTable.Rows[46][4] = "Reserved";
            msaTable.Rows[47][4] = "Reserved";
            msaTable.Rows[48][4] = "Reserved";
            msaTable.Rows[49][4] = "Reserved";
            msaTable.Rows[50][4] = "Reserved";
            msaTable.Rows[51][4] = "Reserved";
            msaTable.Rows[52][4] = "Reserved";
            msaTable.Rows[53][4] = "Reserved";
            msaTable.Rows[54][4] = "Reserved";
            msaTable.Rows[55][4] = "Reserved";
            msaTable.Rows[56][4] = "Reserved";
            msaTable.Rows[57][4] = "Reserved";
            msaTable.Rows[58][4] = "Reserved";
            msaTable.Rows[59][4] = "Reserved";
            msaTable.Rows[60][4] = "Reserved";
            msaTable.Rows[61][4] = "Reserved";
            msaTable.Rows[62][4] = "Reserved";
            msaTable.Rows[63][4] = "Reserved";
            msaTable.Rows[64][4] = "Custom";
            msaTable.Rows[65][4] = "Custom";
            msaTable.Rows[66][4] = "Custom";
            msaTable.Rows[67][4] = "Custom";
            msaTable.Rows[68][4] = "Custom";
            msaTable.Rows[69][4] = "Custom";
            msaTable.Rows[70][4] = "Custom";
            msaTable.Rows[71][4] = "Custom";
            msaTable.Rows[72][4] = "Custom";
            msaTable.Rows[73][4] = "Custom";
            msaTable.Rows[74][4] = "Custom";
            msaTable.Rows[75][4] = "Custom";
            msaTable.Rows[76][4] = "Custom";
            msaTable.Rows[77][4] = "Custom";
            msaTable.Rows[78][4] = "Custom";
            msaTable.Rows[79][4] = "Custom";
            msaTable.Rows[80][4] = "Custom";
            msaTable.Rows[81][4] = "Custom";
            msaTable.Rows[82][4] = "Custom";
            msaTable.Rows[83][4] = "Custom";
            msaTable.Rows[84][4] = "Custom";
            msaTable.Rows[85][4] = "Modyle Type Advertising Code";
            msaTable.Rows[86][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[87][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[88][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[89][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[90][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[91][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[92][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[93][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[94][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[95][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[96][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[97][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[98][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[99][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[100][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[101][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[102][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[103][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[104][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[105][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[106][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[107][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[108][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[109][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[110][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[111][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[112][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[113][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[114][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[115][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[116][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[117][4] = "Cable Host-Media Interfaces Advertising Option";
            msaTable.Rows[118][4] = "Password area ";
            msaTable.Rows[119][4] = "Password area ";
            msaTable.Rows[120][4] = "Password area ";
            msaTable.Rows[121][4] = "Password area ";
            msaTable.Rows[122][4] = "Password area ";
            msaTable.Rows[123][4] = "Password area ";
            msaTable.Rows[124][4] = "Password area ";
            msaTable.Rows[125][4] = "Password area ";
            msaTable.Rows[126][4] = "Bank Select Byte";
            msaTable.Rows[127][4] = "Page Select Byte";
            #endregion

            //msaTable.Rows[127][4] = "Page Select Byte";
            #region Page00
            msaTable.Rows[128][4] = "Identifier";
            msaTable.Rows[129][4] = "Vendor Name";
            msaTable.Rows[130][4] = "Vendor Name";
            msaTable.Rows[131][4] = "Vendor Name";
            msaTable.Rows[132][4] = "Vendor Name";
            msaTable.Rows[133][4] = "Vendor Name";
            msaTable.Rows[134][4] = "Vendor Name";
            msaTable.Rows[135][4] = "Vendor Name";
            msaTable.Rows[136][4] = "Vendor Name";
            msaTable.Rows[137][4] = "Vendor Name";
            msaTable.Rows[138][4] = "Vendor Name";
            msaTable.Rows[139][4] = "Vendor Name";
            msaTable.Rows[140][4] = "Vendor Name";
            msaTable.Rows[141][4] = "Vendor Name";
            msaTable.Rows[142][4] = "Vendor Name";
            msaTable.Rows[143][4] = "Vendor Name";
            msaTable.Rows[144][4] = "Vendor Name";
            msaTable.Rows[145][4] = "Vendor OUI";
            msaTable.Rows[146][4] = "Vendor OUI";
            msaTable.Rows[147][4] = "Vendor OUI";
            msaTable.Rows[148][4] = "Vendor PN";
            msaTable.Rows[149][4] = "Vendor PN";
            msaTable.Rows[150][4] = "Vendor PN";
            msaTable.Rows[151][4] = "Vendor PN";
            msaTable.Rows[152][4] = "Vendor PN";
            msaTable.Rows[153][4] = "Vendor PN";
            msaTable.Rows[154][4] = "Vendor PN";
            msaTable.Rows[155][4] = "Vendor PN";
            msaTable.Rows[156][4] = "Vendor PN";
            msaTable.Rows[157][4] = "Vendor PN";
            msaTable.Rows[158][4] = "Vendor PN";
            msaTable.Rows[159][4] = "Vendor PN";
            msaTable.Rows[160][4] = "Vendor PN";
            msaTable.Rows[161][4] = "Vendor PN";
            msaTable.Rows[162][4] = "Vendor PN";
            msaTable.Rows[163][4] = "Vendor PN";
            msaTable.Rows[164][4] = "Vendor Rev";
            msaTable.Rows[165][4] = "Vendor Rev";
            msaTable.Rows[166][4] = "Vendor SN";
            msaTable.Rows[167][4] = "Vendor SN";
            msaTable.Rows[168][4] = "Vendor SN";
            msaTable.Rows[169][4] = "Vendor SN";
            msaTable.Rows[170][4] = "Vendor SN";
            msaTable.Rows[171][4] = "Vendor SN";
            msaTable.Rows[172][4] = "Vendor SN";
            msaTable.Rows[173][4] = "Vendor SN";
            msaTable.Rows[174][4] = "Vendor SN";
            msaTable.Rows[175][4] = "Vendor SN";
            msaTable.Rows[176][4] = "Vendor SN";
            msaTable.Rows[177][4] = "Vendor SN";
            msaTable.Rows[178][4] = "Vendor SN";
            msaTable.Rows[179][4] = "Vendor SN";
            msaTable.Rows[180][4] = "Vendor SN";
            msaTable.Rows[181][4] = "Vendor SN";
            msaTable.Rows[182][4] = "Date Code";
            msaTable.Rows[183][4] = "Date Code";
            msaTable.Rows[184][4] = "Date Code";
            msaTable.Rows[185][4] = "Date Code";
            msaTable.Rows[186][4] = "Date Code";
            msaTable.Rows[187][4] = "Date Code";
            msaTable.Rows[188][4] = "Date Code";
            msaTable.Rows[189][4] = "Date Code";
            msaTable.Rows[190][4] = "CLEI Code";
            msaTable.Rows[191][4] = "CLEI Code";
            msaTable.Rows[192][4] = "CLEI Code";
            msaTable.Rows[193][4] = "CLEI Code";
            msaTable.Rows[194][4] = "CLEI Code";
            msaTable.Rows[195][4] = "CLEI Code";
            msaTable.Rows[196][4] = "CLEI Code";
            msaTable.Rows[197][4] = "CLEI Code";
            msaTable.Rows[198][4] = "CLEI Code";
            msaTable.Rows[199][4] = "CLEI Code";
            msaTable.Rows[200][4] = "Module Power Characteristics";
            msaTable.Rows[201][4] = "Module Power Characteristics";
            msaTable.Rows[202][4] = "Cable assembly length";
            msaTable.Rows[203][4] = "Media Connector Type";
            msaTable.Rows[204][4] = "Copper Cable Attenuation";
            msaTable.Rows[205][4] = "Copper Cable Attenuation";
            msaTable.Rows[206][4] = "Copper Cable Attenuation";
            msaTable.Rows[207][4] = "Copper Cable Attenuation";
            msaTable.Rows[208][4] = "Copper Cable Attenuation";
            msaTable.Rows[209][4] = "Copper Cable Attenuation";
            msaTable.Rows[210][4] = "Cable Assembly Lane Information";
            msaTable.Rows[211][4] = "Cable Assembly Lane Information";
            msaTable.Rows[212][4] = "Media Interface Technology";
            msaTable.Rows[213][4] = "Reserved";
            msaTable.Rows[214][4] = "Reserved";
            msaTable.Rows[215][4] = "Reserved";
            msaTable.Rows[216][4] = "Reserved";
            msaTable.Rows[217][4] = "Reserved";
            msaTable.Rows[218][4] = "Reserved";
            msaTable.Rows[219][4] = "Reserved";
            msaTable.Rows[220][4] = "Reserved";
            msaTable.Rows[221][4] = "Custom";
            msaTable.Rows[222][4] = "Checksum";
            msaTable.Rows[223][4] = "User Custom Info NV";
            msaTable.Rows[224][4] = "User Custom Info NV";
            msaTable.Rows[225][4] = "User Custom Info NV";
            msaTable.Rows[226][4] = "User Custom Info NV";
            msaTable.Rows[227][4] = "User Custom Info NV";
            msaTable.Rows[228][4] = "User Custom Info NV";
            msaTable.Rows[229][4] = "User Custom Info NV";
            msaTable.Rows[230][4] = "User Custom Info NV";
            msaTable.Rows[231][4] = "User Custom Info NV";
            msaTable.Rows[232][4] = "User Custom Info NV";
            msaTable.Rows[233][4] = "User Custom Info NV";
            msaTable.Rows[234][4] = "User Custom Info NV";
            msaTable.Rows[235][4] = "User Custom Info NV";
            msaTable.Rows[236][4] = "User Custom Info NV";
            msaTable.Rows[237][4] = "User Custom Info NV";
            msaTable.Rows[238][4] = "User Custom Info NV";
            msaTable.Rows[239][4] = "User Custom Info NV";
            msaTable.Rows[240][4] = "User Custom Info NV";
            msaTable.Rows[241][4] = "User Custom Info NV";
            msaTable.Rows[242][4] = "User Custom Info NV";
            msaTable.Rows[243][4] = "User Custom Info NV";
            msaTable.Rows[244][4] = "User Custom Info NV";
            msaTable.Rows[245][4] = "User Custom Info NV";
            msaTable.Rows[246][4] = "User Custom Info NV";
            msaTable.Rows[247][4] = "User Custom Info NV";
            msaTable.Rows[248][4] = "User Custom Info NV";
            msaTable.Rows[249][4] = "User Custom Info NV";
            msaTable.Rows[250][4] = "User Custom Info NV";
            msaTable.Rows[251][4] = "User Custom Info NV";
            msaTable.Rows[252][4] = "User Custom Info NV";
            msaTable.Rows[253][4] = "User Custom Info NV";
            msaTable.Rows[254][4] = "User Custom Info NV";
            msaTable.Rows[255][4] = "User Custom Info NV";
            #endregion

            #region Page01
            msaTable.Rows[256][4] = "Module Hardware and Firmware major/minor revision codes"; //128
            msaTable.Rows[257][4] = "Module Hardware and Firmware major/minor revision codes";//129
            msaTable.Rows[258][4] = "Module Hardware and Firmware major/minor revision codes";//130
            msaTable.Rows[259][4] = "Module Hardware and Firmware major/minor revision codes";//131
            msaTable.Rows[260][4] = " link length SMF";//132
            msaTable.Rows[261][4] = " link length (OM5)";//133
            msaTable.Rows[262][4] = " link length (OM4)";//134
            msaTable.Rows[263][4] = " link length (OM3 50um)";//135
            msaTable.Rows[264][4] = " link length (OM2 50um)";//136
            msaTable.Rows[265][4] = " Reserved";//137
            msaTable.Rows[266][4] = " Nominal Wavelength";//138
            msaTable.Rows[267][4] = " Nominal Wavelength";//139
            msaTable.Rows[268][4] = " Wavelength Tolerance";//140
            msaTable.Rows[269][4] = " Wavelength Tolerance";//141
            msaTable.Rows[270][4] = " Implemented Management Interface features advertising ";//142
            msaTable.Rows[271][4] = " Implemented Management Interface features advertising ";//143
            msaTable.Rows[272][4] = " Implemented Management Interface features advertising ";//144
            msaTable.Rows[273][4] = " Module Characteristics advertising ";//145
            msaTable.Rows[274][4] = " Module Characteristics advertising ";//146
            msaTable.Rows[275][4] = " Module Characteristics advertising ";//147
            msaTable.Rows[276][4] = " Module Characteristics advertising ";//148
            msaTable.Rows[277][4] = " Module Characteristics advertising ";//149
            msaTable.Rows[278][4] = " Module Characteristics advertising  ";//150
            msaTable.Rows[279][4] = " Module Characteristics advertising ";//151
            msaTable.Rows[280][4] = " Module Characteristics advertising ";//152
            msaTable.Rows[281][4] = " Module Characteristics advertising ";//153
            msaTable.Rows[282][4] = " Module Characteristics advertising ";//154
            msaTable.Rows[283][4] = " Implemented Controls advertising";//155
            msaTable.Rows[284][4] = " Implemented Controls advertising";//156
            msaTable.Rows[285][4] = " Implemented Flags advertising";//157
            msaTable.Rows[286][4] = " Implemented Flags advertising";//158
            msaTable.Rows[287][4] = " Implemented Monitors advertising";//159
            msaTable.Rows[288][4] = " Implemented Monitors advertising";//160
            msaTable.Rows[289][4] = " Implemented Signal Integrity Controls advertising";//161
            msaTable.Rows[290][4] = " Implemented Signal Integrity Controls advertising";//162
            msaTable.Rows[291][4] = " Reserved";//163
            msaTable.Rows[292][4] = " Reserved";//164
            msaTable.Rows[293][4] = " Reserved";//165
            msaTable.Rows[294][4] = " Reserved";//166
            msaTable.Rows[295][4] = " Reserved";//167
            msaTable.Rows[296][4] = " Reserved";//168
            msaTable.Rows[297][4] = " Reserved";//169
            msaTable.Rows[298][4] = " Reserved";//170
            msaTable.Rows[299][4] = " Reserved";//171
            msaTable.Rows[300][4] = " Reserved";//172
            msaTable.Rows[301][4] = " Reserved";//173
            msaTable.Rows[302][4] = " Reserved";//174
            msaTable.Rows[303][4] = " Reserved";//175
            msaTable.Rows[304][4] = " Reserved";//176
            msaTable.Rows[305][4] = " Reserved";//177
            msaTable.Rows[306][4] = " Reserved";//178
            msaTable.Rows[307][4] = " Reserved";//179
            msaTable.Rows[308][4] = " Reserved";//180
            msaTable.Rows[309][4] = " Reserved";//181
            msaTable.Rows[310][4] = " Reserved";//182
            msaTable.Rows[311][4] = " Reserved";//183
            msaTable.Rows[312][4] = " Reserved";//184
            msaTable.Rows[313][4] = " Reserved";//185
            msaTable.Rows[314][4] = " Reserved";//186
            msaTable.Rows[315][4] = " Reserved";//187
            msaTable.Rows[316][4] = " Reserved";//188
            msaTable.Rows[317][4] = " Reserved";//189
            msaTable.Rows[318][4] = "Reserved";//190
            msaTable.Rows[319][4] = "Custom";//191
            msaTable.Rows[320][4] = "Custom";//192
            msaTable.Rows[321][4] = "Custom";//193
            msaTable.Rows[322][4] = "Custom";//194
            msaTable.Rows[323][4] = "Custom";//195
            msaTable.Rows[324][4] = "Custom";//196
            msaTable.Rows[325][4] = "Custom";//197
            msaTable.Rows[326][4] = "Custom";//198
            msaTable.Rows[327][4] = "Custom";//199
            msaTable.Rows[328][4] = "Custom";//200
            msaTable.Rows[329][4] = "Custom";//201
            msaTable.Rows[330][4] = "Custom";//202
            msaTable.Rows[331][4] = "Custom";//203
            msaTable.Rows[332][4] = "Custom";//204
            msaTable.Rows[333][4] = "Custom";//205
            msaTable.Rows[334][4] = "Custom";//206
            msaTable.Rows[335][4] = "Custom";//207
            msaTable.Rows[336][4] = "Custom";//208
            msaTable.Rows[337][4] = "Custom";//209
            msaTable.Rows[338][4] = "Custom";//210
            msaTable.Rows[339][4] = "Custom";//211
            msaTable.Rows[340][4] = "Custom";//212
            msaTable.Rows[341][4] = "Custom";//213
            msaTable.Rows[342][4] = "Custom";//214
            msaTable.Rows[343][4] = "Custom";//215
            msaTable.Rows[344][4] = "Custom";//216
            msaTable.Rows[345][4] = "Custom";//217
            msaTable.Rows[346][4] = "Custom";//218
            msaTable.Rows[347][4] = "Custom";//219
            msaTable.Rows[348][4] = "Custom";//220
            msaTable.Rows[349][4] = "Custom";//221
            msaTable.Rows[350][4] = "Custom";//222
            msaTable.Rows[351][4] = "Module Host-Media Interfaces Advertising Codes";//223
            msaTable.Rows[352][4] = "Module Host-Media Interfaces Advertising Codes ";//224
            msaTable.Rows[353][4] = "Module Host-Media Interfaces Advertising Codes ";//225
            msaTable.Rows[354][4] = "Module Host-Media Interfaces Advertising Codes ";//226
            msaTable.Rows[355][4] = "Module Host-Media Interfaces Advertising Codes ";//227
            msaTable.Rows[356][4] = "Module Host-Media Interfaces Advertising Codes ";//228
            msaTable.Rows[357][4] = "Module Host-Media Interfaces Advertising Codes ";//229
            msaTable.Rows[358][4] = "Module Host-Media Interfaces Advertising Codes ";//230
            msaTable.Rows[359][4] = "Module Host-Media Interfaces Advertising Codes ";//231
            msaTable.Rows[360][4] = "Module Host-Media Interfaces Advertising Codes ";//232
            msaTable.Rows[361][4] = "Module Host-Media Interfaces Advertising Codes ";//233
            msaTable.Rows[362][4] = "Module Host-Media Interfaces Advertising Codes ";//234
            msaTable.Rows[363][4] = "Module Host-Media Interfaces Advertising Codes ";//235
            msaTable.Rows[364][4] = "Module Host-Media Interfaces Advertising Codes ";//236
            msaTable.Rows[365][4] = "Module Host-Media Interfaces Advertising Codes ";//237
            msaTable.Rows[366][4] = "Module Host-Media Interfaces Advertising Codes ";//238
            msaTable.Rows[367][4] = "Module Host-Media Interfaces Advertising Codes ";//239
            msaTable.Rows[368][4] = "Module Host-Media Interfaces Advertising Codes ";//240
            msaTable.Rows[369][4] = "Module Host-Media Interfaces Advertising Codes ";//241
            msaTable.Rows[370][4] = "Module Host-Media Interfaces Advertising Codes ";//242
            msaTable.Rows[371][4] = "Module Host-Media Interfaces Advertising Codes ";//243
            msaTable.Rows[372][4] = "Module Host-Media Interfaces Advertising Codes ";//244
            msaTable.Rows[373][4] = "Module Host-Media Interfaces Advertising Codes ";//245
            msaTable.Rows[374][4] = "Module Host-Media Interfaces Advertising Codes ";//246
            msaTable.Rows[375][4] = "Module Host-Media Interfaces Advertising Codes ";//247
            msaTable.Rows[376][4] = "Module Host-Media Interfaces Advertising Codes ";//248
            msaTable.Rows[377][4] = "Module Host-Media Interfaces Advertising Codes ";//249
            msaTable.Rows[378][4] = "Module Host-Media Interfaces Advertising Codes ";//250
            msaTable.Rows[379][4] = "Reserved ";//251
            msaTable.Rows[380][4] = "Reserved ";//252
            msaTable.Rows[381][4] = "Reserved ";//253
            msaTable.Rows[382][4] = "Reserved ";//254
            msaTable.Rows[383][4] = "Checksum";//255
            #endregion

            #region Page02

            msaTable.Rows[384][4] = "Temperature monitor high alarm threshold MSB"; //128
            msaTable.Rows[385][4] = "Temperature monitor high alarm threshold LSB";//129
            msaTable.Rows[386][4] = "Temperature monitor low alarm threshold MSB";//130
            msaTable.Rows[387][4] = "Temperature monitor low alarm threshold LSB";//131
            msaTable.Rows[388][4] = "Temperature monitor high warning threshold MSB";//132
            msaTable.Rows[389][4] = "Temperature monitor high warning threshold LSB";//133
            msaTable.Rows[390][4] = "Temperature monitor low warning threshold MSB";//134
            msaTable.Rows[391][4] = "Temperature monitor low warning threshold LSB";//135
            msaTable.Rows[392][4] = "Supply 3.3-volt monitor high alarm threshold MSB";//136
            msaTable.Rows[393][4] = "Supply 3.3-volt monitor high alarm threshold LSB";//137
            msaTable.Rows[394][4] = "Supply 3.3-volt monitor low alarm threshold MSB";//138
            msaTable.Rows[395][4] = "Supply 3.3-volt monitor low alarm threshold LSB";//139
            msaTable.Rows[396][4] = "Supply 3.3-volt monitor high warning threshold MSB";//140
            msaTable.Rows[397][4] = "Supply 3.3-volt monitor high warning threshold LSB";//141
            msaTable.Rows[398][4] = "Supply 3.3-volt monitor low warning threshold MSB";//142
            msaTable.Rows[399][4] = "Supply 3.3-volt monitor low warning threshold LSB";//143
            msaTable.Rows[400][4] = "Aux 1 monitor high alarm threshold MSB";//144
            msaTable.Rows[401][4] = "Aux 1 monitor high alarm threshold LSB";//145
            msaTable.Rows[402][4] = "Aux 1 monitor low alarm threshold MSB";//146
            msaTable.Rows[403][4] = "Aux 1 monitor low alarm threshold LSB";//147
            msaTable.Rows[404][4] = "Aux 1 monitor high warning threshold MSB";//148
            msaTable.Rows[405][4] = "Aux 1 monitor high warning threshold LSB";//149
            msaTable.Rows[406][4] = "Aux 1 monitor low warning threshold MSB";//150
            msaTable.Rows[407][4] = "Aux 1 monitor low warning threshold LSB";//151
            msaTable.Rows[408][4] = "Aux 2 monitor high alarm threshold MSB";//152
            msaTable.Rows[409][4] = "Aux 2 monitor high alarm threshold LSB";//153
            msaTable.Rows[410][4] = "Aux 2 monitor low alarm threshold MSB";//154
            msaTable.Rows[411][4] = "Aux 2 monitor low alarm threshold LSB";//155
            msaTable.Rows[412][4] = "Aux 2 monitor high warning threshold MSB";//156
            msaTable.Rows[413][4] = "Aux 2 monitor high warning threshold LSB";//157
            msaTable.Rows[414][4] = "Aux 2 monitor low warning threshold MSB";//158
            msaTable.Rows[415][4] = "Aux 2 monitor low warning threshold LSB";//159
            msaTable.Rows[416][4] = "Aux 3 monitor high alarm threshold MSB";//160
            msaTable.Rows[417][4] = "Aux 3 monitor high alarm threshold LSB";//161
            msaTable.Rows[418][4] = "Aux 3 monitor low alarm threshold MSB";//162
            msaTable.Rows[419][4] = "Aux 3 monitor low alarm threshold LSB";//163
            msaTable.Rows[420][4] = "Aux 3 monitor high warning threshold MSB";//164
            msaTable.Rows[421][4] = "Aux 3 monitor high warning threshold LSB";//165
            msaTable.Rows[422][4] = "Aux 3 monitor low warning threshold MSB";//166
            msaTable.Rows[423][4] = "Aux 3 monitor low warning threshold LSB";//167
            msaTable.Rows[424][4] = "Custom monitor high alarm threshold MSB";//168
            msaTable.Rows[425][4] = "Custom monitor high alarm threshold LSB";//169
            msaTable.Rows[426][4] = "Custom monitor low alarm threshold MSB";//170
            msaTable.Rows[427][4] = "Custom monitor low alarm threshold LSB";//171
            msaTable.Rows[428][4] = "Custom monitor high warning threshold MSB";//172
            msaTable.Rows[429][4] = "Custom monitor high warning threshold LSB";//173
            msaTable.Rows[430][4] = "Custom monitor low warning threshold MSB";//174
            msaTable.Rows[431][4] = "Custom monitor low warning threshold LSB";//175
            msaTable.Rows[432][4] = "Tx optical power monitor high alarm threshold MSB";//176
            msaTable.Rows[433][4] = "Tx optical power monitor high alarm threshold LSB";//177
            msaTable.Rows[434][4] = "Tx optical power monitor low alarm threshold MSB";//178
            msaTable.Rows[435][4] = "Tx optical power monitor low alarm threshold LSB";//179
            msaTable.Rows[436][4] = "Tx optical power high warning threshold MSB";//180
            msaTable.Rows[437][4] = "Tx optical power high warning threshold LSB";//181
            msaTable.Rows[438][4] = "Tx optical power low warning threshold MSB";//182
            msaTable.Rows[439][4] = "Tx optical power low warning threshold LSB";//183
            msaTable.Rows[440][4] = "Tx bias current monitor high alarm threshold MSB";//184
            msaTable.Rows[441][4] = "Tx bias current monitor high alarm threshold LSB";//185
            msaTable.Rows[442][4] = "Tx bias current monitor low alarm threshold MSB";//186
            msaTable.Rows[443][4] = "Tx bias current monitor low alarm threshold LSB";//187
            msaTable.Rows[444][4] = "Tx bias current high warning threshold MSB";//188
            msaTable.Rows[445][4] = "Tx bias current high warning threshold LSB";//189
            msaTable.Rows[446][4] = "Tx bias current low warning threshold MSB";///190
            msaTable.Rows[447][4] = "Tx bias current low warning threshold LSB";///191
            msaTable.Rows[448][4] = "Rx optical power monitor high alarm threshold MSB";//192
            msaTable.Rows[449][4] = "Rx optical power monitor high alarm threshold LSB";//193
            msaTable.Rows[450][4] = "Rx optical power monitor low alarm threshold MSB";//194
            msaTable.Rows[451][4] = "Rx optical power monitor low alarm threshold LSB";//195
            msaTable.Rows[452][4] = "Rx optical power monitor high warning threshold MSB";//196
            msaTable.Rows[453][4] = "Rx optical power monitor high warning threshold LSB";//197
            msaTable.Rows[454][4] = "Rx optical power monitor low warning threshold MSB";//198
            msaTable.Rows[455][4] = "Rx optical power monitor low warning threshold LSB";//199
            msaTable.Rows[456][4] = "Reserved";//200
            msaTable.Rows[457][4] = "Reserved";//201
            msaTable.Rows[458][4] = "Reserved";//202
            msaTable.Rows[459][4] = "Reserved";//203
            msaTable.Rows[460][4] = "Reserved";//204
            msaTable.Rows[461][4] = "Reserved";//205
            msaTable.Rows[462][4] = "Reserved";//206
            msaTable.Rows[463][4] = "Reserved";//207
            msaTable.Rows[464][4] = "Reserved";//208
            msaTable.Rows[465][4] = "Reserved";//209
            msaTable.Rows[466][4] = "Reserved";//210
            msaTable.Rows[467][4] = "Reserved";//211
            msaTable.Rows[468][4] = "Reserved";//212
            msaTable.Rows[469][4] = "Reserved";//213
            msaTable.Rows[470][4] = "Reserved";//214
            msaTable.Rows[471][4] = "Reserved";//215
            msaTable.Rows[472][4] = "Reserved";//216
            msaTable.Rows[473][4] = "Reserved";//217
            msaTable.Rows[474][4] = "Reserved";//218
            msaTable.Rows[475][4] = "Reserved";//219
            msaTable.Rows[476][4] = "Reserved";//220
            msaTable.Rows[477][4] = "Reserved";//221
            msaTable.Rows[478][4] = "Reserved";//222
            msaTable.Rows[479][4] = "Reserved";//223
            msaTable.Rows[480][4] = "Reserved";//224
            msaTable.Rows[481][4] = "Reserved";//225
            msaTable.Rows[482][4] = "Reserved";//226
            msaTable.Rows[483][4] = "Reserved";//227
            msaTable.Rows[484][4] = "Reserved";//228
            msaTable.Rows[485][4] = "Reserved";//229
            msaTable.Rows[486][4] = "Customizable space";//230
            msaTable.Rows[487][4] = "Customizable space";//231
            msaTable.Rows[488][4] = "Customizable space";//232
            msaTable.Rows[489][4] = "Customizable space";//233
            msaTable.Rows[490][4] = "Customizable space";//234
            msaTable.Rows[491][4] = "Customizable space";//235
            msaTable.Rows[492][4] = "Customizable space";//236
            msaTable.Rows[493][4] = "Customizable space";//237
            msaTable.Rows[494][4] = "Customizable space";//238
            msaTable.Rows[495][4] = "Customizable space";//239
            msaTable.Rows[496][4] = "Customizable space";//240
            msaTable.Rows[497][4] = "Customizable space";//241
            msaTable.Rows[498][4] = "Customizable space";//242
            msaTable.Rows[499][4] = "Customizable space";//243
            msaTable.Rows[500][4] = "Customizable space";//244
            msaTable.Rows[501][4] = "Customizable space";//245
            msaTable.Rows[502][4] = "Customizable space";//246
            msaTable.Rows[503][4] = "Customizable space";//247
            msaTable.Rows[504][4] = "Customizable space";//248
            msaTable.Rows[505][4] = "Customizable space";//249
            msaTable.Rows[506][4] = "Customizable space";//250
            msaTable.Rows[507][4] = "Customizable space";//251
            msaTable.Rows[508][4] = "Customizable space";//252
            msaTable.Rows[509][4] = "Customizable space";//253
            msaTable.Rows[510][4] = "Customizable space";//254 
            msaTable.Rows[511][4] = "Checksum";//255   
            #endregion

            #region Page03

            msaTable.Rows[512][4] = "User EEPROM NVR";//128
            msaTable.Rows[513][4] = "Thermal load mode Select";//129
            msaTable.Rows[514][4] = "Target temperature";//130
            msaTable.Rows[515][4] = "User EEPROM NVR";//131
            msaTable.Rows[516][4] = "Insertion Counter MSB";//132
            msaTable.Rows[517][4] = "Insertion Counter LSB";//133
            msaTable.Rows[518][4] = "Cut-Off temperature";//134
            msaTable.Rows[519][4] = "power controller 1";//135
            msaTable.Rows[520][4] = "power controller 2";//136
            msaTable.Rows[521][4] = "PWM controller 3";//137
            msaTable.Rows[522][4] = "PWM controller 4";//138
            msaTable.Rows[523][4] = "Digital state detection";//139
            msaTable.Rows[524][4] = "Digital Control of IntL";//140
            msaTable.Rows[525][4] = "User EEPROM NVR";//141
            msaTable.Rows[526][4] = "User EEPROM NVR";//142
            msaTable.Rows[527][4] = "User EEPROM NVR";//143
            msaTable.Rows[528][4] = "User EEPROM NVR";//144
            msaTable.Rows[529][4] = "User EEPROM NVR";//145
            msaTable.Rows[530][4] = "User EEPROM NVR";//146
            msaTable.Rows[531][4] = "User EEPROM NVR";//147
            msaTable.Rows[532][4] = "User EEPROM NVR";//148
            msaTable.Rows[533][4] = "User EEPROM NVR";//149
            msaTable.Rows[534][4] = "User EEPROM NVR";//150
            msaTable.Rows[535][4] = "User EEPROM NVR";//151
            msaTable.Rows[536][4] = "Internally measured module temperature 2 MSB";//152
            msaTable.Rows[537][4] = "Internally measured module temperature 2 LSB";//153
            msaTable.Rows[538][4] = "Internally measured module temperature 4 MSB";//154
            msaTable.Rows[539][4] = "Internally measured module temperature 4 LSB";//155
            msaTable.Rows[540][4] = "User EEPROM NVR";//156
            msaTable.Rows[541][4] = "User EEPROM NVR";//157
            msaTable.Rows[542][4] = "User EEPROM NVR";//158
            msaTable.Rows[543][4] = "User EEPROM NVR";//159
            msaTable.Rows[544][4] = "User EEPROM NVR";//160
            msaTable.Rows[545][4] = "User EEPROM NVR";//161
            msaTable.Rows[546][4] = "User EEPROM NVR";//162
            msaTable.Rows[547][4] = "User EEPROM NVR";//163
            msaTable.Rows[548][4] = "User EEPROM NVR";//164
            msaTable.Rows[549][4] = "User EEPROM NVR";//165
            msaTable.Rows[550][4] = "User EEPROM NVR";//166
            msaTable.Rows[551][4] = "User EEPROM NVR";//167
            msaTable.Rows[552][4] = "User EEPROM NVR";//168
            msaTable.Rows[553][4] = "User EEPROM NVR";//169
            msaTable.Rows[554][4] = "User EEPROM NVR";//170
            msaTable.Rows[555][4] = "User EEPROM NVR";//171
            msaTable.Rows[556][4] = "User EEPROM NVR";//172
            msaTable.Rows[557][4] = "User EEPROM NVR";//173
            msaTable.Rows[558][4] = "User EEPROM NVR";//174
            msaTable.Rows[559][4] = "User EEPROM NVR";//175
            msaTable.Rows[560][4] = "User EEPROM NVR";//176
            msaTable.Rows[561][4] = "User EEPROM NVR";//177
            msaTable.Rows[562][4] = "User EEPROM NVR";//178
            msaTable.Rows[563][4] = "User EEPROM NVR";//179
            msaTable.Rows[564][4] = "User EEPROM NVR";//180
            msaTable.Rows[565][4] = "User EEPROM NVR";//181
            msaTable.Rows[566][4] = "User EEPROM NVR";//182
            msaTable.Rows[567][4] = "User EEPROM NVR";//183
            msaTable.Rows[568][4] = "User EEPROM NVR";//184
            msaTable.Rows[569][4] = "User EEPROM NVR";//185
            msaTable.Rows[570][4] = "User EEPROM NVR";//186
            msaTable.Rows[571][4] = "User EEPROM NVR";//187
            msaTable.Rows[572][4] = "User EEPROM NVR";//188
            msaTable.Rows[573][4] = "User EEPROM NVR";//189
            msaTable.Rows[574][4] = "User EEPROM NVR";//190
            msaTable.Rows[575][4] = "User EEPROM NVR";//191
            msaTable.Rows[576][4] = "User EEPROM NVR";//192
            msaTable.Rows[577][4] = "User EEPROM NVR";//193
            msaTable.Rows[578][4] = "User EEPROM NVR";//194
            msaTable.Rows[579][4] = "User EEPROM NVR";//195
            msaTable.Rows[580][4] = "User EEPROM NVR";//196
            msaTable.Rows[581][4] = "User EEPROM NVR";//197
            msaTable.Rows[582][4] = "User EEPROM NVR";//198
            msaTable.Rows[583][4] = "User EEPROM NVR";//199
            msaTable.Rows[584][4] = "User EEPROM NVR";//200
            msaTable.Rows[585][4] = "User EEPROM NVR";//201
            msaTable.Rows[586][4] = "User EEPROM NVR";//202
            msaTable.Rows[587][4] = "User EEPROM NVR";//203
            msaTable.Rows[588][4] = "User EEPROM NVR";//204
            msaTable.Rows[589][4] = "User EEPROM NVR";//205
            msaTable.Rows[590][4] = "User EEPROM NVR";//206
            msaTable.Rows[591][4] = "User EEPROM NVR";//207
            msaTable.Rows[592][4] = "User EEPROM NVR";//208
            msaTable.Rows[593][4] = "User EEPROM NVR";//209
            msaTable.Rows[594][4] = "User EEPROM NVR";//210
            msaTable.Rows[595][4] = "User EEPROM NVR";//211
            msaTable.Rows[596][4] = "User EEPROM NVR";//212
            msaTable.Rows[597][4] = "User EEPROM NVR";//213
            msaTable.Rows[598][4] = "User EEPROM NVR";//214
            msaTable.Rows[599][4] = "User EEPROM NVR";//215
            msaTable.Rows[600][4] = "User EEPROM NVR";//216
            msaTable.Rows[601][4] = "User EEPROM NVR";//217
            msaTable.Rows[602][4] = "User EEPROM NVR";//218
            msaTable.Rows[603][4] = "User EEPROM NVR";//219
            msaTable.Rows[604][4] = "User EEPROM NVR";//220
            msaTable.Rows[605][4] = "User EEPROM NVR";//221
            msaTable.Rows[606][4] = "User EEPROM NVR";//222
            msaTable.Rows[607][4] = "User EEPROM NVR";//223
            msaTable.Rows[608][4] = "User EEPROM NVR";//224
            msaTable.Rows[609][4] = "User EEPROM NVR";//225
            msaTable.Rows[610][4] = "User EEPROM NVR";//226
            msaTable.Rows[611][4] = "User EEPROM NVR";//227
            msaTable.Rows[612][4] = "User EEPROM NVR";//228
            msaTable.Rows[613][4] = "User EEPROM NVR";//229
            msaTable.Rows[614][4] = "User EEPROM NVR";//230
            msaTable.Rows[615][4] = "User EEPROM NVR";//231
            msaTable.Rows[616][4] = "User EEPROM NVR";//232
            msaTable.Rows[617][4] = "User EEPROM NVR";//233
            msaTable.Rows[618][4] = "User EEPROM NVR";//234
            msaTable.Rows[619][4] = "User EEPROM NVR";//235
            msaTable.Rows[620][4] = "User EEPROM NVR";//236
            msaTable.Rows[621][4] = "User EEPROM NVR";//237
            msaTable.Rows[622][4] = "User EEPROM NVR";//238
            msaTable.Rows[623][4] = "User EEPROM NVR";//239
            msaTable.Rows[624][4] = "User EEPROM NVR";//240
            msaTable.Rows[625][4] = "User EEPROM NVR";//241
            msaTable.Rows[626][4] = "User EEPROM NVR";//242
            msaTable.Rows[627][4] = "User EEPROM NVR";//243
            msaTable.Rows[628][4] = "User EEPROM NVR";//244
            msaTable.Rows[629][4] = "User EEPROM NVR";//245
            msaTable.Rows[630][4] = "User EEPROM NVR";//246
            msaTable.Rows[631][4] = "User EEPROM NVR";//247
            msaTable.Rows[632][4] = "User EEPROM NVR";//248
            msaTable.Rows[633][4] = "User EEPROM NVR";//249
            msaTable.Rows[634][4] = "User EEPROM NVR";//250
            msaTable.Rows[635][4] = "User EEPROM NVR";//251
            msaTable.Rows[636][4] = "User EEPROM NVR";//252
            msaTable.Rows[637][4] = "User EEPROM NVR";//253
            msaTable.Rows[638][4] = "User EEPROM NVR";//254 
            msaTable.Rows[639][4] = "User EEPROM NVR";//255

            #endregion
            msaGrid.AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode.AllCells;
        }
        public void msaGrid_CellValueChanged(object sender, System.Windows.Forms.DataGridViewCellEventArgs e)
        {
            msaTable.Rows[e.RowIndex][e.ColumnIndex] = msaGrid[e.ColumnIndex, e.RowIndex].Value.ToString();  //.Rows[e.RowIndex , 1];
            if (e.ColumnIndex == 1)
            {
                msaGrid[2, e.RowIndex].Value = int.Parse(msaTable.Rows[e.RowIndex][e.ColumnIndex].ToString(), System.Globalization.NumberStyles.HexNumber);
                msaGrid[3, e.RowIndex].Value = Convert.ToChar(int.Parse(msaTable.Rows[e.RowIndex][e.ColumnIndex].ToString(), System.Globalization.NumberStyles.HexNumber));

                if (!softwarePause)   //softwarePause= true is to indicate that the thread is already paused so no need to pause/resume in the listener of the MSA table=> avoid 640 pause/resume 
                {
                    PauseMonitor();
                }
                int row = 0;
                row = e.RowIndex;

                if ((row % 128 == 0) && (row != 0))  //test done on the row inorder to know if we need to change the page
                {
                    msaManager.I2CWrite(127, (row / 128) - 1);
                }

                msaManager.I2CWrite(row < 128 ? row : row % 128 + 128, msaManager.StringIntoValue(msaGrid[1, row].Value.ToString()));
                if (!softwarePause)
                {
                    ResumeMonitor();
                }
            }
        }
        public void FillMSADescription2()
        {
            #region Page10h
            msaTable2.Rows[0][4] = "Data Path Power Control";
            msaTable2.Rows[1][4] = "Tx Input Polarity Flip";
            msaTable2.Rows[2][4] = "Tx Output Disable";
            msaTable2.Rows[3][4] = "Tx Squelch Disable";
            msaTable2.Rows[4][4] = "Tx Force Squelch";
            msaTable2.Rows[5][4] = "Reserved";
            msaTable2.Rows[6][4] = "Tx Input Equalization Adaptation Freeze";
            msaTable2.Rows[7][4] = "Tx Input Equalization Adaptation Store";
            msaTable2.Rows[8][4] = "Tx Input Equalization Adaptation Store";
            msaTable2.Rows[9][4] = "Rx Output Polarity Flip";
            msaTable2.Rows[10][4] = "Rx Output Disable";
            msaTable2.Rows[11][4] = "Rx Squelch Disable";
            msaTable2.Rows[12][4] = "Reserved";
            msaTable2.Rows[13][4] = "Reserved";
            msaTable2.Rows[14][4] = "Reserved";
            msaTable2.Rows[15][4] = "Staged Set 0 Apply Data Init";
            msaTable2.Rows[16][4] = "Staged Set 0 Apply Immediate";
            msaTable2.Rows[17][4] = "Set 0 Application Select Controls Lane1";
            msaTable2.Rows[18][4] = "Set 0 Application Select Controls Lane2";
            msaTable2.Rows[19][4] = "Set 0 Application Select Controls Lane3";
            msaTable2.Rows[20][4] = "Set 0 Application Select Controls Lane4";
            msaTable2.Rows[21][4] = "Set 0 Application Select Controls Lane5";
            msaTable2.Rows[22][4] = "Set 0 Application Select Controls Lane6";
            msaTable2.Rows[23][4] = "Set 0 Application Select Controls Lane7";
            msaTable2.Rows[24][4] = "Set 0 Application Select Controls Lane8";
            msaTable2.Rows[25][4] = "Staged Set 0 Tx Adaptive Input Equalization Enable";
            msaTable2.Rows[26][4] = "Staged Set 0 Tx Adaptive Input Equalization Recall";
            msaTable2.Rows[27][4] = "Staged Set 0 Tx Adaptive Input Equalization Recall";
            msaTable2.Rows[28][4] = "Staged Set 0 Tx Input Equalization Control";
            msaTable2.Rows[29][4] = "Staged Set 0 Tx Input Equalization Control";
            msaTable2.Rows[30][4] = "Staged Set 0 Tx Input Equalization Control";
            msaTable2.Rows[31][4] = "Staged Set 0 Tx Input Equalization Control";
            msaTable2.Rows[32][4] = "Staged Set 0 Tx CDR Bypass Control";
            msaTable2.Rows[33][4] = "Staged Set 0 Rx CDR Bypass Control";
            msaTable2.Rows[34][4] = "Staged Set 0 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[35][4] = "Staged Set 0 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[36][4] = "Staged Set 0 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[37][4] = "Staged Set 0 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[38][4] = "Staged Set 0 Rx Output Equalization Post-Tap";
            msaTable2.Rows[39][4] = "Staged Set 0 Rx Output Equalization Post-Tap";
            msaTable2.Rows[40][4] = "Staged Set 0 Rx Output Equalization Post-Tap";
            msaTable2.Rows[41][4] = "Staged Set 0 Rx Output Equalization Post-Tap";
            msaTable2.Rows[42][4] = "Staged Set 0 Rx Output Amplitude Control";
            msaTable2.Rows[43][4] = "Staged Set 0 Rx Output Amplitude Control";
            msaTable2.Rows[44][4] = "Staged Set 0 Rx Output Amplitude Control";
            msaTable2.Rows[45][4] = "Staged Set 0 Rx Output Amplitude Control";
            msaTable2.Rows[46][4] = "Reserved";
            msaTable2.Rows[47][4] = "Reserved";
            msaTable2.Rows[48][4] = "Reserved";
            msaTable2.Rows[49][4] = "Reserved";
            msaTable2.Rows[50][4] = "Staged Set 1 Apply Data Init";
            msaTable2.Rows[51][4] = "Staged Set 1 Apply Immediate";
            msaTable2.Rows[52][4] = "Set 1 Application Select Controls Lane1";
            msaTable2.Rows[53][4] = "Set 1 Application Select Controls Lane2";
            msaTable2.Rows[54][4] = "Set 1 Application Select Controls Lane3";
            msaTable2.Rows[55][4] = "Set 1 Application Select Controls Lane4";
            msaTable2.Rows[56][4] = "Set 1 Application Select Controls Lane5";
            msaTable2.Rows[57][4] = "Set 1 Application Select Controls Lane6";
            msaTable2.Rows[58][4] = "Set 1 Application Select Controls Lane7";
            msaTable2.Rows[59][4] = "Set 1 Application Select Controls Lane8";
            msaTable2.Rows[60][4] = "Staged Set 1 Tx Adaptive Input Equalization Enable";
            msaTable2.Rows[61][4] = "Staged Set 1 Tx Adaptive Input Equalization Recall";
            msaTable2.Rows[62][4] = "Staged Set 1 Tx Adaptive Input Equalization Recall";
            msaTable2.Rows[63][4] = "Staged Set 1 Tx Input Equalization Control";
            msaTable2.Rows[64][4] = "Staged Set 1 Tx Input Equalization Control";
            msaTable2.Rows[65][4] = "Staged Set 1 Tx Input Equalization Control";
            msaTable2.Rows[66][4] = "Staged Set 1 Tx Input Equalization Control";
            msaTable2.Rows[67][4] = "Staged Set 1 Tx CDR Bypass Control";
            msaTable2.Rows[68][4] = "Staged Set 1 Rx CDR Bypass Control";
            msaTable2.Rows[69][4] = "Staged Set 1 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[70][4] = "Staged Set 1 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[71][4] = "Staged Set 1 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[72][4] = "Staged Set 1 Rx Output Equalization Pre-Tap";
            msaTable2.Rows[73][4] = "Staged Set 1 Rx Output Equalization Post-Tap";
            msaTable2.Rows[74][4] = "Staged Set 1 Rx Output Equalization Post-Tap";
            msaTable2.Rows[75][4] = "Staged Set 1 Rx Output Equalization Post-Tap";
            msaTable2.Rows[76][4] = "Staged Set 1 Rx Output Equalization Post-Tap";
            msaTable2.Rows[77][4] = "Staged Set 1 Rx Output Amplitude Control";
            msaTable2.Rows[78][4] = "Staged Set 1 Rx Output Amplitude Control";
            msaTable2.Rows[79][4] = "Staged Set 1 Rx Output Amplitude Control";
            msaTable2.Rows[80][4] = "Staged Set 1 Rx Output Amplitude Control";
            msaTable2.Rows[81][4] = "Reserved";
            msaTable2.Rows[82][4] = "Reserved";
            msaTable2.Rows[83][4] = "Reserved";
            msaTable2.Rows[84][4] = "Reserved";
            msaTable2.Rows[85][4] = "State Change flag mask";
            msaTable2.Rows[86][4] = "Tx Fault flag mask";
            msaTable2.Rows[87][4] = "Tx LOS flag mask";
            msaTable2.Rows[88][4] = "Tx CDR LOL flag mask";
            msaTable2.Rows[89][4] = "Tx Adaptive Eq Fault flag mask ";
            msaTable2.Rows[90][4] = "Tx Power High alarm flag mask";
            msaTable2.Rows[91][4] = "Tx Power Low alarm flag mask";
            msaTable2.Rows[92][4] = "Tx Power High  Warning flag mask";
            msaTable2.Rows[93][4] = "Tx Power Low  Warning flag mask";
            msaTable2.Rows[94][4] = "Tx Bias High Alarm flag mask";
            msaTable2.Rows[95][4] = "Tx Bias Low Alarm flag mask";
            msaTable2.Rows[96][4] = "Tx Bias High Warning flag mask";
            msaTable2.Rows[97][4] = "Tx Bias Low Warning flag mask";
            msaTable2.Rows[98][4] = "Rx LOS flag mask";
            msaTable2.Rows[99][4] = "Rx CDR LOL flag mask";
            msaTable2.Rows[100][4] = "Rx Power High alarm flag mask";
            msaTable2.Rows[101][4] = "Rx Power Low alarm flag mask";
            msaTable2.Rows[102][4] = "Rx Power High  Warning flag mask";
            msaTable2.Rows[103][4] = "Rx Power Low  Warning flag mask";
            msaTable2.Rows[104][4] = "Reserved";
            msaTable2.Rows[105][4] = "Reserved";
            msaTable2.Rows[106][4] = "Reserved";
            msaTable2.Rows[107][4] = "Reserved";
            msaTable2.Rows[108][4] = "Reserved";
            msaTable2.Rows[109][4] = "Reserved";
            msaTable2.Rows[110][4] = "Reserved";
            msaTable2.Rows[111][4] = "Reserved";
            msaTable2.Rows[112][4] = "Custom";
            msaTable2.Rows[113][4] = "Custom";
            msaTable2.Rows[114][4] = "Custom";
            msaTable2.Rows[115][4] = "Custom";
            msaTable2.Rows[116][4] = "Custom";
            msaTable2.Rows[117][4] = "Custom";
            msaTable2.Rows[118][4] = "Custom";
            msaTable2.Rows[119][4] = "Custom";
            msaTable2.Rows[120][4] = "Custom";
            msaTable2.Rows[121][4] = "Custom";
            msaTable2.Rows[122][4] = "Custom";
            msaTable2.Rows[123][4] = "Custom";
            msaTable2.Rows[124][4] = "Custom";
            msaTable2.Rows[125][4] = "Custom";
            msaTable2.Rows[126][4] = "Custom";
            msaTable2.Rows[127][4] = "Custom";

            #endregion
            msaGrid2.AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode.AllCells;
        }
        public void msaGrid2_CellValueChanged(object sender, System.Windows.Forms.DataGridViewCellEventArgs e)
        {
            msaTable2.Rows[e.RowIndex][e.ColumnIndex] = msaGrid2[e.ColumnIndex, e.RowIndex].Value.ToString();  //.Rows[e.RowIndex , 1];
            if (e.ColumnIndex == 1)
            {
                msaGrid2[2, e.RowIndex].Value = int.Parse(msaTable2.Rows[e.RowIndex][e.ColumnIndex].ToString(), System.Globalization.NumberStyles.HexNumber);
                msaGrid2[3, e.RowIndex].Value = Convert.ToChar(int.Parse(msaTable2.Rows[e.RowIndex][e.ColumnIndex].ToString(), System.Globalization.NumberStyles.HexNumber));

                if (!softwarePause)   //softwarePause= true is to indicate that the thread is already paused so no need to pause/resume in the listener of the MSA table=> avoid 640 pause/resume 
                {
                    PauseMonitor();
                }
                int row = 0;
                row = e.RowIndex;


                msaManager.I2CWrite(127, 16);


                msaManager.I2CWrite(row + 128, msaManager.StringIntoValue(msaGrid2[1, row].Value.ToString()));
                if (!softwarePause)
                {
                    ResumeMonitor();
                }
            }
        }

        private void b_ReadSingleByte_Click(object sender, RoutedEventArgs e)
        {

            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }

            PauseMonitor();

            byte DecAddr;
            byte[] Data = new byte[1] { 0 };

            string str = tb_ByteAddressDecimal.Text;
            if (!msaManager.VerifyAddress(ref str))
            {
                tb_ByteAddressDecimal.Text = "";
                MessageBox.Show("Error: Address Required (0 to 255)");
            }
            else
            {
                PauseMonitor();
                //msaManager.I2CWrite(127, MemPage); //write the Mempage, which means to select the page we want to read and write to it
                Thread.Sleep(100);
                DecAddr = Convert.ToByte(Convert.ToInt32(tb_ByteAddressDecimal.Text));  // the byte address is in decimal format so we convert it to hex base 16

                Data = msaManager.I2CRead(DecAddr);
                Thread.Sleep(100);
                tb_SingleByteHexadecimal.Text = Data[0].ToString("X2");  //hexadecimal display of the data

                //tb_SingleByteMEmoryContentbinary.Text = Convert.ToString(Data, 2).PadLeft(8, Convert.ToChar("0"));   //binary format of the data

                tb_SingleByteMEmoryContentbinary.Text = msaManager.hex2binary(tb_SingleByteHexadecimal.Text).PadLeft(8, Convert.ToChar("0")); //binary format of the data

                int val1 = msaManager.StringIntoValue(tb_SingleByteHexadecimal.Text);
                tb_SingleByteASCII.textBox.Text = Convert.ToChar(val1).ToString();//ASCII representation of the data
            }
            ResumeMonitor();

        }
        void DoEvents()
        {
            DispatcherFrame f = new DispatcherFrame();
            Dispatcher.CurrentDispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.Normal, (SendOrPostCallback)delegate(object arg)
            {
                DispatcherFrame fr = arg as DispatcherFrame;
                fr.Continue = false;
            }, f);
            Dispatcher.PushFrame(f);
        }
        private void PauseMonitor()
        {
            requestSleep = true;
            while (!threadIsSleep)
            {
                DoEvents();
            };
        }
        public void ResumeMonitor()
        {
            requestSleep = false;
            threadIsSleep = false;
        }
        public void Initialize()
        {
            try
            {
                if (BoardID == 4062)
                {
                    //msaManager.SelectModule();

                    //b_refreshControls2_Click(null, null);
                    //b_RefreshInterrupt_Click(null, null);
                    //b_RefreshIdentification_Click_1(null, null);
                    ////  b_RefreshRdWr_Click(null, null);
                    //// b_RefreshHFRD_Click(null, null);
                    //b_RefreshLoadSave_Click(null, null);
                    PauseMonitor();
                    if (!(module_index.SelectedIndex < 0))
                    {
                        UInt16 valuePortD = 0;
                        valuePortD = msaManager.GetPort(4);
                        if (msaManager.cn.target == 0)
                        {
                            if (msaManager.IsBitSet(valuePortD, BITS.BIT3))
                            {
                                chk_lpmodeL.IsChecked = true;
                            }
                            else
                            {
                                chk_lpmodeL.IsChecked = false;
                            }

                            if (!msaManager.IsBitSet(valuePortD, BITS.BIT1))
                            {
                                chk_resetL.IsChecked = true;
                            }
                            else
                            {
                                chk_resetL.IsChecked = false;
                            }

                            if (!msaManager.IsBitSet(valuePortD, BITS.BIT2))
                            {
                                chk_modeselL.IsChecked = true;
                            }
                            else
                            {
                                chk_modeselL.IsChecked = false;
                            }
                        }
                        if (msaManager.cn.target == 1)
                        {
                            if (msaManager.IsBitSet(valuePortD, BITS.BIT9))
                            {
                                chk_lpmodeL.IsChecked = true;
                            }
                            else
                            {
                                chk_lpmodeL.IsChecked = false;
                            }

                            if (!msaManager.IsBitSet(valuePortD, BITS.BIT5))
                            {
                                chk_resetL.IsChecked = true;
                            }
                            else
                            {
                                chk_resetL.IsChecked = false;
                            }

                            if (!msaManager.IsBitSet(valuePortD, BITS.BIT6))
                            {
                                chk_modeselL.IsChecked = true;
                            }
                            else
                            {
                                chk_modeselL.IsChecked = false;
                            }
                        }

                    }
                }
                else if (BoardID == 4162)
                {

                    PauseMonitor();

                    UInt16 valuePortC = 0, valuePortE = 0;
                        valuePortC = msaManager.GetPort(2);
                        valuePortE = msaManager.GetPort(4);

                            if (msaManager.IsBitSet(valuePortC, BITS.BIT1))
                            {
                                chk_lpmodeL.IsChecked = true;
                            }
                            else
                            {
                                chk_lpmodeL.IsChecked = false;
                            }


                            if (!msaManager.IsBitSet(valuePortE, BITS.BIT8))
                            {
                                chk_resetL.IsChecked = true;
                            }
                            else
                            {
                                chk_resetL.IsChecked = false;
                            }

                            if (!msaManager.IsBitSet(valuePortE, BITS.BIT4))
                            {
                                chk_modeselL.IsChecked = true;
                            }
                            else
                            {
                                chk_modeselL.IsChecked = false;
                            }
                        

                    

                }




            }
            catch (Exception ex)
            {
                ResumeMonitor();
                MessageBox.Show(ex.Message);
            }

            ResumeMonitor();
        }
        private void Window_Closed(object sender, EventArgs e)
        {
            try
            {
                MulThread.Abort();
            }
            catch { }
            msaManager.Disconnect();
        }

        private void btn_setPageNum_Click(object sender, RoutedEventArgs e)
        {
            MemPage = Convert.ToByte(tbox_pageNum.Text);
        }
        private void rb_UpperPage00_Checked(object sender, RoutedEventArgs e)
        {
            MemPage = 00;
            tbox_pageNum.Clear();
            tbox_pageNum.IsEnabled = false;
            btn_setPageNum.IsEnabled = false;
        }
        private void rb_UpperPage01_Checked(object sender, RoutedEventArgs e)
        {
            MemPage = 01;
            tbox_pageNum.Clear();
            tbox_pageNum.IsEnabled = false;
            btn_setPageNum.IsEnabled = false;
        }
        private void rb_UpperPage02_Checked(object sender, RoutedEventArgs e)
        {
            MemPage = 02;
            tbox_pageNum.Clear();
            tbox_pageNum.IsEnabled = false;
            btn_setPageNum.IsEnabled = false;
        }
        private void rb_UpperPage03_Checked(object sender, RoutedEventArgs e)
        {
            MemPage = 03;
            tbox_pageNum.Clear();
            tbox_pageNum.IsEnabled = false;
            btn_setPageNum.IsEnabled = false;
        }
        private void rb_none_Checked(object sender, RoutedEventArgs e)
        {
            tbox_pageNum.IsEnabled = true;
            btn_setPageNum.IsEnabled = true;
        }

        private void b_WriteSingleByte_Click(object sender, RoutedEventArgs e)
        {

            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            byte DecAddr;
            byte Data = 0;
            PauseMonitor();
            string str = tb_ByteAddressDecimal.Text;
            if (tb_SingleByteHexadecimal.Text.Length > 1)  //the hex value of data must be of 2 characters 
            {
                if (msaManager.VerifyAddress(ref str))
                {
                    DecAddr = Convert.ToByte(Convert.ToInt32(tb_ByteAddressDecimal.Text)); //convert  the address to  hex format base 16
                    Data = Convert.ToByte(Convert.ToUInt32(tb_SingleByteHexadecimal.Text.Substring(0, 2), 16)); //convert data value to hex base 16
                    msaManager.I2CWrite(127, MemPage);
                    msaManager.I2CWrite(DecAddr, Data);

                }
                else
                {
                    tb_ByteAddressDecimal.Text = "";
                    MessageBox.Show("Error: Address Required (0 to 255)");
                }
            }
            else
            {
                MessageBox.Show("Error: Insufficient Data to Write");
            }
            ResumeMonitor();
        }

        private void b_ReadMultiByte_Click(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            byte startAddress;
            byte[] Data = new byte[1] { 0 };
            int byteCount;
            int Addr;
            int i;
            string strOut;
            string str = tb_StartingAddressDecimal.Text;
            string strEndAddr = tb_EndAddress.Text;

            PauseMonitor();

            if (msaManager.VerifyAddress(ref str) && msaManager.VerifyAddress(ref strEndAddr))
            {
                //the bytecount is a string representing a decimal number
                byteCount = (Convert.ToInt32(tb_EndAddress.Text) - Convert.ToInt32(tb_StartingAddressDecimal.Text)) + 1; // =1 since the start and end addresses are inclusive in the count
                if ((byteCount > 0) && (byteCount < 257))
                {
                    strOut = "";
                    lb_MultiByteDisplay.listBox.Items.Clear();

                    //the address value is a decimal integer that must be converted into byte
                    startAddress = Convert.ToByte(Convert.ToUInt32(tb_StartingAddressDecimal.Text));
                    for (i = 0; i < byteCount; i++)
                    {
                        Addr = (startAddress + i) % 256; //if the bytecount+StartAddr exceed 255, then it wraps to 0.

                        msaManager.I2CWrite(127, MemPage);
                        Data = msaManager.I2CRead(Convert.ToByte(Addr));

                        strOut = String.Format("{0,5:000}             {1,7:X2}       {2,4}   ", Addr, Data[0], ""); //Address and Hex data
                        strOut = strOut + Convert.ToString(Convert.ToUInt32(Data[0]), 2).PadLeft(8, Convert.ToChar("0")); //Address, hex data , binary value
                        strOut = String.Format("{0,5:000}{1,7:X2}{2,4}", strOut, Convert.ToChar(Data[0]), "");//Address, hex data , binary value, Ascci value
                        lb_MultiByteDisplay.listBox.Items.Add(strOut);
                    }
                }
                else
                {
                    MessageBox.Show("Error: Address Required (0 to 255)");
                }
            }
            else
            {
                tb_StartingAddressDecimal.Text = "";
            }
            ResumeMonitor();
        }

        private void b_SaveMultiByte_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = ".csv";
            dlg.Filter = "Comma Separated Values (.csv)|*.csv";
            if (dlg.ShowDialog() != true)
            {
                return;
            }
            //Create the MultiByte Save file
            fMultiByte = new FileStream(dlg.FileName.Replace(".csv", "") + ".csv", FileMode.OpenOrCreate, FileAccess.Write, FileShare.ReadWrite);
            sMultiByte = new StreamWriter(fMultiByte, System.Text.Encoding.ASCII);
            sMultiByte.WriteLine(DateTime.Now);
            sMultiByte.WriteLine("QSFP passive host: MultiByte Reading");

            sMultiByte.WriteLine("Address, Hex, Binary, ASCII");
            string multiByteStr = "";
            for (int i = 0; i < lb_MultiByteDisplay.listBox.Items.Count; i++)
            {

                multiByteStr = lb_MultiByteDisplay.listBox.Items[i].ToString().Replace(" ", ",").Replace(",,", ",").Replace(",,", ",").Replace(",,", ",").Replace(",,", ",").Replace(",,", ",");
                string b = multiByteStr.Substring(1, (multiByteStr.Length) - 2);
                sMultiByte.WriteLine(multiByteStr.Substring(1, (multiByteStr.Length) - 1));
            }
            sMultiByte.Flush();
            sMultiByte.Close();
        }

        private void b_RefreshLoadSave_Click(object sender, RoutedEventArgs e)
        {
            //Read Values From HW into the MEM Grid
            byte[] ReadBuff;
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            PauseMonitor();
            softwarePause = true;

            for (int row = 0; row < 640; row += 32)
            {
                if ((row % 128 == 0) && (row != 0))
                {
                    msaManager.I2CWrite(127, (byte)((row / 128) - 1));
                }
                ReadBuff = new byte[32];
                ReadBuff = msaManager.I2CRead((byte)(row < 128 ? row : row % 128 + 128));

                for (int i = 0; i < 32; i++)
                {
                    msaTable.Rows[(row + i)][1] = ReadBuff[i].ToString("X2");
                    msaTable.Rows[(row + i)][2] = int.Parse(msaTable.Rows[(row + i)][1].ToString(), System.Globalization.NumberStyles.HexNumber);
                    msaTable.Rows[(row + i)][3] = Convert.ToChar(int.Parse(msaTable.Rows[(row + i)][1].ToString(), System.Globalization.NumberStyles.HexNumber));
                }
            }

            msaGrid.DataSource = msaTable.Copy();

            //Checksums:
            string ReadString = "";
            // Page 00
            tb_CalculatedCheckSum128_222.Text = msaManager.calc_CheckSum128_221val();

            msaManager.I2CWrite(127, 00);
            ReadBuff = msaManager.I2CRead(222);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            tb_StoredCheckSum128_222.Text = intval.ToString("X2");

            //page01

            tb_CalculatedCheckSum128_254P1.Text = msaManager.calc_CheckSum130_254valPage01();

            msaManager.I2CWrite(127, 01);
            ReadBuff = msaManager.I2CRead(255);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            tb_StoredCheckSum128_254P1.Text = intval.ToString("X2");

            //page02
            tb_CalculatedCheckSum128_254P2.Text = msaManager.calc_CheckSum128_254valPage02();

            msaManager.I2CWrite(127, 02);
            ReadBuff = msaManager.I2CRead(255);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            tb_StoredCheckSum128_254P2.Text = intval.ToString("X2");


            ResumeMonitor();
            softwarePause = false;
        }

        private void b_WriteMSAtoHW_Click(object sender, RoutedEventArgs e)
        {
            //Write Values in the Mem Grid to the HW
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            PauseMonitor();
            for (int row = 0; row < 640; row++)
            {
                if ((row % 128 == 0) && (row != 0))
                {
                    msaManager.I2CWrite(127, (byte)((row / 128) - 1));
                }
                msaManager.I2CWrite((byte)(row < 128 ? row : row % 128 + 128), byte.Parse(msaTable.Rows[row][1].ToString(), System.Globalization.NumberStyles.HexNumber));
            }
            ResumeMonitor();
        }

        private void b_LoadMSA_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.OpenFileDialog ofd = new System.Windows.Forms.OpenFileDialog();
            ofd.Filter = "Comma Separated Values (.csv)|*.csv";
            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.Cancel)
            {
                return;
            }

            sr = new StreamReader(ofd.FileName);
            string[] parts;
            int temp = 0;
            CultureInfo provider;
            provider = CultureInfo.InvariantCulture;
            PauseMonitor();
            softwarePause = true;
            sr.ReadLine();
            sr.ReadLine();
            sr.ReadLine();  //we do not want to load the first 3 lines of the .CSV file, so we read them but do not use them later
            int pointer = 0;
            for (int i = 0; i < 640; i++)
            {
                parts = sr.ReadLine().Split(',');
                msaTable.Rows[pointer][1] = parts[1].Remove(0, 2);
                if (int.TryParse(msaTable.Rows[pointer][1].ToString(), System.Globalization.NumberStyles.HexNumber, provider, out temp) == false)
                {
                    MessageBox.Show("Invalid File format.", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                    return;
                }
                else
                {
                    msaTable.Rows[pointer][2] = int.Parse(msaTable.Rows[pointer][1].ToString(), System.Globalization.NumberStyles.HexNumber);
                }
                msaTable.Rows[pointer][3] = Convert.ToChar(int.Parse(msaTable.Rows[pointer][1].ToString(), System.Globalization.NumberStyles.HexNumber));
                pointer++;
            }

            msaGrid.DataSource = msaTable.Copy();
            sr.Close();
            ResumeMonitor();
            softwarePause = false;
        }

        private void b_SaveMSA_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.SaveFileDialog dlgGrid = new System.Windows.Forms.SaveFileDialog();
            dlgGrid.DefaultExt = ".csv";
            dlgGrid.Filter = "Comma Separated Values (.csv)|*.csv";
            dlgGrid.ShowDialog();

            //Create the Memory Grid Save file
            fGrid = new FileStream(dlgGrid.FileName.Replace(".csv", "") + ".csv", FileMode.OpenOrCreate, FileAccess.Write, FileShare.ReadWrite);
            sGrid = new StreamWriter(fGrid, System.Text.Encoding.ASCII);
            sGrid.WriteLine(DateTime.Now);
            sGrid.WriteLine("QSFP passive host: MSA");

            sGrid.WriteLine("Address, Hex, Decimal, ASCII, MSA Description");
            string multiByteStr;
            for (int i = 0; i < 640; i++)
            {

                multiByteStr = msaTable.Rows[i][0].ToString() + ",0x" + msaTable.Rows[i][1].ToString() + "," + msaTable.Rows[i][2].ToString() + "," + msaTable.Rows[i][3].ToString() + "," + msaTable.Rows[i][4].ToString();
                sGrid.WriteLine(multiByteStr.Replace('\n', ' ').Replace('\r', ' '));
            }
            sGrid.Flush();
            sGrid.Close();
        }
        #region Interrupt
        private void b_RefreshInterrupt_Click(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            int intval = 0;
            byte[] ReadBuff = new byte[1] { 0 };

            string ReadString = "";

            PauseMonitor();
            ReadBuff = msaManager.I2CRead(31);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_sttchn.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);

            ReadBuff = msaManager.I2CRead(32);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_VccLW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            chk_VccHW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_vccLA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_VccHW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_tempLW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_tempHW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_tempLA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_tempHA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);


            ReadBuff = msaManager.I2CRead(33);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_auxLW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            chk_auxHW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_auxLA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_auxHA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_auxLW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_auxHW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_auxLA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_auxHA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);

            ReadBuff = msaManager.I2CRead(34);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_VDLW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            chk_VDHW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_VDLA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_VDHA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_auxLW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_auxHW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_auxLA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_auxHA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);

            msaManager.I2CWrite(127, 16);
            ReadBuff = msaManager.I2CRead(213);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_sttCng.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_sttCng1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_sttCng2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_sttCng3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_sttCng4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_sttCng5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_sttCng6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_sttCng7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);


            msaManager.I2CWrite(127, 16);
            ReadBuff = msaManager.I2CRead(226);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);

            chk_rxLOS0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxLOS1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxLOS2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxLOS3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxLOS4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxLOS5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxLOS6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxLOS7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(215);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txLOS0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txLOS1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txLOS2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txLOS3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txLOS4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txLOS5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txLOS6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txLOS7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(227);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxLOL0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxLOL1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxLOL2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxLOL3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxLOL4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxLOL5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxLOL6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxLOL7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(216);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txLOL0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txLOL1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txLOL2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txLOL3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txLOL4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txLOL5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txLOL6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txLOL7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(214);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txFault0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txFault1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txFault2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txFault3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txFault4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txFault5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txFault6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txFault7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);



            /* ReadBuff = msaManager.I2CRead(107);
             ReadString = ReadBuff[0].ToString("X2");
             intval = msaManager.StringIntoValue(ReadString);
             chk_temp2LW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
             chk_temp2HW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
             chk_temp2LA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
             chk_temp2HA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
             chk_tempLW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
             chk_tempHW.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
             chk_tempLA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
             chk_tempHA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

             ReadBuff = msaManager.I2CRead(108);
             ReadString = ReadBuff[0].ToString("X2");
             intval = msaManager.StringIntoValue(ReadString);
             chk_initCompl.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
             chk_adaptation.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
             chk_tecCurrFault.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
             chk_tecCurrHA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
             chk_vccLA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
             chk_vccHA.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);*/
            ReadBuff = msaManager.I2CRead(231);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxpwrLW0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxpwrLW1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxpwrLW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxpwrLW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxpwrLW4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxpwrLW5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxpwrLW6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxpwrLW7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(229);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxpwrLA0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxpwrLA1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxpwrLA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxpwrLA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxpwrLA4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxpwrLA5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxpwrLA6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxpwrLA7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(228);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxpwrHA0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxpwrHA1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxpwrHA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxpwrHA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxpwrHA4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxpwrHA5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxpwrHA6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxpwrHA7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(230);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxpwrHW0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxpwrHW1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxpwrHW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxpwrHW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxpwrHW4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxpwrHW5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxpwrHW6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxpwrHW7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(223);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txBLA0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txBLA1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txBLA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txBLA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txBLA4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txBLA5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txBLA6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txBLA7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(222);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txBHA0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txBHA1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txBHA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txBHA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txBHA4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txBHA5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txBHA6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txBHA7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(225);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txBLW0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txBLW1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txBLW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txBLW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txBLW4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txBLW5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txBLW6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txBLW7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(224);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txBHW0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txBHW1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txBHW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txBHW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txBHW4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txBHW5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txBHW6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txBHW7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(219);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txpwrLA0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txpwrLA1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txpwrLA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txpwrLA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txpwrLA4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txpwrLA5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txpwrLA6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txpwrLA7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(218);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txpwrHA0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txpwrHA1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txpwrHA2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txpwrHA3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txpwrHA4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txpwrHA5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txpwrHA6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txpwrHA7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(221);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txpwrLW0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txpwrLW1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txpwrLW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txpwrLW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txpwrLW4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txpwrLW5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txpwrLW6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txpwrLW7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);
            ReadBuff = msaManager.I2CRead(220);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txpwrHW0.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txpwrHW1.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txpwrHW2.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txpwrHW3.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txpwrHW4.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txpwrHW5.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txpwrHW6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txpwrHW7.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ResumeMonitor();
        }

        private void chk_rxLOS0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT0, (bool)chk_rxLOS0.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxLOS1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT1, (bool)chk_rxLOS1.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxLOS2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT2, (bool)chk_rxLOS2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOS3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT3, (bool)chk_rxLOS3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOS4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT4, (bool)chk_rxLOS4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOS5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT5, (bool)chk_rxLOS5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOS6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT6, (bool)chk_rxLOS6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOS7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(226, BITS.BIT7, (bool)chk_rxLOS7.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT0, (bool)chk_txLOS0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT1, (bool)chk_txLOS1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT2, (bool)chk_txLOS2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT3, (bool)chk_txLOS3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT4, (bool)chk_txLOS4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT5, (bool)chk_txLOS5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT6, (bool)chk_txLOS6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOS7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(215, BITS.BIT7, (bool)chk_txLOS7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxLOL0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT0, (bool)chk_rxLOL0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOL1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT1, (bool)chk_rxLOL1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOL2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT2, (bool)chk_rxLOL2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOL3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT3, (bool)chk_rxLOL3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOL4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT4, (bool)chk_rxLOL4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOL5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT5, (bool)chk_rxLOL5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOL6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT6, (bool)chk_rxLOL6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxLOL7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(227, BITS.BIT7, (bool)chk_rxLOL7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txLOL0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT0, (bool)chk_txLOL0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOL1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT1, (bool)chk_txLOL1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOL2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT2, (bool)chk_txLOL2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOL3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT3, (bool)chk_txLOL3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOL4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT4, (bool)chk_txLOL4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOL5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT5, (bool)chk_txLOL5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOL6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT6, (bool)chk_txLOL6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txLOL7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(216, BITS.BIT7, (bool)chk_txLOL7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txFault0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT0, (bool)chk_txFault0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txFault1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT1, (bool)chk_txFault1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txFault2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT2, (bool)chk_txFault2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txFault3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT3, (bool)chk_txFault3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txFault4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT4, (bool)chk_txFault4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txFault5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT5, (bool)chk_txFault5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txFault6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT6, (bool)chk_txFault6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txFault7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(214, BITS.BIT7, (bool)chk_txFault7.IsChecked, 16);
            ResumeMonitor();
        }



        private void chk_tempHA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT0, (bool)chk_tempHA.IsChecked);
            ResumeMonitor();
        }
        private void chk_tempLA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT1, (bool)chk_tempLA.IsChecked);
            ResumeMonitor();
        }
        private void chk_tempHW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT2, (bool)chk_tempHW.IsChecked);
            ResumeMonitor();
        }
        private void chk_tempLW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT3, (bool)chk_tempLW.IsChecked);
            ResumeMonitor();
        }
        /*  private void chk_temp2HA_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(107, BITS.BIT3, (bool)chk_temp2HA.IsChecked);
              ResumeMonitor();
          }
          private void chk_temp2LA_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(107, BITS.BIT2, (bool)chk_temp2LA.IsChecked);
              ResumeMonitor();
          }
          private void chk_temp2HW_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(107, BITS.BIT1, (bool)chk_temp2HW.IsChecked);
              ResumeMonitor();
          }
          private void chk_temp2LW_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(107, BITS.BIT0, (bool)chk_temp2LW.IsChecked);
              ResumeMonitor();
          }

          private void chk_tecCurrHA_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(108, BITS.BIT3, (bool)chk_tecCurrHA.IsChecked);
              ResumeMonitor();
          }
          private void chk_tecCurrFault_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(108, BITS.BIT2, (bool)chk_tecCurrFault.IsChecked);
              ResumeMonitor();
          }

          private void chk_adaptation_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(108, BITS.BIT1, (bool)chk_adaptation.IsChecked);
              ResumeMonitor();
          }

          private void chk_initCompl_Click(object sender, RoutedEventArgs e)
          {
              PauseMonitor();
              msaManager.RxTxTempVccCheckBox(108, BITS.BIT0, (bool)chk_initCompl.IsChecked);
              ResumeMonitor();
          }*/

        private void chk_vccHA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT4, (bool)chk_vccHA.IsChecked);
            ResumeMonitor();
        }
        private void chk_vccLA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT5, (bool)chk_vccLA.IsChecked);
            ResumeMonitor();
        }

        private void chk_VccHW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT6, (bool)chk_VccHW.IsChecked);
            ResumeMonitor();
        }

        private void chk_VccLW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(32, BITS.BIT7, (bool)chk_VccLW.IsChecked);
            ResumeMonitor();
        }

        private void chk_sttCng_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT0, (bool)chk_sttCng.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_sttCng1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT1, (bool)chk_sttCng1.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_sttCng2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT2, (bool)chk_sttCng2.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_sttCng3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT3, (bool)chk_sttCng3.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_sttCng4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT4, (bool)chk_sttCng4.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_sttCng5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT5, (bool)chk_sttCng5.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_sttCng6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT6, (bool)chk_sttCng6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_sttCng7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(213, BITS.BIT7, (bool)chk_sttCng7.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT0, (bool)chk_rxpwrLW0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT1, (bool)chk_rxpwrLW1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT2, (bool)chk_rxpwrLW2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT3, (bool)chk_rxpwrLW3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT4, (bool)chk_rxpwrLW4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT5, (bool)chk_rxpwrLW5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT6, (bool)chk_rxpwrLW6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLW7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(231, BITS.BIT7, (bool)chk_rxpwrLW7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrLA0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT0, (bool)chk_rxpwrLA0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLA1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT1, (bool)chk_rxpwrLA1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT2, (bool)chk_rxpwrLA2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT3, (bool)chk_rxpwrLA3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLA4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT4, (bool)chk_rxpwrLA4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLA5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT5, (bool)chk_rxpwrLA5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLA6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT6, (bool)chk_rxpwrLA6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrLA7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(229, BITS.BIT7, (bool)chk_rxpwrLA7.IsChecked, 16);
            ResumeMonitor();
        }


        private void chk_rxpwrHA0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT0, (bool)chk_rxpwrHA0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrHA1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT1, (bool)chk_rxpwrHA1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrHA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT2, (bool)chk_rxpwrHA2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrHA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT3, (bool)chk_rxpwrHA3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrHA4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT4, (bool)chk_rxpwrHA4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrHA5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT5, (bool)chk_rxpwrHA5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrHA6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT6, (bool)chk_rxpwrHA6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_rxpwrHA7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(228, BITS.BIT7, (bool)chk_rxpwrHA7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLA0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT0, (bool)chk_txBLA0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLA1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT1, (bool)chk_txBLA1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT2, (bool)chk_txBLA2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT3, (bool)chk_txBLA3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLA4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT4, (bool)chk_txBLA4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLA5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT5, (bool)chk_txBLA5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLA6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT6, (bool)chk_txBLA6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLA7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(223, BITS.BIT7, (bool)chk_txBLA7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHA0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT0, (bool)chk_txBHA0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHA1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT1, (bool)chk_txBHA1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT2, (bool)chk_txBHA2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT3, (bool)chk_txBHA3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHA4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT4, (bool)chk_txBHA4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHA5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT5, (bool)chk_txBHA5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHA6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT6, (bool)chk_txBHA6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHA7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(222, BITS.BIT7, (bool)chk_txBHA7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLA0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT0, (bool)chk_txpwrLA0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrLA1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT1, (bool)chk_txpwrLA1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrLA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT2, (bool)chk_txpwrLA2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrLA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT3, (bool)chk_txpwrLA3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrLA4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT4, (bool)chk_txpwrLA4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrLA5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT5, (bool)chk_txpwrLA5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrLA6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT6, (bool)chk_txpwrLA6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrLA7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(219, BITS.BIT7, (bool)chk_txpwrLA7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHA0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT0, (bool)chk_txpwrHA0.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHA1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT1, (bool)chk_txpwrHA1.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT2, (bool)chk_txpwrHA2.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT3, (bool)chk_txpwrHA3.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHA4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT4, (bool)chk_txpwrHA4.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHA5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT5, (bool)chk_txpwrHA5.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHA6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT6, (bool)chk_txpwrHA6.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHA7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(218, BITS.BIT7, (bool)chk_txpwrHA7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT0, (bool)chk_rxpwrHW0.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT1, (bool)chk_rxpwrHW1.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT2, (bool)chk_rxpwrHW2.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT3, (bool)chk_rxpwrHW3.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT4, (bool)chk_rxpwrHW4.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT5, (bool)chk_rxpwrHW5.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT6, (bool)chk_rxpwrHW6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpwrHW7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(230, BITS.BIT7, (bool)chk_rxpwrHW7.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBHW0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT0, (bool)chk_txBHW0.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHW1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT1, (bool)chk_txBHW1.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT2, (bool)chk_txBHW2.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT3, (bool)chk_txBHW3.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHW4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT4, (bool)chk_txBHW4.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHW5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT5, (bool)chk_txBHW5.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHW6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT6, (bool)chk_txBHW6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBHW7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(224, BITS.BIT7, (bool)chk_txBHW7.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txBLW0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT0, (bool)chk_txBHW0.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLW1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT1, (bool)chk_txBHW1.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT2, (bool)chk_txBHW2.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT3, (bool)chk_txBHW3.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLW4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT4, (bool)chk_txBHW4.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLW5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT5, (bool)chk_txBHW5.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLW6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT6, (bool)chk_txBHW6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txBLW7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(225, BITS.BIT7, (bool)chk_txBHW7.IsChecked, 16);
            ResumeMonitor();
        }
        private void chk_txpwrHW0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT0, (bool)chk_txpwrHW0.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHW1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT1, (bool)chk_txpwrHW1.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT2, (bool)chk_txpwrHW2.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT3, (bool)chk_txpwrHW3.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHW4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT4, (bool)chk_txpwrHW4.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHW5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT5, (bool)chk_txpwrHW5.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHW6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT6, (bool)chk_txpwrHW6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrHW7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(220, BITS.BIT7, (bool)chk_txpwrHW7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW0_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT0, (bool)chk_txpwrLW0.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT1, (bool)chk_txpwrLW1.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT2, (bool)chk_txpwrLW2.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT3, (bool)chk_txpwrLW3.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT4, (bool)chk_txpwrLW4.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT5, (bool)chk_txpwrLW5.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT6, (bool)chk_txpwrLW6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpwrLW7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(221, BITS.BIT7, (bool)chk_txpwrLW7.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_auxHA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT0, (bool)chk_auxHA.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxLA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT1, (bool)chk_auxLA.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxHA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT4, (bool)chk_auxHA2.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxLA2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT5, (bool)chk_auxHA2.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxHW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT2, (bool)chk_auxHW.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxLW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT3, (bool)chk_auxLW.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxHW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT6, (bool)chk_auxHW2.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxLW2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT7, (bool)chk_auxLW2.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxHW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(34, BITS.BIT2, (bool)chk_auxHW3.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxLW3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(34, BITS.BIT3, (bool)chk_auxLW3.IsChecked);
            ResumeMonitor();

        }
        private void chk_auxHA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(34, BITS.BIT0, (bool)chk_auxHA3.IsChecked);
            ResumeMonitor();
        }

        private void chk_auxLA3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(34, BITS.BIT1, (bool)chk_auxLA3.IsChecked);
            ResumeMonitor();
        }

        private void chk_VDHW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(34, BITS.BIT6, (bool)chk_VDHW.IsChecked);
            ResumeMonitor();
        }
        private void chk_VDHA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(34, BITS.BIT4, (bool)chk_VDHA.IsChecked);
            ResumeMonitor();
        }

        private void chk_VDLA_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(34, BITS.BIT5, (bool)chk_VDLA.IsChecked);
            ResumeMonitor();
        }

        private void chk_VDLW_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(33, BITS.BIT7, (bool)chk_VDLW.IsChecked);
            ResumeMonitor();
        }
        #endregion

        private void chk_txDIS0_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT0, (bool)chk_txDIS0_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txDIS1_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT1, (bool)chk_txDIS1_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txDIS2_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT2, (bool)chk_txDIS2_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txDIS3_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT3, (bool)chk_txDIS3_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txDIS4_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT4, (bool)chk_txDIS4_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txDIS5_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT5, (bool)chk_txDIS5_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txDIS6_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT6, (bool)chk_txDIS6_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txDIS7_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(130, BITS.BIT7, (bool)chk_txDIS7_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity0_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT0, (bool)chk_txpolarity0_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity1_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT1, (bool)chk_txpolarity1_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity2_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT2, (bool)chk_txpolarity2_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity3_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT3, (bool)chk_txpolarity3_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity4_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT4, (bool)chk_txpolarity4_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity5_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT5, (bool)chk_txpolarity5_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity6_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT6, (bool)chk_txpolarity6_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txpolarity7_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(129, BITS.BIT7, (bool)chk_txpolarity7_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh8_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT0, (bool)chk_txsquelsh8_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu9_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT1, (bool)chk_Forcesqu9_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh9_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT1, (bool)chk_txsquelsh9_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh10_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT2, (bool)chk_txsquelsh10_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh11_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT3, (bool)chk_txsquelsh11_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh12_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT4, (bool)chk_txsquelsh12_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh13_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT5, (bool)chk_txsquelsh13_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh14_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT6, (bool)chk_txsquelsh14_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_txsquelsh15_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(131, BITS.BIT7, (bool)chk_txsquelsh15_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu8_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT0, (bool)chk_Forcesqu8_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu10_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT2, (bool)chk_Forcesqu10_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu11_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT3, (bool)chk_Forcesqu11_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu12_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT4, (bool)chk_Forcesqu12_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu13_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT5, (bool)chk_Forcesqu13_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu14_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT6, (bool)chk_Forcesqu14_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_Forcesqu15_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(132, BITS.BIT7, (bool)chk_Forcesqu15_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        //private void chk_txFlagsqu8_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT0, (bool)chk_txFlagsqu8_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_txFlagsqu9_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT1, (bool)chk_txFlagsqu9_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_txFlagsqu10_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT2, (bool)chk_txFlagsqu10_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_txFlagsqu11_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT3, (bool)chk_txFlagsqu11_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_txFlagsqu12_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT4, (bool)chk_txFlagsqu12_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_txFlagsqu13_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT5, (bool)chk_txFlagsqu13_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_txFlagsqu14_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT6, (bool)chk_txFlagsqu14_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_txFlagsqu15_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(133, BITS.BIT7, (bool)chk_txFlagsqu15_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        private void chk_rxpolarity0_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT0, (bool)chk_rxpolarity0_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpolarity1_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT1, (bool)chk_rxpolarity1_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpolarity2_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT2, (bool)chk_rxpolarity2_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpolarity3_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT3, (bool)chk_rxpolarity3_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpolarity4_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT4, (bool)chk_rxpolarity4_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpolarity5_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT5, (bool)chk_rxpolarity5_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpolarity6_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT6, (bool)chk_rxpolarity6_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxpolarity7_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(137, BITS.BIT7, (bool)chk_rxpolarity7_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS8_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT0, (bool)chk_rxDIS8_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS9_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT1, (bool)chk_rxDIS9_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS10_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT2, (bool)chk_rxDIS10_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS11_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT3, (bool)chk_rxDIS11_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS12_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT4, (bool)chk_rxDIS12_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS13_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT5, (bool)chk_rxDIS13_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS14_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT6, (bool)chk_rxDIS14_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxDIS15_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(138, BITS.BIT7, (bool)chk_rxDIS15_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh8_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT0, (bool)chk_rxsquelsh8_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh9_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT1, (bool)chk_rxsquelsh9_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh10_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT2, (bool)chk_rxsquelsh10_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh11_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT3, (bool)chk_rxsquelsh11_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh12_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT4, (bool)chk_rxsquelsh12_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh13_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT5, (bool)chk_rxsquelsh13_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh14_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT6, (bool)chk_rxsquelsh14_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_rxsquelsh15_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(139, BITS.BIT7, (bool)chk_rxsquelsh15_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        //private void chk_RxFlagsqu8_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT0, (bool)chk_RxFlagsqu8_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_RxFlagsqu9_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT1, (bool)chk_RxFlagsqu9_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_RxFlagsqu10_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT2, (bool)chk_RxFlagsqu10_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_RxFlagsqu11_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT3, (bool)chk_RxFlagsqu11_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_RxFlagsqu12_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT4, (bool)chk_RxFlagsqu12_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_RxFlagsqu13_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT5, (bool)chk_RxFlagsqu13_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_RxFlagsqu14_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT6, (bool)chk_RxFlagsqu14_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        //private void chk_RxFlagsqu15_ms6_Click(object sender, RoutedEventArgs e)
        //{
        //    PauseMonitor();
        //    msaManager.RxTxTempVccCheckBox(140, BITS.BIT7, (bool)chk_RxFlagsqu15_ms6.IsChecked, 16);
        //    ResumeMonitor();
        //}

        private void chk_dataPath8_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT0, (bool)chk_dataPath8_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_dataPath9_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT1, (bool)chk_dataPath9_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_dataPath10_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT2, (bool)chk_dataPath10_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_dataPath11_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT3, (bool)chk_dataPath11_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_dataPath12_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT4, (bool)chk_dataPath12_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_dataPath13_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT5, (bool)chk_dataPath13_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_dataPath14_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT6, (bool)chk_dataPath14_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void chk_dataPath15_ms6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(128, BITS.BIT7, (bool)chk_dataPath15_ms6.IsChecked, 16);
            ResumeMonitor();
        }

        private void Rx_amp0_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            int registerVal = 0;
            int tempVal = 0;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(145, 0);
            registerVal &= 0xF0;
            tempval2 = 0x01;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(145, tempval2);
            switch (Rx_amp0.SelectedIndex)
            {
                case (0):

                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0xF0;
                    int ComboVal = 0;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0xF0;
                    ComboVal = 1;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, ComboVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0xF0;
                    ComboVal = 2;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0xF0;
                    ComboVal = 3;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, ComboVal);
                    break;
            }

        }

        private void Rx_amp1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int registerVal = 0;
            int tempVal = 0;
            int ComboVal;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(146, 0);
            registerVal &= 0xF0;
            tempval2 = 0x03;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(146, tempval2);
            switch (Rx_amp1.SelectedIndex)
            {
                case (0):

                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0x0F;
                    ComboVal = 0;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0x0F;
                    ComboVal = 1;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, tempVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0x0F;
                    ComboVal = 2;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(170, 0);
                    registerVal &= 0x0F;
                    ComboVal = 3;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(170, tempVal);
                    break;
            }
        }

        private void Rx_amp2_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            int registerVal = 0;
            int tempVal = 0;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(147, 0);
            registerVal &= 0xF0;
            tempval2 = 0x05;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(147, tempval2);
            switch (Rx_amp2.SelectedIndex)
            {
                case (0):
                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0xF0;
                    int ComboVal = 0;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0xF0;
                    ComboVal = 1;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, ComboVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0xF0;
                    ComboVal = 2;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0xF0;
                    ComboVal = 3;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, ComboVal);
                    break;
            }

        }

        private void Rx_amp3_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int registerVal = 0;
            int tempVal = 0;
            int ComboVal;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(148, 0);
            registerVal &= 0xF0;
            tempval2 = 0x07;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(148, tempval2);
            switch (Rx_amp3.SelectedIndex)
            {
                case (0):

                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0x0F;
                    ComboVal = 0;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0x0F;
                    ComboVal = 1;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, tempVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0x0F;
                    ComboVal = 2;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(171, 0);
                    registerVal &= 0x0F;
                    ComboVal = 3;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(171, tempVal);
                    break;
            }
        }

        private void Rx_amp4_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            int registerVal = 0;
            int tempVal = 0;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(149, 0);
            registerVal &= 0xF0;
            tempval2 = 0x09;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(149, tempval2);
            switch (Rx_amp4.SelectedIndex)
            {
                case (0):
                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0xF0;
                    int ComboVal = 0;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0xF0;
                    ComboVal = 1;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, ComboVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0xF0;
                    ComboVal = 2;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0xF0;
                    ComboVal = 3;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, ComboVal);
                    break;
            }

        }

        private void Rx_amp5_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int registerVal = 0;
            int tempVal = 0;
            int ComboVal;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(150, 0);
            registerVal &= 0xF0;
            tempval2 = 0x0B;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(150, tempval2);
            switch (Rx_amp5.SelectedIndex)
            {
                case (0):

                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0x0F;
                    ComboVal = 0;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0x0F;
                    ComboVal = 1;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, tempVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0x0F;
                    ComboVal = 2;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(172, 0);
                    registerVal &= 0x0F;
                    ComboVal = 3;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(172, tempVal);
                    break;
            }
        }

        private void Rx_amp6_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            int registerVal = 0;
            int tempVal = 0;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(151, 0);
            registerVal &= 0xF0;
            tempval2 = 0x0D;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(151, tempval2);
            switch (Rx_amp6.SelectedIndex)
            {
                case (0):
                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0xF0;
                    int ComboVal = 0;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0xF0;
                    ComboVal = 1;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, ComboVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0xF0;
                    ComboVal = 2;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0xF0;
                    ComboVal = 3;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, ComboVal);
                    break;
            }

        }

        private void Rx_amp7_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int registerVal = 0;
            int tempVal = 0;
            int ComboVal;
            int tempval2 = 0;
            msaManager.I2CWrite(127, 16);
            registerVal = msaManager.ReadAddress(152, 0);
            registerVal &= 0xF0;
            tempval2 = 0x0F;
            tempVal = registerVal | tempval2;
            msaManager.I2CWrite(152, tempval2);

            switch (Rx_amp7.SelectedIndex)
            {
                case (0):

                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0x0F;
                    ComboVal = 0;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, tempVal);
                    break;
                case (1):
                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0x0F;
                    ComboVal = 1;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, tempVal);

                    break;
                case (2):
                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0x0F;
                    ComboVal = 2;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, tempVal);
                    break;
                case (3):
                    registerVal = msaManager.ReadAddress(173, 0);
                    registerVal &= 0x0F;
                    ComboVal = 3;
                    ComboVal = ComboVal << 4;
                    tempVal = registerVal | ComboVal;
                    msaManager.I2CWrite(173, tempVal);
                    break;
            }
        }

        private void b_refreshControls2_Click(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            int intval = 0;
            byte[] ReadBuff = new byte[1] { 0 };

            string ReadString = "";

            PauseMonitor();
            msaManager.I2CWrite(127, 16);
            ReadBuff = msaManager.I2CRead(130);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txDIS0_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txDIS1_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txDIS2_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txDIS3_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txDIS4_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txDIS5_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txDIS6_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txDIS7_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(131);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txsquelsh8_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txsquelsh9_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txsquelsh10_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txsquelsh11_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txsquelsh12_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txsquelsh13_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txsquelsh14_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txsquelsh15_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(129);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_txpolarity0_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_txpolarity1_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_txpolarity2_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_txpolarity3_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_txpolarity4_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_txpolarity5_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_txpolarity6_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_txpolarity7_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);



            ReadBuff = msaManager.I2CRead(132);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_Forcesqu8_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_Forcesqu9_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_Forcesqu10_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_Forcesqu11_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_Forcesqu12_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_Forcesqu13_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_Forcesqu14_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_Forcesqu15_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            //ReadBuff = msaManager.I2CRead(133);
            //ReadString = ReadBuff[0].ToString("X2");
            //intval = msaManager.StringIntoValue(ReadString);
            //chk_txFlagsqu8_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            //chk_txFlagsqu9_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            //chk_txFlagsqu10_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            //chk_txFlagsqu11_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            //chk_txFlagsqu12_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            //chk_txFlagsqu13_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            //chk_txFlagsqu14_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            //chk_txFlagsqu15_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);


            ReadBuff = msaManager.I2CRead(137);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxpolarity0_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxpolarity1_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxpolarity2_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxpolarity3_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxpolarity4_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxpolarity5_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxpolarity6_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxpolarity7_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(139);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxsquelsh8_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxsquelsh9_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxsquelsh10_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxsquelsh11_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxsquelsh12_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxsquelsh13_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxsquelsh14_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxsquelsh15_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(138);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_rxDIS8_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_rxDIS9_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_rxDIS10_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_rxDIS11_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_rxDIS12_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_rxDIS13_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_rxDIS14_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_rxDIS15_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            //ReadBuff = msaManager.I2CRead(140);
            //ReadString = ReadBuff[0].ToString("X2");
            //intval = msaManager.StringIntoValue(ReadString);
            //chk_RxFlagsqu8_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            //chk_RxFlagsqu9_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            //chk_RxFlagsqu10_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            //chk_RxFlagsqu11_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            //chk_RxFlagsqu12_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            //chk_RxFlagsqu13_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            //chk_RxFlagsqu14_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            //chk_RxFlagsqu15_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            ReadBuff = msaManager.I2CRead(128);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            chk_dataPath8_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT0);
            chk_dataPath9_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT1);
            chk_dataPath10_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT2);
            chk_dataPath11_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT3);
            chk_dataPath12_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT4);
            chk_dataPath13_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT5);
            chk_dataPath14_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT6);
            chk_dataPath15_ms6.IsChecked = msaManager.IsBitSet(intval, BITS.BIT7);

            int regVal = 0;
            int tempValLeft = 0;
            int tempValRight = 0;

            regVal = msaManager.ReadAddress(156, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_equ0.Value = tempValRight;
            tb_eq1.Text = s_equ0.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_equ1.Value = tempValLeft;
            tb_eq2.Text = s_equ1.Value.ToString();

            regVal = msaManager.ReadAddress(157, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_equ2.Value = tempValRight;
            tb_eq3.Text = s_equ2.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_equ3.Value = tempValLeft;
            tb_eq4.Text = s_equ3.Value.ToString();

            regVal = msaManager.ReadAddress(158, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_equ4.Value = tempValRight;
            tb_eq5.Text = s_equ4.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_equ5.Value = tempValLeft;
            tb_eq6.Text = s_equ5.Value.ToString();

            regVal = msaManager.ReadAddress(159, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_equ6.Value = tempValRight;
            tb_eq7.Text = s_equ6.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_equ7.Value = tempValLeft;
            tb_eq8.Text = s_equ7.Value.ToString();


            int val = 0;
            regVal = msaManager.ReadAddress(170, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            Rx_amp0.TabIndex = tempValRight;
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            Rx_amp1.TabIndex = tempValLeft;

            regVal = msaManager.ReadAddress(171, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            Rx_amp2.TabIndex = tempValRight;
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            Rx_amp3.TabIndex = tempValLeft;

            regVal = msaManager.ReadAddress(172, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            Rx_amp4.TabIndex = tempValRight;
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            Rx_amp5.TabIndex = tempValLeft;

            regVal = msaManager.ReadAddress(173, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            Rx_amp6.TabIndex = tempValRight;
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            Rx_amp7.TabIndex = tempValLeft;



            regVal = msaManager.ReadAddress(162, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_pre0.Value = tempValRight;
            tb_pre1.Text = s_pre0.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_pre1.Value = tempValLeft;
            tb_pre2.Text = s_pre1.Value.ToString();

            regVal = msaManager.ReadAddress(163, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_pre2.Value = tempValRight;
            tb_pre3.Text = s_pre2.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_pre3.Value = tempValLeft;
            tb_pre4.Text = s_pre3.Value.ToString();

            regVal = msaManager.ReadAddress(164, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_pre4.Value = tempValRight;
            tb_pre5.Text = s_pre4.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_pre5.Value = tempValLeft;
            tb_pre6.Text = s_pre5.Value.ToString();

            regVal = msaManager.ReadAddress(165, 0);
            tempValRight = regVal & msaManager.StringIntoValue("0F");
            s_pre6.Value = tempValRight;
            tb_pre7.Text = s_pre6.Value.ToString();
            tempValLeft = regVal & msaManager.StringIntoValue("F0");
            tempValLeft = tempValLeft >> 4;
            s_pre7.Value = tempValLeft;
            tb_pre8.Text = s_pre7.Value.ToString();

            ResumeMonitor();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            int registerVal = 0;
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
            {
                msaManager.I2CWrite(127, 16);
                registerVal = 0xFF;
                msaManager.I2CWrite(143, registerVal);
            }
            if ((bool)rb_appall.IsChecked)
            {
                msaManager.I2CWrite(127, 16);
                registerVal = 0xFF;
                msaManager.I2CWrite(144, registerVal);
            }

            ResumeMonitor();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {

            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            PauseMonitor();

            l1.Visibility = Visibility.Visible;
            l2.Visibility = Visibility.Visible;
            l3.Visibility = Visibility.Visible;
            l4.Visibility = Visibility.Visible;
            l5.Visibility = Visibility.Visible;
            l6.Visibility = Visibility.Visible;
            l7.Visibility = Visibility.Visible;
            l8.Visibility = Visibility.Visible;
            ResumeMonitor();

        }

        private void l1_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT0, (bool)l1.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT0, (bool)l1.IsChecked, 16);
            ResumeMonitor();
        }

        private void l2_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT1, (bool)l2.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT1, (bool)l2.IsChecked, 16);
            ResumeMonitor();
        }

        private void l3_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT2, (bool)l3.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT2, (bool)l3.IsChecked, 16);
            ResumeMonitor();
        }

        private void l4_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT3, (bool)l4.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT3, (bool)l4.IsChecked, 16);
            ResumeMonitor();
        }

        private void l5_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT4, (bool)l5.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT4, (bool)l5.IsChecked, 16);
            ResumeMonitor();
        }

        private void l6_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT5, (bool)l6.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT5, (bool)l6.IsChecked, 16);
            ResumeMonitor();
        }

        private void l7_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT6, (bool)l7.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT6, (bool)l7.IsChecked, 16);
            ResumeMonitor();
        }

        private void l8_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            if ((bool)rb_appinit.IsChecked)
                msaManager.RxTxTempVccCheckBox(143, BITS.BIT7, (bool)l8.IsChecked, 16);
            if ((bool)rb_appall.IsChecked)
                msaManager.RxTxTempVccCheckBox(144, BITS.BIT7, (bool)l8.IsChecked, 16);
            ResumeMonitor();
        }

        private void b_RefreshIdentification_Click_1(object sender, RoutedEventArgs e)
        {
            int intval = 0;
            byte[] ReadBuff = new byte[1] { 0 };
            string ReadString = "";
            string asciiResult = "";

            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }

            PauseMonitor();

            //Vendor name, byte 129-144 Page00
            tb_VendorName.Text = msaManager.AscciiDisplay(129, 16, 0);

            //Vendor OUI, byte 145-147 Page00
            tb_VendorOUI.Text = msaManager.vendorOUI();

            //Vendor PN, byte 148-163 Page00
            tb_VendorPartNumber.Text = msaManager.AscciiDisplay(148, 16, 0);

            //Vendor Rev, byte 164-165 Page00
            tb_VendorRevision.Text = msaManager.AscciiDisplay(164, 2, 0);

            //Wavelenght centered, byte 138-139 Page01
            tb_WavelengthCenter.Text = msaManager.CenteredWavelength();

            //Wavelenght Tolerance, byte 140-141 Page01
            tb_WavelengthTolerance.Text = msaManager.WavelengthTolerance();

            //Max Temperature, byte 190 Page00
            //msaManager.I2CWrite(127, 00);
            //ReadBuff = msaManager.I2CRead(190);
            //ReadString = ReadBuff[0].ToString("X2");
            //intval = msaManager.StringIntoValue(ReadString);
            //tb_MaxTemperature.Text = intval.ToString();


            //Vendor SN, byte 166-181 Page00
            tb_VendorSerialNumber.Text = msaManager.AscciiDisplay(166, 16, 0);

            //Date Code, byte 182-189 Page00
            tb_VendorDataCode.Text = msaManager.AscciiDisplay(182, 8, 0);

            //Misc(VendorSpecific), byte 224-255 Page00
            tb_VendorMisc224_255.Text = msaManager.VendorSpecific();



            //LOT Code, byte 188-189 Page00
            tb_VendorLOTCode.Text = msaManager.AscciiDisplay(188, 2, 0);

            //Module ID, byte 128 Page00
            tb_MOduleID.Text = msaManager.ModuleID();

            msaManager.I2CWrite(127, 01);
            ReadBuff = msaManager.I2CRead(155);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            if (msaManager.IsBitSet(intval, BITS.BIT7))
                tb_wavelengthControl.Text = "Active wavelength control";
            else
                tb_wavelengthControl.Text = "No wavelength control";

            if (msaManager.IsBitSet(intval, BITS.BIT6))
                tb_tunable.Text = "Transmitter tunable";
            else
                tb_tunable.Text = "Transmitter not tunable";

            msaManager.I2CWrite(127, 01);
            ReadBuff = msaManager.I2CRead(145);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            if (msaManager.IsBitSet(intval, BITS.BIT7))
                tb_cooling.Text = "Cooled transmitter";
            else
                tb_cooling.Text = "Uncooled transmitter device";

            //msaManager.I2CWrite(127, 00);
            //ReadBuff = msaManager.I2CRead(151);
            //ReadString = ReadBuff[0].ToString("X2");
            //intval = msaManager.StringIntoValue(ReadString);
            //if (msaManager.IsBitSet(intval, BITS.BIT7))
            //    tb_detectortype.Text = "APD detector";
            //else
            //    tb_detectortype.Text = "Pin detector";


            //Connector, byte 203 Page00
            tb_Connector.Text = msaManager.ConnectorID();

            //Bit Rate, byte 140 Page00
            // tb_BitRate.Text = msaManager.BitrateVal();

            //Extended Rate Select, byte 141 Page00 (extended rate select is selected when byte 141 in page00 is 1, and byte 221 page00 has bit2=0 and bit3=1

            /* msaManager.I2CWrite(127, 00);
               intval = msaManager.ReadAddress(141, 0);

               int intval2 = 0;
               msaManager.I2CWrite(127, 0);
               intval2 = msaManager.ReadAddress(221, 0);

               if ((msaManager.IsBitSet(intval, BITS.BIT0)) && (!msaManager.IsBitSet(intval2, BITS.BIT2)))
               {
                   tb_ExtendedRateSelect.Text = "Extended Rate Select tags";
               }
               else
               {
                   tb_ExtendedRateSelect.Text = "Extended Rate Select is not selected";
               }
               */
            //Single Mode Fiber, byte 132 Page01
            msaManager.I2CWrite(127, 01);
            intval = (msaManager.ReadAddress(132, 0));
            intval &= 0x3F;
            double val = 0;
            if (!msaManager.IsBitSet(intval, BITS.BIT7) && !msaManager.IsBitSet(intval, BITS.BIT6))
            {
                val = double.Parse(intval.ToString());
                val *= 100;
            }
            else if (!msaManager.IsBitSet(intval, BITS.BIT7) && msaManager.IsBitSet(intval, BITS.BIT6))
            {
                val = double.Parse(intval.ToString());
                val *= 1000;
            }

            tb_SingleModeFiber.Text = val.ToString();

            //OM5, byte 133 Page01
            msaManager.I2CWrite(127, 01);
            intval = (msaManager.ReadAddress(133, 0)) * 2; //the value in units if 2 meter and we want it in units of 1 m so mult by 2
            tTb_OM5MultiModeFiber.Text = intval.ToString();

            //OM4, byte 134 Page01
            msaManager.I2CWrite(127, 01);
            intval = (msaManager.ReadAddress(134, 0)) * 2;
            tTb_OM4MultiModeFiber.Text = intval.ToString();

            //OM3, byte 135 Page01

            msaManager.I2CWrite(127, 01);
            intval = (msaManager.ReadAddress(135, 0)) * 2;
            tb_OM3MultiModeFiber.Text = intval.ToString();

            //OM2, byte 136 Page01
            msaManager.I2CWrite(127, 01);
            intval = (msaManager.ReadAddress(136, 0));
            tb_OM2MultiModeFiber.Text = intval.ToString();

            //Copper, byte 202 Page00
            msaManager.I2CWrite(127, 0);
            intval = (msaManager.ReadAddress(202, 0));
            intval &= 0x3F;
            val = 0;
            if (!msaManager.IsBitSet(intval, BITS.BIT7) && !msaManager.IsBitSet(intval, BITS.BIT6))
            {
                val = double.Parse(intval.ToString());
                val *= 0.1;
            }
            else if (!msaManager.IsBitSet(intval, BITS.BIT7) && msaManager.IsBitSet(intval, BITS.BIT6))
            {
                val = double.Parse(intval.ToString());
            }
            else if (msaManager.IsBitSet(intval, BITS.BIT7) && !msaManager.IsBitSet(intval, BITS.BIT6))
            {
                val = double.Parse(intval.ToString());
                val *= 10;
            }
            else
            {
                val = double.Parse(intval.ToString());
                val *= 100;
            }


            tb_Copper.Text = val.ToString();

            //Device Technology, byte 212 Page00
            msaManager.I2CWrite(127, 0);
            intval = (msaManager.ReadAddress(212, 0));
            //intval = intval & msaManager.StringIntoValue("F0");
            DeviceTechnology devTech;
            devTech = (DeviceTechnology)intval;
            tb_DeviceTechnology.Text = devTech.ToString();

            //Power Class/CLEI code existence, byte 129 Page00

            ReadBuff = msaManager.I2CRead(2);
            ReadString = ReadBuff[0].ToString("X2");
            int testval = msaManager.StringIntoValue(ReadString);

            if (msaManager.IsBitSet(testval, BITS.BIT6))   //CLEI code is present in Page00
            {
                //CLEI code, byte 190-199 Page02
                byte[] ReadBuffCLEICode = new byte[10] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

                msaManager.I2CWrite(127, 00);
                ReadBuffCLEICode = ReadBuff = msaManager.I2CRead(190);


                asciiResult = "";
                ReadString = "";
                for (int i = 0; i < 10; i++)
                {
                    ReadString += ReadBuffCLEICode[i].ToString("X2");
                    intval = msaManager.StringIntoValue(ReadBuffCLEICode[i].ToString("X2"));
                    asciiResult += Convert.ToChar(intval);
                }
                tb_ClEICode.Text = asciiResult;
            }
            else
            {
                tb_ClEICode.Text = "CLEI Code Doesn't Exist in Page00";
            }

            msaManager.I2CWrite(127, 0);
            ReadBuff = msaManager.I2CRead(200);
            ReadString = ReadBuff[0].ToString("X2");
            testval = msaManager.StringIntoValue(ReadString);

            if (!msaManager.IsBitSet(testval, BITS.BIT7))
            {
                if ((!msaManager.IsBitSet(testval, BITS.BIT6)) && (!msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 1 Module (1.5 W max. power consumption)";
                }
                else if ((!msaManager.IsBitSet(testval, BITS.BIT6)) && (msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 2 Module (3.5 W max. power consumption)";
                }
                else if ((msaManager.IsBitSet(testval, BITS.BIT6)) && (!msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 3 Module (5.0 W max. power consumption)";
                }
                else if ((msaManager.IsBitSet(testval, BITS.BIT6)) && (msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 4 Module (7.0 W max. power consumption)";
                }
            }

            else
            {
                if ((!msaManager.IsBitSet(testval, BITS.BIT6)) && (!msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 5 Module (10.0 W max. power consumption)";
                }
                else if ((!msaManager.IsBitSet(testval, BITS.BIT6)) && (msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 6 Module (12.0 W max. power consumption)";
                }
                else if ((msaManager.IsBitSet(testval, BITS.BIT6)) && (!msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 7 Module (14.0 W max. power consumption)";
                }
                else if ((msaManager.IsBitSet(testval, BITS.BIT6)) && (msaManager.IsBitSet(testval, BITS.BIT5)))
                {
                    tb_POwerClass.Text = "Power Class 8 Module (>14 W max. power consumption)";
                }
            }

            //Max Power, byte 201 Page00
            msaManager.I2CWrite(127, 00);
            ReadBuff = msaManager.I2CRead(201);
            ReadString = ReadBuff[0].ToString("X2");
            intval = msaManager.StringIntoValue(ReadString);
            tb_MaxPower.Text = intval.ToString();
            /*  if (msaManager.IsBitSet(testval, BITS.BIT3))
              {
                  tb_CDR_Tx.Text = "Tx channels include CDRs";
              }
              else
              {
                  tb_CDR_Tx.Text = "Tx channels don't include CDRs";
              }

              if (msaManager.IsBitSet(testval, BITS.BIT2))
              {
                  tb_CDR_Rx.Text = "Rx channels include CDRs";
              }
              else
              {
                  tb_CDR_Rx.Text = "Rx channels don't include CDRs";
              }
              if (msaManager.IsBitSet(testval, BITS.BIT1))
              {
                  tb_MdioSupp.Text = "MDIO serial interface implemented";
              }
              else
              {
                  tb_MdioSupp.Text = "MDIO serial interface not implemented";
              }
              if (msaManager.IsBitSet(testval, BITS.BIT1))
              {
                  tb_MaxtwoWireSpeed.Text = "Serial interface speed 1KHz-1 MHz";
              }
              else
              {
                  tb_MaxtwoWireSpeed.Text = "Serial interface speed 1-400 KHz";
              }
            

              //Data Encoding, byte 139 Page00

              msaManager.I2CWrite(127, 00);
              ReadBuff = msaManager.I2CRead(139);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);
              EncodingValues datacode;
              datacode = (EncodingValues)intval;

              if ((intval >= 0x09) && (intval <= 0xFF))
              {
                  tb_DataEncoding.Text = EncodingValues.Reserved.ToString();
              }
              else
              {
                  tb_DataEncoding.Text = datacode.ToString();
              }

              //SONET, byte 132-133 Page00

              byte[] ReadBuffSONET = new byte[2] { 0, 0 };

              msaManager.I2CWrite(127, 00);
              ReadBuffSONET = ReadBuff = msaManager.I2CRead(132);

              ReadString = "";
              for (int i = 0; i < 2; i++)
              {
                  ReadString += ReadBuffSONET[i].ToString("X2");
              }

              int sonet132val = msaManager.StringIntoValue(ReadBuffSONET[0].ToString("X2"));
              int sonet133val = msaManager.StringIntoValue(ReadBuffSONET[1].ToString("X2"));

              if (msaManager.IsBitSet(sonet132val, BITS.BIT2))
              {
                  tb_SONET.Text = "OC 48, Long reach";
              }

              else if (msaManager.IsBitSet(sonet132val, BITS.BIT1))
              {
                  tb_SONET.Text = "OC 48, Intermediate reach";
              }

              else if (msaManager.IsBitSet(sonet132val, BITS.BIT0))
              {
                  tb_SONET.Text = "OC 48, Short reach";
              }
              else
              {
                  tb_SONET.Text = "Not available";
              }

              if (msaManager.IsBitSet(sonet133val, BITS.BIT6))
              {
                  tb_SAS_SATA.Text = "SAS 12.0 Gbps";
              }
              else if (msaManager.IsBitSet(sonet133val, BITS.BIT5))
              {
                  tb_SAS_SATA.Text = "SAS 6.0 Gb";
              }
              else if (msaManager.IsBitSet(sonet133val, BITS.BIT4))
              {
                  tb_SAS_SATA.Text = "SAS 3.0 Gb";
              }
              else
              {
                  tb_SAS_SATA.Text = "Not available";
              }

              //10G Ethernet, byte 131 Page00

              msaManager.I2CWrite(127, 00);
              ReadBuff = ReadBuff = msaManager.I2CRead(131);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);
              if (msaManager.IsBitSet(intval, BITS.BIT6))
              {
                  tb_10GEthernet.Text = "10GBase-LRM";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT5))
              {
                  tb_10GEthernet.Text = "10GBase-LR";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT4))
              {
                  tb_10GEthernet.Text = "10GBase-SR";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT3))
              {
                  tb_10GEthernet.Text = "40GBASE-CR4";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT2))
              {
                  tb_10GEthernet.Text = "40GBASE-SR4";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT1))
              {
                  tb_10GEthernet.Text = "40GBASE-LR4";
              }
              else // should i add this part?
              {
                  tb_10GEthernet.Text = "Not Available";
              }

              //1G Ethernet, byte 134 Page00

              msaManager.I2CWrite(127, 00);
              ReadBuff = msaManager.I2CRead(134);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);
              if (msaManager.IsBitSet(intval, BITS.BIT3))
              {
                  tb_1GEthernet.Text = "1000Base-T";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT2))
              {
                  tb_1GEthernet.Text = "1000Base-CX";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT1))
              {
                  tb_1GEthernet.Text = "1000Base-LX";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT0))
              {
                  tb_1GEthernet.Text = "1000Base-SX";
              }
              else // should i add this part?
              {
                  tb_1GEthernet.Text = "Not available";
              }

              //Link Length, byte 135 Page00

              msaManager.I2CWrite(127, 00);
              ReadBuff = msaManager.I2CRead(135);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);
              if (msaManager.IsBitSet(intval, BITS.BIT7))
              {
                  tb_LInkLengthFiberChannel.Text = "very Long Distance";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT6))
              {
                  tb_LInkLengthFiberChannel.Text = "Short Distance";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT5))
              {
                  tb_LInkLengthFiberChannel.Text = "Intermediate Distance";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT4))
              {
                  tb_LInkLengthFiberChannel.Text = "Long Distance";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT3))
              {
                  tb_LInkLengthFiberChannel.Text = "Medium Distance";
              }

              else // should i add this part?
              {
                  tb_LInkLengthFiberChannel.Text = "Not Available";
              }


              ReadBuff = msaManager.I2CRead(136);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);
              if (msaManager.IsBitSet(intval, BITS.BIT1))
              {
                  tb_TechnologyFiberCHannel.Text = "Long Wave Laser";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT0))
              {
                  tb_TechnologyFiberCHannel.Text = "Electrical Inter-Enclosure";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT7))
              {
                  tb_TechnologyFiberCHannel.Text = "Electrical intra-enclosure";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT6))
              {
                  tb_TechnologyFiberCHannel.Text = "Shortwave laser w/o OFC(SN)";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT5))
              {
                  tb_TechnologyFiberCHannel.Text = "Shortwave laser w/ OFC(SL)";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT4))
              {
                  tb_TechnologyFiberCHannel.Text = "Longwave laser";
              }

              else // should i add this part?
              {
                  tb_TechnologyFiberCHannel.Text = "Not Available";
              }

              //Medium, byte 137 Page00

              //  msaManager.I2CWrite(127, 00);
              ReadBuff = msaManager.I2CRead(137);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);
              if (msaManager.IsBitSet(intval, BITS.BIT7))
              {
                  tb_MediumFiberChannel.Text = "Twin Axial Pair (TW)";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT6))
              {
                  tb_MediumFiberChannel.Text = "Shielded Twisted Pair (TP)";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT5))
              {
                  tb_MediumFiberChannel.Text = "Miniature Coax (MI)";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT4))
              {
                  tb_MediumFiberChannel.Text = "Video Coax (TV)";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT3))
              {
                  tb_MediumFiberChannel.Text = "Multi-mode, 62.5m (M6)";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT2))
              {
                  tb_MediumFiberChannel.Text = "Multi-mode, 50m (M5)";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT1))
              {
                  tb_MediumFiberChannel.Text = "Multi-mode, 50um (OM3)";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT0))
              {
                  tb_MediumFiberChannel.Text = "Single Mode (SM)";
              }
              else
              {
                  tb_MediumFiberChannel.Text = "Not Available";
              }

              //Speed, byte 138 Page00

              msaManager.I2CWrite(127, 00);
              ReadBuff = msaManager.I2CRead(138);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);
              if (msaManager.IsBitSet(intval, BITS.BIT7))
              {
                  tb_SpeedFiberChannel.Text = "1200 MBytes/Sec";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT6))
              {
                  tb_SpeedFiberChannel.Text = "800 MBytes/Sec";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT5))
              {
                  tb_SpeedFiberChannel.Text = "1600 Mbytes/Sec";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT4))
              {
                  tb_SpeedFiberChannel.Text = "400 MBytes/Sec";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT2))
              {
                  tb_SpeedFiberChannel.Text = "200 MBytes/Sec";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT0))
              {
                  tb_SpeedFiberChannel.Text = "100 MBytes/Sec";
              }
              else
              {
                  tb_SpeedFiberChannel.Text = "Not Available";
              }
              //Infiniband Speed/Technology, byte 164 Page00

              msaManager.I2CWrite(127, 00);
              ReadBuff = msaManager.I2CRead(164);

              ReadString = ReadBuff[0].ToString("X2");

              intval = msaManager.StringIntoValue(ReadString);

              if (msaManager.IsBitSet(intval, BITS.BIT2))
              {
                  tb_InfiniBandSpeed.Text = "QDR Speed";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT1))
              {
                  tb_InfiniBandSpeed.Text = "DDR Speed";
              }

              else if (msaManager.IsBitSet(intval, BITS.BIT0))
              {
                  tb_InfiniBandSpeed.Text = "SDR Speed";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT3))
              {
                  tb_InfiniBandSpeed.Text = "FDR Speed";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT4))
              {
                  tb_InfiniBandSpeed.Text = "EDR Speed";
              }
              else if (msaManager.IsBitSet(intval, BITS.BIT5))
              {
                  tb_InfiniBandSpeed.Text = "LDR Speed";
              }
              else
              {
                  tb_InfiniBandSpeed.Text = "Not Available";
              }
              */

            ResumeMonitor();
        }

        private void b_Initialize_Click(object sender, RoutedEventArgs e)
        {

            b_Initialize.IsEnabled = false;
            PauseMonitor();
            //initialize allows to connect to the HW and read the initial data from the HW
            if (!IsConnected)
            {
                //if ((module_index.SelectedIndex < 0))
                //{
                //    lb_DisplayStatus.Items.Clear();
                //    lb_DisplayStatus.Items.Add("Please Select a module");
                //    b_Initialize.Content = "Initialize";
                //    b_Initialize.IsEnabled = true;
                //    btn_IPChanger.IsEnabled = false;
                //    IsConnected = false;
                //    enableMonitor[msaManager.MSAInstance] = false;
                //    ChangeStatus(ref elps_Warning, 0);
                //    ChangeStatus(ref elps_OK, 2);
                //    return;
                //}
                string ip = txt_IP.Text;
                UInt16 port = 6653;
                int isReachable = 0;

                Thread Thread = new Thread(delegate()
                {
                    if (msaManager.Connect(ip, port))
                        isReachable = 1;

                });
                Thread.Start();
                Thread.Join(7000);
                if (Thread.IsAlive || isReachable == 0)
                {
                    Thread.Abort();
                    Thread = null;
                    b_Initialize.Content = "Initialize";
                    b_Initialize.IsEnabled = true;
                    btn_IPChanger.IsEnabled = false;
                    IsConnected = false;
                    enableMonitor[msaManager.MSAInstance] = false;
                    ChangeStatus(ref elps_Warning, 0);
                    ChangeStatus(ref elps_OK, 2);
                    return;
                }

                BoardID = msaManager.ReadBoardID();
                msaManager.BoardID = BoardID;



                b_Initialize.Content = "Disconnect";

                enableMonitor[msaManager.MSAInstance] = true;
                b_StopMonitoring.IsEnabled = true;
                btn_IPChanger.IsEnabled = true;
                IsConnected = true;
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Successful Connection");
                



                ////if (msaManager.GetDeviceCount() > 0)
                ////{
                ////    msaManager.SetDeviceID(devId);
                ////    fwinfo.FWDeviceID = devId;
                ////}
                //Display Firmware
                UInt16 revapi = 0;
                //if (msaManager.GetRev(ref revapi))
                //{
                //    lb_DisplayStatus.Items.Insert(0, "API Rev : " + revapi);
                //}

                Properties.Settings.Default.IP = ip;
                Properties.Settings.Default.Save();

                lb_DisplayStatus.Items.Insert(0, "Connected to Host");
                ChangeStatus(ref elps_Warning, 2);
                ChangeStatus(ref elps_OK, 1);
                elps_connection.Fill = System.Windows.Media.Brushes.LimeGreen;
                double vcc = msaManager.Get_VCC();
                vcc = Math.Round(vcc, 2);
                sld_1.Value = vcc;
                //// check if the module is present or not by checking the signal at port B , RB0, if the control signal is low then the module is present
                //if (!msaManager.IsModulePresent())
                //{
                //    ChangeStatus(ref elps_ModuleFound, false);
                //    ChangeStatusWarning(ref i_ModuleNotFound, true);
                //    ChangeStatus(ref i_OK, false);
                //    ChangeStatusWarning(ref i_Warning, true);
                //    lb_DisplayStatus.Items.Add("Module Not Found");
                //    b_Initialize.IsEnabled = true;
                //    return;
                //}
                //else
                //{
                //    ChangeStatus(ref i_ModuleFound, true);
                //    ChangeStatusWarning(ref i_ModuleNotFound, false);
                //    ChangeStatus(ref i_OK, true);
                //    ChangeStatusWarning(ref i_Warning, false);
                //    lb_DisplayStatus.Items.Add("Module Found");
                //    b_Initialize.IsEnabled = true;

                //    //lb_DisplayStatus.Items.Add
                //}

                if (BoardID == 4062)
                {
                    lb_selectmodule.Visibility = Visibility.Visible;
                    module_index.Visibility = Visibility.Visible;

   if ((module_index.SelectedIndex < 0))
                {
                    lb_DisplayStatus.Items.Clear();
                    lb_DisplayStatus.Items.Add("Please Select a module");
                    b_Initialize.Content = "Initialize";
                   b_Initialize.IsEnabled = true;
                  btn_IPChanger.IsEnabled = false;
                    IsConnected = false;
                    enableMonitor[msaManager.MSAInstance] = false;
                    ChangeStatus(ref elps_Warning, 0);
                    ChangeStatus(ref elps_OK, 2);
                    return;
                }
                }
                else if(BoardID==4162)
                {
                    msaManager.SetTarget(0);
                    lb_selectmodule.Visibility = Visibility.Collapsed;
                    module_index.Visibility = Visibility.Collapsed;
                }








                // Initialize all the GUI and Refrech all Tabs
                Cursor = Cursors.Wait;
                Initialize();
                //msaManager.SelectModule();
                Cursor = Cursors.Arrow;

                ////AOC default value
                //cbox_FanONOFF.IsChecked = false;
                //rbtn_33.IsChecked = true;
                //msaManager.SetFan_ON_OFF(0);
                //msaManager.SetPower(1);
                //msaManager.Set_PWM(1, 0);
                //msaManager.Set_PWM(2, 0);
                //msaManager.SetPower(1);

            }
            else
            {
                // If the module is not present or is not able to connect
                // Or Disconnect
                enableMonitor[msaManager.MSAInstance] = false;
                b_StopMonitoring.IsEnabled = false;
                IsConnected = false;
                try
                {
                    PauseMonitor();
                    elps_connection.Fill = System.Windows.Media.Brushes.Red;
                    b_Initialize.Content = "Initialize";
                    msaManager.Disconnect();
                    lb_DisplayStatus.Items.Clear();
                    lb_DisplayStatus.Items.Add("Disconnected.");
                    ChangeStatus(ref elps_Warning, 2);
                    ChangeStatus(ref elps_OK, 2);
                    ChangeStatus(ref elps_ModuleFound, 2);
                    ChangeStatus(ref elps_ModuleNotFound, 2);
                }
                catch
                {
                }
            }
            b_Initialize.IsEnabled = true;
            ResumeMonitor();
        }

        private void b_get_Click(object sender, RoutedEventArgs e)
        {
            

            PauseMonitor();
            if (BoardID == 4062)
            {
                UInt16 valuePort = 0;
                valuePort = msaManager.GetPort(4);
                if (msaManager.cn.target == 0)
                {
                    if (!msaManager.IsBitSet(valuePort, BITS.BIT4))
                    {
                        chk_intL.IsChecked = true;
                    }
                    else
                    {
                        chk_intL.IsChecked = false;
                    }
                    valuePort = msaManager.GetPort(6);
                    if (!msaManager.IsBitSet(valuePort, BITS.BIT12))
                    {
                        chk_modPRS.IsChecked = true;
                    }
                    else
                    {
                        chk_modPRS.IsChecked = false;
                    }
                }
                if (msaManager.cn.target == 1)
                {
                    if (!msaManager.IsBitSet(valuePort, BITS.BIT8))
                    {
                        chk_intL.IsChecked = true;
                    }
                    else
                    {
                        chk_intL.IsChecked = false;
                    }

                    if (!msaManager.IsBitSet(valuePort, BITS.BIT7))
                    {
                        chk_modPRS.IsChecked = true;
                    }
                    else
                    {
                        chk_modPRS.IsChecked = false;
                    }
                }
            }
            else if(BoardID==4162)
            {
                UInt16 valuePortD = 0, valuePortE = 0;
                valuePortD = msaManager.GetPort(3);
                valuePortE = msaManager.GetPort(4);

                if (!msaManager.IsBitSet(valuePortD, BITS.BIT12))
                {
                    chk_intL.IsChecked = true;
                }
                else
                {
                    chk_intL.IsChecked = false;
                }

                if (!msaManager.IsBitSet(valuePortE, BITS.BIT0))
                {
                    chk_modPRS.IsChecked = true;
                }
                else
                {
                    chk_modPRS.IsChecked = false;
                }




            }
            ResumeMonitor();
        }

        public void ChangeStatus(ref Ellipse ellipse, int status)
        {
            object[] parameters = new object[2];
            parameters[0] = ellipse;
            parameters[1] = status;
            this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal, SetActionChangeLedStatus, parameters);
        }

        //private void cb_usb_DropDownOpened(object sender, EventArgs e)
        //{
        //    try
        //    {
        //        if (initialized && deviceCount != msaManager.GetDeviceCount())
        //        {
        //            PauseMonitor();
        //            isDetectHWdone = false;
        //            for (int i = 0; i < deviceCount; i++)
        //            {
        //                msaManager.MSAInstance = (ushort)i;
        //                if (msaManager.IsConnected())
        //                    msaManager.Disconnect();
        //            }
        //            deviceCount = msaManager.GetDeviceCount();
        //            enableMonitor = new bool[deviceCount];
        //            //isConnected = new bool[deviceCount];
        //            //System.Windows.Application.Current.Dispatcher.Invoke(
        //            //                                     new Action(() =>
        //            //                                     {
        //            cb_usb.Items.Clear();
        //            for (int i = 0; i < deviceCount; i++)
        //            {
        //                cb_usb.Items.Add(i);
        //            }
        //            isDetectHWdone = true;
        //            cb_usb.SelectedIndex = 0;
        //            //  }));

        //            ResumeMonitor();
        //        }
        //    }
        //    catch (Exception ex)
        //    {
        //        MessageBox.Show(ex.Message);
        //    }

        //}

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            PauseMonitor();
            isDetectHWdone = false;
            deviceCount = 1;
            enableMonitor = new bool[deviceCount];
            ////isConnected = new bool[deviceCount];
            ////System.Windows.Application.Current.Dispatcher.Invoke(
            ////                                     new Action(() =>
            ////                                     {

            isDetectHWdone = true;

            ////  }));

            ResumeMonitor();

        }

        //private void cb_usb_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    if (isDetectHWdone)
        //    {
        //        msaManager.MSAInstance = (ushort)cb_usb.SelectedIndex;

        //        if (!msaManager.IsConnected())
        //        {
        //            b_Initialize.Content = "Initialize";
        //            elps_connection.Fill = System.Windows.Media.Brushes.Red;
        //            ChangeStatus(ref elps_ModuleFound, 2);
        //            ChangeStatus(ref elps_ModuleNotFound, 2);
        //            b_StopMonitoring.IsEnabled = false;
        //        }
        //        else
        //        {
        //            b_Initialize.Content = "Disconnect";
        //            elps_connection.Fill = System.Windows.Media.Brushes.LimeGreen;
        //            b_StopMonitoring.IsEnabled = true;
        //            //b_RefreshInterruptMasks_Click(null,null);
        //            //b_RefreshControls_Click(null, null);
        //            //b_RefreshIdentification_Click_1(null, null);
        //            //b_RefreshLoadSave_Click(null, null);

        //            try
        //            {
        //                //byte valuePortA = 0;
        //                //byte valuePortD = 0;
        //                //PauseMonitor();
        //                //msaManager.GetPort(3, ref valuePortD);
        //                //msaManager.GetPort(0, ref valuePortA);

        //                //if (msaManager.IsBitSet(valuePortD, BITS.BIT0))
        //                //{
        //                //    cbox_txdis.IsChecked = true;
        //                //}
        //                //else
        //                //{
        //                //    cbox_txdis.IsChecked = false;
        //                //}

        //                //if (msaManager.IsBitSet(valuePortA, BITS.BIT1))
        //                //{
        //                //    cbox_rs1.IsChecked = true;
        //                //}
        //                //else
        //                //{
        //                //    cbox_rs1.IsChecked = false;
        //                //}

        //                //if (msaManager.IsBitSet(valuePortA, BITS.BIT0))
        //                //{
        //                //    cbox_rs0.IsChecked = true;
        //                //}
        //                //else
        //                //{
        //                //    cbox_rs0.IsChecked = false;
        //                //}

        //                //ResumeMonitor();
        //            }
        //            catch (Exception ex)
        //            {
        //                ResumeMonitor();
        //                MessageBox.Show(ex.Message);
        //            }
        //        }
        //    }
        //}




        private void chk_modeselL_Click(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                return;
            }
            try
            {
                PauseMonitor();

                if (BoardID == 4062)
                {
                    UInt16 valuePortD = 0;

                    if (msaManager.cn.target == 0)
                    {
                        valuePortD = msaManager.GetPort(4);
                        //  valuePortD &= 0xFB;

                        if (!(bool)chk_modeselL.IsChecked)
                        {
                            valuePortD |= 0x0004;
                        }
                        else
                        {
                            valuePortD &= 0xFFFB;
                        }
                        msaManager.SetPort(4, valuePortD);
                    }
                    if (msaManager.cn.target == 1)
                    {
                        valuePortD = msaManager.GetPort(4);
                        //  valuePortD &= 0xFB;

                        if (!(bool)chk_modeselL.IsChecked)
                        {
                            valuePortD |= 0x0040;
                        }
                        else
                        {
                            valuePortD &= 0xFFBF;
                        }
                        msaManager.SetPort(4, valuePortD);
                    }
                }
                else if(BoardID==4162)
                {

                    UInt16 valuePortE = 0;

               
                        valuePortE = msaManager.GetPort(4);
                        //  valuePortD &= 0xFB;

                        if (!(bool)chk_modeselL.IsChecked)
                        {
                            valuePortE |= 0x0010;
                        }
                        else
                        {
                            valuePortE &= 0xFFEF;
                        }
                        msaManager.SetPort(4, valuePortE);
                    
                }
                ResumeMonitor();
            }
            catch (Exception ex)
            {
                ResumeMonitor();
                MessageBox.Show(ex.Message);
            }
        }

        private void chk_resetL_Click(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                return;
            }
            try
               
            {

                PauseMonitor();
                if (BoardID == 4062)
                {
                    UInt16 valuePortD = 0;
                    if (msaManager.cn.target == 0)
                    {
                        valuePortD = msaManager.GetPort(4);
                        // valuePortD &= 0xFD;

                        if (!(bool)chk_resetL.IsChecked)
                        {
                            valuePortD |= 0x0002;
                        }
                        else
                        {
                            valuePortD &= 0xFFFD;

                        }
                        msaManager.SetPort(4, valuePortD);
                    }
                    if (msaManager.cn.target == 1)
                    {
                        valuePortD = msaManager.GetPort(4);
                        // valuePortD &= 0xFD;

                        if (!(bool)chk_resetL.IsChecked)
                        {
                            valuePortD |= 0x0020;
                        }
                        else
                        {
                            valuePortD &= 0xFFDF;
                        }
                        msaManager.SetPort(4, valuePortD);
                    }
                }
                else if (BoardID==4162)
                {
                    UInt16 valuePortE = 0;
                    valuePortE = msaManager.GetPort(4);
                    // valuePortD &= 0xFD;

                    if (!(bool)chk_resetL.IsChecked)
                    {
                        valuePortE |= 0x0100;
                    }
                    else
                    {
                        valuePortE &= 0xFEFF;

                    }
                    msaManager.SetPort(4, valuePortE);

                }
                ResumeMonitor();
            }
            catch (Exception ex)
            {
                ResumeMonitor();
                MessageBox.Show(ex.Message);
            }
        }

        private void chk_lpmodeL_Click(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                return;
            }
            try
            {
                PauseMonitor();
                if (BoardID == 4062)
                {
                    UInt16 valuePortD = 0;
                   
                    if (msaManager.cn.target == 0)
                    {
                        valuePortD = msaManager.GetPort(4);
                        // valuePortD &= 0xF7;

                        if (!(bool)chk_lpmodeL.IsChecked)
                        {
                            valuePortD &= 0xFFF7;
                        }
                        else
                        {
                            valuePortD |= 0x0008;
                        }
                        msaManager.SetPort(4, valuePortD);
                    }
                    if (msaManager.cn.target == 1)
                    {
                        valuePortD = msaManager.GetPort(4);
                        // valuePortD &= 0xF7;

                        if (!(bool)chk_lpmodeL.IsChecked)
                        {
                            valuePortD &= 0xFDFF;
                        }
                        else
                        {
                            valuePortD |= 0x0200;
                        }
                        msaManager.SetPort(4, valuePortD);
                    }
                }
                else if (BoardID==4162)
                {
                    UInt16 valuePortC = 0;
                    valuePortC = msaManager.GetPort(2);

                  

                        if (!(bool)chk_lpmodeL.IsChecked)
                        {
                            valuePortC &= 0xFFFD;
                        }
                        else
                        {
                            valuePortC |= 0x0002;
                        }
                        msaManager.SetPort(2, valuePortC);
                    

                }
                ResumeMonitor();
            }
            catch (Exception ex)
            {
                ResumeMonitor();
                MessageBox.Show(ex.Message);
            }
        }

        private void s_equ_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            Slider slider = sender as Slider;
            int sliderVal = (int)slider.Value;

            switch (slider.Name)
            {
                case "s_equ0":
                    tb_eq1.Text = sliderVal.ToString();
                    break;

                case "s_equ1":
                    tb_eq2.Text = sliderVal.ToString();
                    break;

                case "s_equ2":
                    tb_eq3.Text = sliderVal.ToString();
                    break;

                case "s_equ3":
                    tb_eq4.Text = sliderVal.ToString();
                    break;

                case "s_equ4":
                    tb_eq5.Text = sliderVal.ToString();
                    break;

                case "s_equ5":
                    tb_eq6.Text = sliderVal.ToString();
                    break;

                case "s_equ6":
                    tb_eq7.Text = sliderVal.ToString();
                    break;

                case "s_equ7":
                    tb_eq8.Text = sliderVal.ToString();
                    break;
                default:
                    break;
            }
        }



        private void s_pre_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            Slider slider = sender as Slider;
            int sliderVal = (int)slider.Value;

            switch (slider.Name)
            {
                case "s_pre0":
                    tb_pre1.Text = sliderVal.ToString();
                    break;

                case "s_pre1":
                    tb_pre2.Text = sliderVal.ToString();
                    break;

                case "s_pre2":
                    tb_pre3.Text = sliderVal.ToString();
                    break;

                case "s_pre3":
                    tb_pre4.Text = sliderVal.ToString();
                    break;

                case "s_pre4":
                    tb_pre5.Text = sliderVal.ToString();
                    break;

                case "s_pre5":
                    tb_pre6.Text = sliderVal.ToString();
                    break;

                case "s_pre6":
                    tb_pre7.Text = sliderVal.ToString();
                    break;

                case "s_pre7":
                    tb_pre8.Text = sliderVal.ToString();
                    break;
                default:
                    break;
            }
        }

        private void s_equ_PreviewMouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            Slider slider = sender as Slider;
            int tempVal = 0;
            int regVal = 0;
            int tempval2 = 0;
            int sliderVal = (int)slider.Value;
            msaManager.I2CWrite(127, 16);
            switch (slider.Name)
            {
                case "s_equ0":
                    regVal = msaManager.ReadAddress(145, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x01;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(145, tempval2);
                    regVal = msaManager.ReadAddress(156, 0);
                    regVal &= 0xF0;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(156, tempVal);
                    break;

                case "s_equ1":
                    regVal = msaManager.ReadAddress(146, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x03;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(146, tempval2);
                    regVal = msaManager.ReadAddress(156, 0);
                    sliderVal = sliderVal << 4;
                    regVal &= 0x0F;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(156, tempVal);
                    break;

                case "s_equ2":
                    regVal = msaManager.ReadAddress(147, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x05;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(147, tempval2);
                    regVal = msaManager.ReadAddress(157, 0);
                    regVal &= 0xF0;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(157, tempVal);
                    break;

                case "s_equ3":
                    regVal = msaManager.ReadAddress(148, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x07;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(148, tempval2);
                    regVal = msaManager.ReadAddress(157, 0);
                    sliderVal = sliderVal << 4;
                    regVal &= 0x0F;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(157, tempVal);
                    break;

                case "s_equ4":
                    regVal = msaManager.ReadAddress(149, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x09;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(149, tempval2);
                    regVal = msaManager.ReadAddress(158, 0);
                    regVal &= 0xF0;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(158, tempVal);
                    break;

                case "s_equ5":
                    regVal = msaManager.ReadAddress(150, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x0B;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(150, tempval2);
                    regVal = msaManager.ReadAddress(158, 0);
                    sliderVal = sliderVal << 4;
                    regVal &= 0x0F;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(158, tempVal);
                    break;

                case "s_equ6":
                    regVal = msaManager.ReadAddress(151, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x0D;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(151, tempval2);
                    regVal = msaManager.ReadAddress(159, 0);
                    regVal &= 0xF0;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(159, tempVal);
                    break;

                case "s_equ7":
                    regVal = msaManager.ReadAddress(152, 0);
                    regVal &= 0xF0;
                    tempval2 = 0x0F;
                    tempVal = regVal | tempval2;
                    msaManager.I2CWrite(152, tempval2);
                    regVal = msaManager.ReadAddress(159, 0);
                    sliderVal = sliderVal << 4;
                    regVal &= 0x0F;
                    tempVal = regVal | sliderVal;
                    msaManager.I2CWrite(159, tempVal);
                    break;
                default:
                    break;
            }
        }



        private void s_pre_PreviewMouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            try
            {
                Slider slider = sender as Slider;
                int tempVal = 0;
                int regVal = 0;
                int tempval2 = 0;
                int sliderVal = (int)slider.Value;
                msaManager.I2CWrite(127, 16);
                switch (slider.Name)
                {
                    case "s_pre0":
                        regVal = msaManager.ReadAddress(145, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x01;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(145, tempval2);
                        regVal = msaManager.ReadAddress(162, 0);
                        regVal &= 0xF0;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(162, tempVal);
                        break;

                    case "s_pre1":
                        regVal = msaManager.ReadAddress(146, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x03;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(146, tempval2);
                        regVal = msaManager.ReadAddress(162, 0);
                        sliderVal = sliderVal << 4;
                        regVal &= 0x0F;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(162, tempVal);
                        break;

                    case "s_pre2":
                        regVal = msaManager.ReadAddress(147, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x05;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(147, tempval2);
                        regVal = msaManager.ReadAddress(163, 0);
                        regVal &= 0xF0;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(163, tempVal);
                        break;

                    case "s_pre3":
                        regVal = msaManager.ReadAddress(148, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x07;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(148, tempval2);
                        regVal = msaManager.ReadAddress(163, 0);
                        sliderVal = sliderVal << 4;
                        regVal &= 0x0F;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(163, tempVal);
                        break;

                    case "s_pre4":
                        regVal = msaManager.ReadAddress(149, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x09;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(149, tempval2);
                        regVal = msaManager.ReadAddress(164, 0);
                        regVal &= 0xF0;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(164, tempVal);
                        break;

                    case "s_pre5":
                        regVal = msaManager.ReadAddress(150, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x0B;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(150, tempval2);
                        regVal = msaManager.ReadAddress(164, 0);
                        sliderVal = sliderVal << 4;
                        regVal &= 0x0F;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(164, tempVal);
                        break;

                    case "s_pre6":
                        regVal = msaManager.ReadAddress(151, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x0D;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(151, tempval2);
                        regVal = msaManager.ReadAddress(165, 0);
                        regVal &= 0xF0;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(165, tempVal);
                        break;

                    case "s_pre7":
                        regVal = msaManager.ReadAddress(152, 0);
                        regVal &= 0xF0;
                        tempval2 = 0x0F;
                        tempVal = regVal | tempval2;
                        msaManager.I2CWrite(152, tempval2);
                        regVal = msaManager.ReadAddress(165, 0);
                        sliderVal = sliderVal << 4;
                        regVal &= 0x0F;
                        tempVal = regVal | sliderVal;
                        msaManager.I2CWrite(165, tempVal);
                        break;
                    default:
                        break;
                }
            }
            catch (Exception)
            {
            }


        }

        private void b_AboutUs_Click(object sender, RoutedEventArgs e)
        {
            AboutBox abt = new AboutBox();
            abt.Show();
        }

        private void b_refreshOptions_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            // msa 0.4
            msaManager.I2CWrite(127, 01);
            //ReadBuff = msaManager.I2CRead(142);
            //string ReadString = ReadBuff[0].ToString("X2");
            //intval = msaManager.StringIntoValue(ReadString);
            //ExtendedEthernet datacode;
            //datacode = (ExtendedEthernet)intval;

            //if ((intval >= 0x09) && (intval <= 0xFF))
            //    lbl_192.Content = ExtendedEthernet.Reserved.ToString();
            //else
            //    lbl_192.Content = datacode.ToString();


            msaManager.ReadAddresses(151, 0, ref ReadBuff);
            FlagAsserted(ref elps_Rxpwrmeas, msaManager.IsBitSet(ReadBuff[0], BITS.BIT4));

            FlagAsserted(ref elps_RxoutAmp, msaManager.IsBitSet(ReadBuff[2], BITS.BIT7));

            FlagAsserted(ref elps_Txsqu, msaManager.IsBitSet(ReadBuff[4], BITS.BIT4));
            FlagAsserted(ref elps_Txfrsqu, msaManager.IsBitSet(ReadBuff[4], BITS.BIT3));
            FlagAsserted(ref elps_squDis, msaManager.IsBitSet(ReadBuff[4], BITS.BIT2));
            FlagAsserted(ref elps_TxDis, msaManager.IsBitSet(ReadBuff[4], BITS.BIT1));
            FlagAsserted(ref elps_TxPol, msaManager.IsBitSet(ReadBuff[4], BITS.BIT0));

            FlagAsserted(ref elps_RxSquDis, msaManager.IsBitSet(ReadBuff[5], BITS.BIT2));
            FlagAsserted(ref elps_RxDis, msaManager.IsBitSet(ReadBuff[5], BITS.BIT1));
            FlagAsserted(ref elps_Rxpol, msaManager.IsBitSet(ReadBuff[5], BITS.BIT0));


            FlagAsserted(ref elps_TxCDRLOL, msaManager.IsBitSet(ReadBuff[6], BITS.BIT2));
            FlagAsserted(ref elps_TxLOS, msaManager.IsBitSet(ReadBuff[6], BITS.BIT1));
            FlagAsserted(ref elps_TxFF, msaManager.IsBitSet(ReadBuff[6], BITS.BIT0));

            FlagAsserted(ref elps_RxCDRLOL, msaManager.IsBitSet(ReadBuff[7], BITS.BIT2));
            FlagAsserted(ref elps_RxLOS, msaManager.IsBitSet(ReadBuff[7], BITS.BIT1));

            //FlagAsserted(ref elps_RxPwrMon, msaManager.IsBitSet(ReadBuff[8], BITS.BIT5));
            //FlagAsserted(ref elps_TxPwrMon, msaManager.IsBitSet(ReadBuff[8], BITS.BIT4));
            //FlagAsserted(ref elps_TxBias, msaManager.IsBitSet(ReadBuff[8], BITS.BIT3));


            //FlagAsserted(ref elps_TxAdp, msaManager.IsBitSet(ReadBuff[8], BITS.BIT2));
            //FlagAsserted(ref elps_TxEqu, msaManager.IsBitSet(ReadBuff[8], BITS.BIT1));
            //FlagAsserted(ref elps_TxCDRB, msaManager.IsBitSet(ReadBuff[8], BITS.BIT0));


            FlagAsserted(ref elps_RxPwrMon, msaManager.IsBitSet(ReadBuff[9], BITS.BIT2));
            FlagAsserted(ref elps_TxPwrMon, msaManager.IsBitSet(ReadBuff[9], BITS.BIT1));
            FlagAsserted(ref elps_TxBias, msaManager.IsBitSet(ReadBuff[9], BITS.BIT0));

            FlagAsserted(ref elps_TxAdp, msaManager.IsBitSet(ReadBuff[10], BITS.BIT3));
            FlagAsserted(ref elps_TxEqu, msaManager.IsBitSet(ReadBuff[10], BITS.BIT2));
            FlagAsserted(ref elps_TxCDRB, msaManager.IsBitSet(ReadBuff[10], BITS.BIT1));
            FlagAsserted(ref elps_TxCDR, msaManager.IsBitSet(ReadBuff[10], BITS.BIT0));


            FlagAsserted(ref elps_Stag, msaManager.IsBitSet(ReadBuff[11], BITS.BIT5));
            FlagAsserted(ref elps_Rxcnt, msaManager.IsBitSet(ReadBuff[11], BITS.BIT2));
            FlagAsserted(ref elps_RxCDRb, msaManager.IsBitSet(ReadBuff[11], BITS.BIT1));
            FlagAsserted(ref elps_RxCDR, msaManager.IsBitSet(ReadBuff[11], BITS.BIT0));


            ResumeMonitor();
        }


        private void rb_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                RadioButton rb = (RadioButton)sender;
                PauseMonitor();
                switch (rb.Name)
                {
                    case "rb1":
                        msaManager.SetPower(0);
                        break;
                    case "rb2":
                        msaManager.SetPower(1);
                        break;
                    case "rb3":
                        msaManager.SetPower(2);
                        break;
                    default:
                        break;
                }
                ResumeMonitor();
            }
            catch (Exception)
            {

            }
        }




        private void b_updateChecksum_Click(object sender, RoutedEventArgs e)
        {
            string ReadString = "";

            try
            {
                PauseMonitor();
                // Page 00
                intval = msaManager.store_CheckSum128_221val();
                intval &= 0x00FF;
                tb_CalculatedCheckSum128_222.Text = intval.ToString("X2");

                msaManager.I2CWrite(127, 00);
                ReadBuff = msaManager.I2CRead(222);
                ReadString = ReadBuff[0].ToString("X2");
                intval = msaManager.StringIntoValue(ReadString);
                tb_StoredCheckSum128_222.Text = intval.ToString("X2");

                //page01
                intval = msaManager.store_CheckSum130_254valPage01();
                intval &= 0x00FF;
                tb_CalculatedCheckSum128_254P1.Text = intval.ToString("X2");

                msaManager.I2CWrite(127, 01);
                ReadBuff = msaManager.I2CRead(255);
                ReadString = ReadBuff[0].ToString("X2");
                intval = msaManager.StringIntoValue(ReadString);
                tb_StoredCheckSum128_254P1.Text = intval.ToString("X2");

                //page02
                intval = msaManager.store_CheckSum128_254valPage02();
                intval &= 0x00FF;
                tb_CalculatedCheckSum128_254P2.Text = intval.ToString("X2");

                msaManager.I2CWrite(127, 02);
                ReadBuff = msaManager.I2CRead(255);
                ReadString = ReadBuff[0].ToString("X2");
                intval = msaManager.StringIntoValue(ReadString);
                tb_StoredCheckSum128_254P2.Text = intval.ToString("X2");
                ResumeMonitor();
            }
            catch (Exception)
            {
                ResumeMonitor();
            }

        }

        private void b_StopMonitoring_Click(object sender, RoutedEventArgs e)
        {
            if (threadIsSleep == false)
            {
                PauseMonitor();
                enableMonitor[msaManager.MSAInstance] = false;
                b_StopMonitoring.Content = "Resume Monitor";
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Insert(0, "Monitor is paused");
            }
            else
            {
                b_StopMonitoring.Content = "Pause Monitor";
                enableMonitor[msaManager.MSAInstance] = true;
                ResumeMonitor();
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Insert(0, "Monitor is running");
            }
        }

        private void chk_sttchn_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.RxTxTempVccCheckBox(31, BITS.BIT0, (bool)chk_sttchn.IsChecked);
            ResumeMonitor();
        }

        private void b_Refresh10h_Click(object sender, RoutedEventArgs e)
        {
            byte[] ReadBuff;
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            PauseMonitor();
            softwarePause = true;

            for (int row = 128; row < 255; row += 32)
            {

                msaManager.I2CWrite(127, 16);

                ReadBuff = new byte[32];
                ReadBuff = msaManager.I2CRead((byte)row);

                for (int i = 0; i < 32; i++)
                {
                    msaTable2.Rows[((row-128) + i)][1] = ReadBuff[i].ToString("X2");
                    msaTable2.Rows[((row - 128) + i)][2] = int.Parse(msaTable2.Rows[((row - 128) + i)][1].ToString(), System.Globalization.NumberStyles.HexNumber);
                    msaTable2.Rows[((row - 128) + i)][3] = Convert.ToChar(int.Parse(msaTable2.Rows[((row - 128) + i)][1].ToString(), System.Globalization.NumberStyles.HexNumber));
                }
            }

            msaGrid2.DataSource = msaTable2.Copy();
            ResumeMonitor();
            softwarePause = false;
        }

        private void b_LoadMSA10h_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.OpenFileDialog ofd = new System.Windows.Forms.OpenFileDialog();
            ofd.Filter = "Comma Separated Values (.csv)|*.csv";
            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.Cancel)
            {
                return;
            }

            sr = new StreamReader(ofd.FileName);
            string[] parts;
            int temp = 0;
            CultureInfo provider;
            provider = CultureInfo.InvariantCulture;
            PauseMonitor();
            softwarePause = true;
            sr.ReadLine();
            sr.ReadLine();
            sr.ReadLine();  //we do not want to load the first 3 lines of the .CSV file, so we read them but do not use them later
            int pointer = 0;
            for (int i = 0; i < 128; i++)
            {
                parts = sr.ReadLine().Split(',');
                msaTable.Rows[pointer][1] = parts[1].Remove(0, 2);
                if (int.TryParse(msaTable2.Rows[pointer][1].ToString(), System.Globalization.NumberStyles.HexNumber, provider, out temp) == false)
                {
                    MessageBox.Show("Invalid File format.", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                    return;
                }
                else
                {
                    msaTable2.Rows[pointer][2] = int.Parse(msaTable2.Rows[pointer][1].ToString(), System.Globalization.NumberStyles.HexNumber);
                }
                msaTable2.Rows[pointer][3] = Convert.ToChar(int.Parse(msaTable2.Rows[pointer][1].ToString(), System.Globalization.NumberStyles.HexNumber));
                pointer++;
            }

            msaGrid2.DataSource = msaTable2.Copy();
            sr.Close();
            ResumeMonitor();
            softwarePause = false;
        }

        private void b_WriteMSAtoHW10h_Click(object sender, RoutedEventArgs e)
        {
            if (!IsConnected)
            {
                lb_DisplayStatus.Items.Clear();
                lb_DisplayStatus.Items.Add("Please Connect to the device");
                return;
            }
            PauseMonitor();
            for (int row = 0; row < 128; row++)
            {
                msaManager.I2CWrite(127, 16);
                msaManager.I2CWrite((byte)(row + 128), byte.Parse(msaTable2.Rows[row][1].ToString(), System.Globalization.NumberStyles.HexNumber));
            }
            ResumeMonitor();
        }

        private void b_SaveMSA10h_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.SaveFileDialog dlgGrid = new System.Windows.Forms.SaveFileDialog();
            dlgGrid.DefaultExt = ".csv";
            dlgGrid.Filter = "Comma Separated Values (.csv)|*.csv";
            dlgGrid.ShowDialog();

            //Create the Memory Grid Save file
            fGrid = new FileStream(dlgGrid.FileName.Replace(".csv", "") + ".csv", FileMode.OpenOrCreate, FileAccess.Write, FileShare.ReadWrite);
            sGrid = new StreamWriter(fGrid, System.Text.Encoding.ASCII);
            sGrid.WriteLine(DateTime.Now);
            sGrid.WriteLine("QSFP passive host: MSA");

            sGrid.WriteLine("Address, Hex, Decimal, ASCII, MSA Description");
            string multiByteStr;
            for (int i = 0; i < 128; i++)
            {

                multiByteStr = msaTable2.Rows[i][0].ToString() + ",0x" + msaTable2.Rows[i][1].ToString() + "," + msaTable2.Rows[i][2].ToString() + "," + msaTable2.Rows[i][3].ToString() + "," + msaTable2.Rows[i][4].ToString();
                sGrid.WriteLine(multiByteStr.Replace('\n', ' ').Replace('\r', ' '));
            }
            sGrid.Flush();
            sGrid.Close();
        }


        private void sld_1_PreviewMouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            Slider sld = sender as Slider;
            PauseMonitor();
            double sliderVal = ((double)sld.Value)*100;

            msaManager.Set_Module_VCC((float)sliderVal);
            // double x = msaManager.Get_VCC();
            //MessageBox.Show(x.ToString());
            ResumeMonitor();
        }

        private void btn_reset_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            msaManager.Set_Noise_Amplitude((byte)0);
            msaManager.Set_VCC_Noise_frequency(0);
            sld_amp.Value = 0;
            ampVal_Copy.Text = "0";
            //pointsNoise.Clear();
            ResumeMonitor();
        }




        private void ampVal1_KeyDown(object sender, KeyEventArgs e)
        {
            try
            {
                if (e.Key == System.Windows.Input.Key.Enter)
                {
                    double userVal = Convert.ToDouble(ampVal1.Text);
                    if (userVal < 3.06 || userVal > 3.566)
                    {
                        MessageBox.Show("Please enter a value between 3 and 3.6 V", "QDD_Host", MessageBoxButton.OK, MessageBoxImage.Information);
                        return;
                    }
                    else
                    {
                        PauseMonitor();
                        sld_1.Value = userVal;
                        msaManager.Set_Module_VCC((float)(userVal*100));
                        ResumeMonitor();
                    }

                }
            }
            catch (Exception)
            {
            }
        }


        private void btn_sVcc_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            sld_1.Value = msaManager.Get_VCC();
            ampVal1.Text = sld_1.Value.ToString();
            ResumeMonitor();

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            PauseMonitor();
            double val = Convert.ToDouble(ampVal.Text);
            Int32 val1 = Convert.ToInt32(ampVal_Copy.Text);
            if (val1 >= 0 && val1 <= 0x00989680)
            {
                msaManager.Set_VCC_Noise_frequency(val1);
                msaManager.Set_Noise_Amplitude((byte)val);

            }
            ResumeMonitor();
        }

        private void module_index_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            PauseMonitor();
            ComboBox cb = sender as ComboBox;
            switch (cb.SelectedIndex)
            {
                case 0:
                    msaManager.SetTarget(0);
                    break;
                case 1:
                    msaManager.SetTarget(1);
                    break;

                default:
                    cb.SelectedIndex = 0;
                    break;
            }

            ResumeMonitor();

        }

        private void btn_IPChanger_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                PauseMonitor();
                con = new IPConfiguration(msaManager.cn.wrapper, ref restart);
                con.ShowDialog();
                restart = con.restart;
                if (restart == true)
                {
                    Environment.Exit(0);
                }
                ResumeMonitor();
            }
            catch (Exception ex)
            {
                msaManager.cn.wrapper.exceptionLog(ex);
            }
        }


    }
}
